package inovaProg;
/** 
 * La clase Ip es la clase principal del paquete inovaProg para programadores
 * que se inician en el uso del lenguaje Java
 * implementa facilidades para leer del teclado y escribir en la pantalla
 * variables de tipo: int, float, double, char y String .
 * Es una clase de biblioteca, todos sus metodos tienen el atributo static, por lo que no requieren instancia
 * Autor: Dr. Manuel Prieto
 * Copyright 2010
 * All Rigths Reserved
 * Todos Los Derechos Reservados
 * Se permite el uso libre de este software bajo la licencia GNU GPL
 * Para una licencia comercial, favor de comunicarse con el autor a:
 * mprieto@inwebinternational.com
 */
//Clases importadas para manejo de ventanas
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
//Clases importadas para manejo de archivos y operaciones de Entrada/Salida
import java.io.*;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
//Clases importadas para manejo de fechas
import java.util.Date;
import java.util.Locale;
import java.text.DateFormat;
import java.text.ParseException;
//Clases importadas para formateo de numeros
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols; 
import java.text.NumberFormat;
//Clases importadas para el manejo de tablas
import javax.swing.table.*;
import javax.swing.event.*;
//Clases importadas para el manejo de dirctorios
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.filefilter.*;

/*Esta clase permite ejecutar las acciones de un menu
 *el arreglo acciones[i][j] contiene las claves que se interpretan
 *por la lgica del mtodo "accion"
 */
class IpEjecuta {
public static boolean accion(String accion) {
    if (accion.toUpperCase().equals("SALIDA"))
              {System.exit(0);
               return true;
              }
    //else if (accion.toUpperCase().equals("XXXX"))
    //      {new Xxxx();
    //       return true;}
    //else if (accion.toUpperCase().equals("YYYY"))
    //      {new Yyyy();
    //       return true;}
    else 
        return false;
    }
}

//Clase Principal
 
public class Ip extends FileFilter {
	 /*
     *Metodos para manipular datos de variables de distintos tipos.
     *Los metodos estan sobrecargados para permitir el uso del nombre de la operacin en forma uniforme
     *Los metodos cuyo nombre inicia con una "w" utilizan como interface una ventana para interactura
     *con el usuario
     */ 
    //Declaracin de variables de toda la clase
    public static boolean error;
    String[] filtros ;
    String[] prefijos ;
    public Ip() {//Constructor Dummy
        
       }
    public Ip(String[] filt) {
    	//Constructor para utilizar post fijos como filtros
        filtros=filt;
        
       }
    public Ip(String[] filt, String [] prefij) {
    	//Constructor para utilizar post fijos y pre fijos como filtros
        filtros=filt;
        prefijos=prefij;
       }
   public static void actUnit(String tabla,
                    String [] nombresCampos,
                    String [] tiposCampos,
                    boolean[] esCampoLlave,
                    String [] tablaExistencia){
    new IpActUnit(tabla,
                  nombresCampos,
                  tiposCampos,
                  esCampoLlave,
                  tablaExistencia);            
     }
   public static void actTab(String tabla,
                    String [] nombresCampos,
                    String [] tiposCampos,
                    boolean[] esCampoLlave,
                    String [] tablaExistencia){
    new IpActTab(tabla,
                  nombresCampos,
                  tiposCampos,
                  esCampoLlave,
                  tablaExistencia);            
     }
    public static void genCodAct(){
    new IpGenCodAct();            
     } 
    public static int cargaArregloLLaves(String tabla,
                    String [] valores,
                    String  directorio){
    int nExi=IpDirectorios.cargaArregloLLaves
				(tabla,
				 valores,
				 directorio);      
    return nExi; 
     }
    public static void selectorDeRegistro(String tabla,
                    String[] llaveSel,
                    String  directorio){
    new IpSelectorDeRegistro(tabla,llaveSel,directorio);   
    }
   public static IpModeloTabla modeloTabla(
                    String [] nombresCampos,
                    Object[][] datos){
    IpModeloTabla mod = new IpModeloTabla(nombresCampos,datos);
    return mod; 
     }
   public static IpEscuchadorTabla escuchadorTabla(){
    IpEscuchadorTabla escuchador = new IpEscuchadorTabla();
    return escuchador; 
     } 
     
    /*
    * Metodos para implementar operaciones de entrada y salida
    * y de manipulcion datos de variables de distintos tipos.
    */
	public static int lee(String letrero, int numero) 
      { //Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        error=true;
        // Imprime el letrero
     	 System.out.print(letrero);
     	while(error)
     	 {error=false;
     	 //Operacion de Lectura con proteccin de excepcion para numero entero
         try {datoleido = br.readLine(); // Se lee la lnea con una llamada
	      }
         catch(java.io.IOException ioex) {
    	   System.out.print("Se produjo un error en la Lectura de Numero Entero, Teclee de Nuevo");
    	   error=true;
        }
        
        try {
        	// Se convierte el string leido a numero entero
        	numero= Integer.valueOf(datoleido).intValue();
        	}
        catch(java.lang.NumberFormatException formatex)
          {
    	   System.out.print("Se produjo un error con el formato del Numero Entero, teclee de nuevo:");
    	   error=true;
          }
        }
        return numero;
        //Termina Metodo lee() 
      }
	public static  void escribe( String letrero,int numero) 
       {
        // Imprime el letrero
     	System.out.print (letrero);
     	System.out.println(" "+numero+" ");
        return ;
        //Termina Metodo EscribeEnLaPantalla{} 
       }
   
       
	public static float lee(String letrero, float numero) 
     {//Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        // Imprime el letrero
     	System.out.print (letrero);
       //Operacion de Lectura con proteccin de excepcion para numero entero
       error=true;
       while(error)
       {
       	error=false;
        try {
        	datoleido = br.readLine(); // Se lee la lnea con una llamada
	        }
        catch(java.io.IOException ioex)
         {
    	   System.out.println("Se produjo un error en la Lectura de Numero Decimal, teclee de nuevo: ");
    	   System.out.println("Letrero:"+letrero);
    	   error=true;
         }
        try 
         { 	// Se convierte el string leido a numero decimal
        	numero= Float.valueOf(datoleido).floatValue();
         }
        catch(java.lang.NumberFormatException formatex)
         { System.out.print("Se produjo un error con el formato del Numero Decimal, teclee de nuevo:");
    	   error=true;
         }
        }
        return numero;
       //Termina Metodo LeeDelTeclado{} 
      }
           
	public static void escribe(String letrero,float numero ) 
     {  // Imprime el letrero
     	System.out.print(letrero);
     	System.out.println(" "+numero+" ");
        return ;
      //Termina Metodo escribe 
      }
    public static double lee(String letrero, double numero) 
     {//Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        // Imprime el letrero
     	System.out.print (letrero);
       //Operacion de Lectura con proteccin de excepcion para numero doble
       error=true;
       while(error)
       {
       	error=false;
        try {
        	datoleido = br.readLine(); // Se lee la lnea con una llamada
	        }
        catch(java.io.IOException ioex)
         {
    	   System.out.println("Se produjo un error en la Lectura de Numero Doble, teclee de nuevo: ");
    	   System.out.println("Letrero:"+letrero);
    	   error=true;
         }
        try 
         { 	// Se convierte el string leido a numero doble
        	numero= Double.valueOf(datoleido).doubleValue();
         }
        catch(java.lang.NumberFormatException formatex)
         { System.out.print("Se produjo un error con el formato del Numero Doble, teclee de nuevo:");
    	   error=true;
         }
        }
        return numero;
       //Termina Metodo lee 
      }
	public static void escribe(String letrero,double numero ) 
     {  
        // Imprime el letrero
     	System.out.print(letrero);
     	System.out.println(" "+numero+" ");
        return ;
      //Termina Metodo escribe 
      }
      
      public static char lee(String letrero, char caracter) 
      { //Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        error=true;
        // Imprime el letrero
     	 System.out.print(letrero);
     	while(error)
     	 {error=false;
     	 //Operacion de Lectura con proteccin de excepcion para numero entero
         try {datoleido = br.readLine(); // Se lee la lnea con una llamada
	      }
         catch(java.io.IOException ioex) {
    	   System.out.print("Se produjo un error en la Lectura del caracter, Teclee de Nuevo");
    	   error=true;
        }
        
        try {
        	// Se convierte el string leido a caracter
        	caracter= datoleido.charAt(0);
        	}
        catch (java.lang.StringIndexOutOfBoundsException indexex)
          {
    	   System.out.print("Se produjo un error con el formato del caracter, teclee de nuevo:");
    	   error=true;
          }
        }
        return caracter;
        //Termina Metodo lee 
      }
      
      public static void escribe(String letrero,char caracter) 
       {
     	//Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        // Imprime el letrero
     	System.out.print (letrero);
     	System.out.println(caracter);
        return ;
        //Termina Metodo escribe 
       }
      
      public static String lee(String letrero, String linea) 
     {
     	//Declara Variables y Objetos a utilizar localmente  
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        System.out.print(letrero);
        //Operacion de Lectura con proteccin de excepcion para numero entero
       try {
       	    datoleido = br.readLine(); // Se lee la lnea con una llamada
           }
       catch(java.io.IOException ioex)
           {
    	   System.out.println("Se produjo un error en la Lectura de String");
    	   }
       linea=datoleido;   
       return linea;
       //Termina Metodo lee 
      }
      public static void escribe(String letrero,String linea) 
       {  // Imprime el letrero
        System.out.print(letrero);
     	System.out.println (linea);
     	return ;
     	//Termina Metodo escribe  
       }
      public static void escribeMensaje(String letrero) 
       {  // Imprime el letrero
        System.out.println(letrero);
     	return ;
     	//Termina Metodo escribeMensaje{}  
       }
       public static void escribeTexto(String texto) 
       {  // Imprime el texto sin retorno de carro
        System.out.print(texto);
     	return ;
     	//Termina Metodo ecribeTexto  
       }
         
       public static double aDoble(String numero ) 
     {//Declara Variables y Objetos a utilizar localmente
      double doble;
       try{doble=Double.valueOf(numero).doubleValue();
           }
       catch(java.lang.NumberFormatException formatex)
       { //decimal = Float.valueOf("0").floatValue();
       escribeMensaje("Al tratar de convertir el string ["+numero+"] a Doble precision "+
          " se ha producido un error, se retorna 0 como valor");
         doble=0.0;
       }
      return doble;  
      //Termina Metodo aDoble{} 
      }
      public static int aEntero(String numero )
      {//Declara Variables y Objetos a utilizar localmente
        int entero;
        try{entero=Integer.valueOf(numero).intValue();
           }
       catch(java.lang.NumberFormatException formatex)
       { //decimal = Float.valueOf("0").floatValue();
         escribeMensaje("Al tratar de convertir ["+numero+"] a entero "+
          " se ha producido un error, se retorna 0 como valor");
         entero=0;
       }  
        return entero;
        //Termina Metodo aEntero{} 
      }
      public static  float aDecimal(String numero ) 
     {//Declara Variables y Objetos a utilizar localmente
       float decimal;
       try{decimal=Float.valueOf(numero).floatValue();
           }
       catch(java.lang.NumberFormatException formatex)
       { //decimal = Float.valueOf("0").floatValue();
       escribeMensaje("Al tratar de convertir el string ["+numero+"] a Decimal "+
          " se ha producido un error, se retorna 0 como valor");
         decimal=0;
       }
       return decimal;
        //Termina Metodo aDecimal() 
        }
            
       public static void leePausa(String letrero) 
      { //Declara Variables y Objetos a utilizar localmente
      if (letrero.equals(""))
        letrero="Oprima <Enter> para continuar ....";
           
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(isr);
        String datoleido = " ";
        error=true;
        // Imprime el letrero
     	 System.out.print(letrero);
     	//Operacion de Lectura con proteccin de excepcion para numero entero
         try {datoleido = br.readLine(); // Se lee la lnea con una llamada
	      }
         catch(java.io.IOException ioex) {  }
        
        try {
        	// Se convierte el string leido a caracter
        	
        	}
        catch (java.lang.StringIndexOutOfBoundsException indexex)
          { }
         return;
        //Termina Metodo LeePausa{} 
      }
      public static int wlee(String letrero,  int numero)  
      { String datoleido = " ";
        do{
        	error=false;
     		 datoleido =JOptionPane.showInputDialog(letrero);
      
        	try {
        		// Se convierte el string leido a numero entero
        		numero= Integer.valueOf(datoleido).intValue();
        		}
        	catch(java.lang.NumberFormatException formatex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura de Numero Entero, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}
        }while(error);
      return numero;
      //Termina Metodo wlee{} 
      }
      public static  void wescribe( String letrero,int numero) 
       {
         JOptionPane.showMessageDialog( null, letrero + numero, 
         "Salida", JOptionPane.PLAIN_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
       public static float wlee(String letrero,  float numero)  
      { String datoleido = " ";
        do{
        	error=false;
     		 datoleido =JOptionPane.showInputDialog(letrero);
      
        	try {
        		// Se convierte el string leido a numero decimal
        			numero= Float.valueOf(datoleido).floatValue();
        		}
        	catch(java.lang.NumberFormatException formatex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura de Numero Decimal, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}
     		catch(java.lang.NullPointerException indexex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura del Numero Decimal, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}

        }while(error);
      return numero;
      //Termina Metodo wlee{} 
      }
      public static  void wescribe( String letrero,float numero) 
       {
         JOptionPane.showMessageDialog( null, letrero + numero, 
         "Salida", JOptionPane.PLAIN_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
     public static double wlee(String letrero,  double numero)  
      { String datoleido = " ";
        do{
        	error=false;
     		 datoleido =JOptionPane.showInputDialog(letrero);
      
        	try {
        		// Se convierte el string leido a numero decimal
        		numero= Double.valueOf(datoleido).doubleValue();
        		}
        	catch(java.lang.NumberFormatException formatex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura de Numero Decimal Doble, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}
          		catch(java.lang.NullPointerException indexex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura del Numero Doble de Precision, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}

        }while(error);
      return numero;
      //Termina Metodo wlee{} 
      }
      public static  void wescribe( String letrero,double numero) 
       {
         JOptionPane.showMessageDialog( null, letrero + numero, 
         "Salida", JOptionPane.PLAIN_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
      public static char wlee(String letrero,  char caracter)  
      { String datoleido = " ";
        do{
        	error=false;
     		 datoleido =JOptionPane.showInputDialog(letrero);
             
        	try {
        		// Se convierte el caracter a string 
        		caracter= datoleido.charAt(0);
        		}
        	catch(java.lang.StringIndexOutOfBoundsException indexex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura del Caracter, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}
      		catch(java.lang.NullPointerException indexex)
          		{
    	    	JOptionPane.showMessageDialog(
        		 null,
        		 "Se produjo un error en la Lectura del Caracter, Teclee de Nuevo",
        		 "",
        		 JOptionPane.ERROR_MESSAGE );
         		error=true;
          		}

        }while(error);
      return caracter;
      //Termina Metodo wlee{} 
      }
   	public static  void wescribe( String letrero,char caracter) 
       {
         JOptionPane.showMessageDialog( null, letrero + caracter, 
         "Salida", JOptionPane.PLAIN_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
  	public static String wlee(String letrero,  String linea)  
      { String datoleido = " ";
       	error=false;
     	datoleido =JOptionPane.showInputDialog(letrero);
     	// Se pasa el dato leido al parametro 
       	linea= datoleido;
      return linea;
      //Termina Metodo wlee{} 
      }
    public static  void wescribe( String letrero,String linea) 
       {
         JOptionPane.showMessageDialog( null, letrero + linea, 
         "Salida", JOptionPane.PLAIN_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
    public static  void wescribeMensaje( String letrero) 
       {
         JOptionPane.showMessageDialog( null, letrero, 
         "Salida", JOptionPane.INFORMATION_MESSAGE );
        return ;
        //Termina Metodo wescribe{} 
       }
    public static  boolean wescribePregunta( String letrero) 
       {
        int  i=JOptionPane.showOptionDialog
             (null,letrero, "Pregunta", 
             JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE,
             null, null, null);
         if (i==0)    
             return true ;
         return false;    
        //Termina Metodo wEscribePregunta{} 
       }
    public static  boolean wleeRespuesta( String letrero) 
       {
        int  i=JOptionPane.showOptionDialog
             (null,letrero, "Pregunta", 
             JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE,
             null, null, null);
         if (i==0)    
             return true ;
         return false;    
        //Termina Metodo wleePregunta{} 
       }
          public static  String formatoDinero(double numero) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoDinero = new DecimalFormat("$###,###,###,##0.00",simbolos);
         return formatoDinero.format(numero);
        //Termina Metodo formatoDinero 
       }
   public static  String formatoNumero(double numero) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoNumero = new DecimalFormat("###########0.00",simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }
   public static  String formatoNumero(double numero, int numDecimales) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
       	 String ftmSt="###########0.";
         if (numDecimales > 0)
            for (int i=0;i<numDecimales ; i++)
            	ftmSt=ftmSt+"0";
         NumberFormat formatoNumero = new DecimalFormat(ftmSt,simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }        
	public static  String formatoDinero(float numero) 
       {
         DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoDinero = new DecimalFormat("$###,###,###,##0.00",simbolos);
         return formatoDinero.format(numero);
        //Termina Metodo formatoDinero 
       }
   public static  String formatoNumero(float numero) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoNumero = new DecimalFormat("###########0.00",simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }
   public static  String formatoNumero(float numero, int numDecimales) 
       {DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(','); 
       	String ftmSt="###########0.";
         if (numDecimales > 0)
            for (int i=0;i<numDecimales ; i++)
            	ftmSt=ftmSt+"0";
         NumberFormat formatoNumero = new DecimalFormat(ftmSt,simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }
   public static  String formatoDinero(int numero) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoDinero = new DecimalFormat("$###,###,###,##0.00",simbolos);
         return formatoDinero.format(numero);
        //Termina Metodo formatoDinero 
       }
   public static  String formatoNumero(int numero) 
       { DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(',');
         NumberFormat formatoNumero = new DecimalFormat("###########0",simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }
   public static  String formatoNumero(int numero, int numDecimales) 
       {DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
         simbolos.setDecimalSeparator('.');
         simbolos.setGroupingSeparator(','); 
       	String ftmSt="###########0.";
         if (numDecimales > 0)
            for (int i=0;i<numDecimales ; i++)
            	ftmSt=ftmSt+"0";
         NumberFormat formatoNumero = new DecimalFormat(ftmSt,simbolos);
         return formatoNumero.format(numero);
        //Termina Metodo formatoNumero{} 
       }               


    /*
    *Terminan los Metodos para implementar operaciones de entrada y salida
    * y de manipulcion datos de variables de distintos tipos.
    */ 
    /*
	*Mostrar arreglos de una y dos dimensiones
	*/
	//Arreglo Unidimensional de cadenas de caracteres   	
	public static void wmuestraArreglo(String A[],int n)	{
	
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String A[])	{
	
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero,String A[])	{
	
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	//Arreglo Unidimensional de Enteros                                                  
	public static void wmuestraArreglo(int A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero,int A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }        
	public static void wmuestraArreglo(int A[], int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
   public static void menuBarras( String titulo,String[] opciones,String[][] subOpciones, String[][]acciones)
   		{
		new IpMenuBarras(titulo,opciones,subOpciones,acciones);
        }
   public static void muestraArreglo(int A[],int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
    public static void muestraArreglo(int A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero, int A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }        
	//Arreglo Unidimensional de Flotantes                
	public static void wmuestraArreglo(float A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, float A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(float A[],int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void muestraArreglo(float A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero, float A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
	public static void muestraArreglo(float A[], int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }         
	//Arreglo Unidimensional de Dobles      	                         
	public static void wmuestraArreglo(double A[],int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(double A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, double A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }                           	                                               
	public static void muestraArreglo(double A[],int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
	public static void muestraArreglo(double A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero, double A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
     
	//Arreglos bidimensionales de cadenas de caracteres                            	                                               
	public static void wmuestraArreglo(String A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, String A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
    public static void muestraArreglo(String A[],int n)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String A[])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero,String A[])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
          {
            mensaje= mensaje + "\n"+ i + " (" + A[i]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }                              
	public static void muestraArreglo(String A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
	public static void muestraArreglo(String A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero,String A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
	//Arreglos bidimensionales de enteros                                                    
	public static void wmuestraArreglo(int A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(int A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, int A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void muestraArreglo(int A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
	public static void muestraArreglo(int A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero, int A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
	//Arreglos bidimensionales de flotantes                                                    
	public static void wmuestraArreglo(float A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(float A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, float A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void muestraArreglo(float A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
	public static void muestraArreglo(float A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
   public static void muestraArreglo(String letrero, float A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
        
	//Arreglos bidimensionales de dobles                                                    
	public static void wmuestraArreglo(double A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(double A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void wmuestraArreglo(String letrero, double A[][])	{
		String mensaje=letrero;
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.wescribeMensaje(mensaje);
        }
	public static void muestraArreglo(double A[][],int n, int m)	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
	public static void muestraArreglo(double A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }
    public static void muestraArreglo(String letrero,double A[][])	{
		String mensaje="Contenido del Arreglo";
		for(int i=0; i<A.length; i++)
			for(int j=0; j<A[i].length; j++)
          {
            mensaje= mensaje + "\ni="+ i + " j="+j + "  (" + A[i][j]+ ")" ;
          }
	    Ip.escribeMensaje(mensaje);
        }    
 	 /*
     *Terminan los metodos para mostrar arreglos
     */ 
      /*
     *Metodos para manipular archivos.
     */ 
      
	public static boolean borraArchivo( String archivo, boolean debug )      
    {   /*Forma de uso
		*if (borra(String archivo),false)
		*   Ip.wescribemensaje"El archivo " + archivo + " fue borrado con xito ");
		*else
		*   Ip.wescribemensaje"El archivo " + archivo + " no pudo ser borrado "; 
		*/
    	//Borra un archivo o un directorio
        File f = new File(archivo); 
         
        if(f.exists()){ 
            if(f.delete()) 
            {if(debug)
                System.out.println("El archivo o directorio ("+archivo +") ha sido borrado con exito)");
             return true; 
            } 
            else
            {if(debug) 
                System.out.println("Se ocasiono un error al borrar el archivo("+archivo+")");
             return false;  
            } 
        }else{
        	if(debug) 
            System.out.println("El archivo o directorio ("+archivo +") no existe ");
            return true;  
        }
    }
    public static boolean borraArchivo( String archivo )      
    {   /*Forma de uso
		*if (borra(String archivo))
		*   Ip.wescribemensaje"El archivo " + archivo + " fue borrado con xito ");
		*else
		*   Ip.wescribemensaje"El archivo " + archivo + " no pudo ser borrado "; 
		*/
    	//Borra un archivo o un directorio
        boolean debug = false;
        File f = new File(archivo); 
         
        if(f.exists()){ 
            if(f.delete()) 
            {if(debug)
                System.out.println("El archivo o directorio ("+archivo +") ha sido borrado con exito)");
             return true; 
            } 
            else
            {if(debug) 
                System.out.println("Se ocasiono un error al borrar el archivo("+archivo+")");
             return false;  
            } 
        }else{
        	if(debug) 
            System.out.println("El archivo o directorio ("+archivo +") no existe ");
            return true;  
        }
    }
	public static boolean existeArchivo( String archivo)      
    {   /*Forma de uso
		*if (existeArchivo(String archivo))
		*   Ip.wescribemensaje"El archivo " + archivo + " fue localizado ");
		*else
		*   Ip.wescribemensaje"El archivo " + archivo + " no existe "; 
		*/
    	File f = new File(archivo); 
         
        if(f.exists()){ 
            return(true); 
        }else{
        	return(false); 
        	 }
    }
	public static String seleccionaDirectorio(File directorioInicial)	{
		/*Forma de uso
		*String fs = Ip.seleccionaArchivo(new File("."));
		*En fs queda el string que contienen el nombre del directorio seleccionado
        */
		String pathSeleccionada;
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle ("Seleccione la carpeta para lectura/escritura");

        //Seleccionar directorios, no archivos
        fc.setFileSelectionMode ( JFileChooser.DIRECTORIES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);

         //Abrir el dialogo, es necesario seleccionar un directorio
        int result = fc.showOpenDialog (frame);

        if (result==0)
  	           {
  	           	pathSeleccionada = fc.getSelectedFile ().getPath();
  	           	pathSeleccionada=pathSeleccionada+"\\";
                return pathSeleccionada;
  	           }
  	     else           	
  	           {pathSeleccionada="";
  	           Ip.wescribeMensaje("No selecciono ningun directorio");
  	           return pathSeleccionada;
  	           }  	
	}
	public static String seleccionaDirectorio(File directorioInicial,String letrero)	{
		/*Forma de uso
		*String fs = Ip.seleccionaArchivo(new File("."),"Selecciona una directorio");
		*En fs queda el string que contienen el nombre del directorio seleccionado
        */
		String pathSeleccionada;
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle (letrero);

        //Seleccionar direcftoprios, no archivos
        fc.setFileSelectionMode ( JFileChooser.DIRECTORIES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);

         //Abrir el dialogo, es necesario seleccionar un directorio
         //Si se selecciona una archivo el programa falla
         int result = fc.showOpenDialog (frame);
		 if (result==0)
  	           {
  	           	pathSeleccionada = fc.getSelectedFile ().getPath();
  	           	pathSeleccionada=pathSeleccionada+"\\";
                return pathSeleccionada;
  	           }
  	     else           	
  	           {pathSeleccionada="";
  	           Ip.wescribeMensaje("No selecciono ningun directorio");
  	           return pathSeleccionada;
  	           }  	
        }
	public static String seleccionaArchivo(File directorioInicial)	{
		/*Forma de uso
		*String fs = Ip.seleccionaArchivo(new File("."));
		*En fs queda el string que contienen el nombre del archivo seleccionado
        */
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle ("Seleccione un archivo");

        //Seleccionar archivos no directorios
        fc.setFileSelectionMode (JFileChooser.FILES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);
        //Seleccionar un solo archivo
        fc.setMultiSelectionEnabled(false);
        //Permitir filtros
        fc.addChoosableFileFilter(fc.getAcceptAllFileFilter());
        //Abrir el dialogo, es necesario seleccionar un directorio
        int  result = fc.showOpenDialog(frame);
	    if (result == JFileChooser.APPROVE_OPTION)
		    {
		       File selectedFile = fc.getSelectedFile();
		       return selectedFile.getAbsolutePath();
		}
	    else{
		     Ip.wescribeMensaje("No selecciono ningun archivo");
		     return "";
		    }
    
	}
	public static String seleccionaArchivo(File directorioInicial, String letrero)	{
		/*Forma de uso
		*String fs = Ip.seleccionaArchivo(new File("."),"Selecciona un archivo de entrada");
		*En fs queda el string que contienen el nombre del archivo seleccionado
        */
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle (letrero);

        //Seleccionar archivos solamente, no directorios
        fc.setFileSelectionMode (JFileChooser.FILES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);
        //Seleccionar un solo archivo
        fc.setMultiSelectionEnabled(false);
        //Permitir filtros
        fc.addChoosableFileFilter(fc.getAcceptAllFileFilter());
         //Abrir el dialogo, es necesario seleccionar un directorio
        int  result = fc.showOpenDialog(frame);
	     if (result == JFileChooser.APPROVE_OPTION)
		    {
		       File selectedFile = fc.getSelectedFile();
		       return selectedFile.getAbsolutePath();
		}
	    else{
		     Ip.wescribeMensaje("No selecciono ningun archivo");
		     return "";
		    }
	}
	public static String seleccionaArchivo(File directorioInicial, String letrero, String filtro)	{
		/*Forma de uso
		*String fs = Ip.seleccionaArchivo(new File("."),"Selecciona un archivo de entrada","doc");
		*En fs queda el string que contienen el nombre del archivo seleccionado
		*Pre seleccionar archivos con terminacin .doc
        */
        //Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle (letrero);

        //Seleccionar archivos no directorios
        fc.setFileSelectionMode (JFileChooser.FILES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);
        //Seleccionar un solo archivo
        fc.setMultiSelectionEnabled(false);
        //Permitir filtros
        //fc.addChoosableFileFilter(fc.getAcceptAllFileFilter());
        String[] fi = new String[1];
        fi[0]=filtro;
        fc.addChoosableFileFilter(new Ip(fi));

         //Abrir el dialogo, es necesario seleccionar un archivo
         int  result = fc.showOpenDialog(frame);
	     if (result == JFileChooser.APPROVE_OPTION)
		    {
		       File selectedFile = fc.getSelectedFile();
		       return selectedFile.getAbsolutePath();
		}
	    else{
		     Ip.wescribeMensaje("No selecciono ningun archivo");
		     return "";
		    }
    
	}
	public static String seleccionaArchivo(File directorioInicial, String letrero, String[] filtro)	{
		/*Forma de uso
		 *String[] fi = new String[3];
		 *fi[0]="txt";
		 *fi[1]="doc";
		 *fi[2]="c";
		 *String fs = Ip.seleccionaArchivo(new File("."),"Selecciona un archivo de entrada",fi);
		 *En fs queda el string que contienen el nombre del archivo seleccionado
		 *Pre seleccionar archivos con terminacin .doc, .txt y .c
		 */
        
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle (letrero);
        //Seleccionar archivos no directorios
        fc.setFileSelectionMode (JFileChooser.FILES_ONLY);
        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);
        //Seleccionar un solo archivo
        fc.setMultiSelectionEnabled(false);
        //Permitir filtros
        fc.addChoosableFileFilter(new Ip(filtro));
         //Abrir el dialogo, es necesario seleccionar un archivo
         int  result = fc.showOpenDialog(frame);
	     if (result == JFileChooser.APPROVE_OPTION)
		    {
		       File selectedFile = fc.getSelectedFile();
		       return selectedFile.getAbsolutePath();
		}
	    else{
		     Ip.wescribeMensaje("No selecciono ningun archivo");
		     return "";
		    }
	}
	public static String seleccionaArchivo(File directorioInicial, String letrero, String[] filtro, String[] prefijo)	{
		/*Forma de uso
		*String[] fi = new String[3];
		*String[] pre = new String[2];
        *fi[0]="txt";
        *fi[1]="doc";
        *fi[2]="c";
        *pre[0]="P";
        *pre[1]="T";
        *String fs = Ip.seleccionaArchivo(new File("."),"Selecciona un archivo de entrada",fi,pre);
        *En fs queda el string que contienen el nombre del archivo seleccionado
        *Pre seleccionar archivos con terminacin .doc, .txt y .c y cuyos nombres inicien con las letras
        * "P" y "T"
        */
		//Genera archivo con nombres
		JFrame frame = new JFrame();
	    JFileChooser fc = new JFileChooser ();
        fc.setDialogTitle (letrero);

        //Seleccionar directorios, no archivos
        fc.setFileSelectionMode (JFileChooser.FILES_ONLY);

        //Iniciar en el directorio actual
        fc.setCurrentDirectory (directorioInicial);
        //Seleccionar un solo archivo
        fc.setMultiSelectionEnabled(false);
        //Permitir filtros
        //fc.addChoosableFileFilter(fc.getAcceptAllFileFilter());
        fc.addChoosableFileFilter(new Ip(filtro,prefijo));

         //Abrir el dialogo, es necesario seleccionar un archivo
         int  result = fc.showOpenDialog(frame);
	     if (result == JFileChooser.APPROVE_OPTION)
		    {
		       File selectedFile = fc.getSelectedFile();
		       return selectedFile.getAbsolutePath();
		}
	    else{
		     Ip.wescribeMensaje("No selecciono ningun archivo");
		     return "";
		    }
    
	}
	public static void ejecutaConsola(String archivo) {
		try
			{ 
			  Process p = Runtime.getRuntime().exec("cmd.exe /K start cmd.exe /K "+ archivo);
			 }
			 catch (Exception e)
             { 
             Ip.wescribeMensaje("Error al ejecutar ");
             }
	}           
   public static void ejecutaArchivo(String archivo) {
    	try 
			{ Process p = Runtime.getRuntime().exec("cmd.exe /c " + archivo);
		      InputStream is = p.getInputStream(); 
              BufferedReader br = new BufferedReader (new InputStreamReader(is));
              String auxiliar;
              Ip.escribeMensaje("Resultado de la ejecucin del archivo ("+ archivo + ")");
              while ((auxiliar=br.readLine())!=null)
                     Ip.escribeMensaje(auxiliar); 
                     }
              catch (Exception e) 
                { 
                  Ip.wescribeMensaje("Error al Abrir el ejecutar");
                } 
    } 
           
     /* 
	 * Los siguientes metodos implementan facilidades para leer y escribir
	 * en archivos de texto.
	 * Todas estas variables tienen la propiedad static, por lo que solo se puede tener un archivo
	 * abierto en un momento, si algun programa requiere tener mas de un archivo abierto puede utilizar la 
	 * clase IpArchs
	 */    
    //Declaracion de Variables para Manipular Archivos
    public static int 				numero ;
    public static String 			nombre_archivo;
    public static BufferedWriter 	bw;
    public static FileWriter 		fw;
    public static FileReader 		fr;
	public static BufferedReader 	archivo_entrada;
    public static PrintWriter       archivo_salida;
    
    public static boolean abreArchSalidaNuevo(String nombre_archivo) 
	    	{  
		    	try		{
		    		fw = new FileWriter(nombre_archivo);
					bw = new BufferedWriter(fw);
					archivo_salida = new PrintWriter(bw);
				    	}
				catch(java.io.IOException iovariable) 
					{
					System.out.println("Error al Abrir archivo de salida: " + iovariable);
					};
				return true;
			} //Termina AbreArchivoSalidaNuevo()
		public static boolean abreArchSalidaYaExistente(String nombre_archivo) 
    		{   
		    	try		{
		    		fw = new FileWriter(nombre_archivo, true);
					bw = new BufferedWriter(fw);
					archivo_salida = new PrintWriter(bw);
				        }
				catch(java.io.IOException iovariable) 
					{
					System.out.println("Error al Abrir archivo de salida: " + iovariable);
					};
				return true;
			}	
       //Termina Metodo AbreArchSalidaNuevoYaExistente 
        public static boolean escribeEnArch(String linea)
	        { 
		    	archivo_salida.println(linea);
		        return true;
			}
		public static boolean escribeEnArch(double linea)
		    {   
		    	archivo_salida.println(linea);
				return true;
			}
		public static boolean escribeEnArch(float linea)
		   { 
		  	archivo_salida.println(linea);
		  	return true;
		   }
	public static boolean escribeEnArch(int linea)
	       { 
	       	archivo_salida.println(linea);
		  	return true;
		   }
	public static boolean escribeEnArch(long linea)
	       { 
	       	archivo_salida.println(linea);
		  	return true;
		   }	   
	public static boolean escribeEnArch(char linea)
		    {   
		    archivo_salida.println(linea);
			return true;
			}		
  	//Termina Metodo escribeEnArch{}
        public static boolean cierraArchSalida()
	       	{   
	    	archivo_salida.close();
	   	    return true;
			}	
   	//Termina Metodo cierraArchSalida()
        public static boolean abreArchEntrada(String nombre_archivo) 
		    {  
		    	try		{
		    		fr = new FileReader(nombre_archivo);
					archivo_entrada = new BufferedReader(fr);
					
					}
				catch(java.io.FileNotFoundException fnfex) {
					System.out.println("Archivo de Entrada no encontrado: " + fnfex);
					return false;}
				catch(java.io.IOException ioex) {
					System.out.println("Error en el archivo de Entrada: " + ioex);
					return false;}
				return true;
				} 
		//Termina Metodo AbreArchEntrada
		
		public static String leeDeArch()
		    { //Declara Variables y Objetos a utilizar localmente  
		    	String linea;
		    	linea="";
		    	try {
		    			if ((linea = archivo_entrada.readLine()) != null)
		    				return linea;
		    			else
		    	    		return "";	
					}
				catch(java.io.FileNotFoundException fnfex) {
					System.out.println("Archivo no encontrado: " + fnfex);}
				catch(java.io.IOException ioex) {
					System.out.println("Error en el archivo de Entrada: " + ioex);}		 
		            return linea;
		    }
		  //Termina Metodo leeDeArch()  
         public static boolean cierraArchEntrada()
		     { //Declara Variables y Objetos a utilizar localmente  
		    	try {archivo_entrada.close();}
		    		catch(java.io.FileNotFoundException fnfex)
		    			{
						System.out.println("Archivo no encontrado: " + fnfex);
						return false;
						}
					catch(java.io.IOException ioex)
						{
						System.out.println("Error en el archivo de Entrada: " + ioex);
						return false;
						}
				return true;
			}
		  //Termina Metodo CierraArchEntrada()
   /*Metodos para cargar combos de archivos y de tablas
    */
    public static void cargaCombo(JComboBox Combo, String tabla) {
    String[] valores= new String[1000] ;
        int n=IpDirectorios.cargaArregloLLaves(tabla,valores);
        for(int i=0;i<n;i++)
	 		{
	 			Combo.addItem(valores[i]);
	 		}	
    }
    public static void tablasEjecuta(JComboBox Combo, String tabla) {
    String[] valores= new String[1000] ;
        int n=IpDirectorios.cargaArregloLLavesJava(tabla,valores);
        for(int i=0;i<n;i++)
	 		{
	 			Combo.addItem(valores[i]);
	 		}
    }	
	
   /*Metodos para filtrar archivos, debido a estos metodos es necesario que la clase
    *Ip sea una subclase de FileFilter
    */
    // Acepta todos los archivos que cumplan con cualquier filtro
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String s = f.getName();
        int i = s.lastIndexOf('.');
        boolean hayExtension=false;
        String nom="";
        if (i > 0 &&  i < s.length() - 1) {
            String extension = s.substring(i+1).toLowerCase();
            nom=s.substring(0,i).toLowerCase();
            for (int j=0;j<filtros.length;j++)
              { 
            	if(filtros[j].equals(extension)|| filtros[j].trim().equals("*"))
            	  {
               	   hayExtension= true;
               	   break;
                  }
              }   
           }
        
        if (!hayExtension)
        	 return false;
        //Checar si no se requieren prefijos
        if (prefijos==null)
        	 return true;
        if (prefijos.length<1)
        	 return true;	 
        //Revisar que se cumpla con los prefijos
        int l= nom.length();
        for (int j=0;j<prefijos.length;j++)
              { if(prefijos[j].trim().equals("*")) 
              	    return true;
              	if(prefijos[j].length() > nom.length()) 
              	    return false;    
              	if(prefijos[j].trim().toLowerCase().equals(nom.substring(0,prefijos[j].length()))   )
            	  {
               	   return true;
               	  }
              }   
        return false;
    }
     // Descripcion
    public String getDescription() {
        return "fc.addChoosableFileFilter(new FiltroArchivos(String[] filtro));";
    }
    /*
     *Metodos de validacion de datos
     */
   	public static float validarDato(float numero,String datoleido,
                             String[] mensaje, boolean[] existeError)
 		/*Validar numero flotante
 		 *Forma de uso
		 *boolean[] existeError = new boolean[]{false};
		 *String[] mensaje  = new String[]{""}; 
		 *float datoValidado=0;
		 *String datoleido = .... //contiene el dato que se va a validar
		 *invocacion
		 *datoValidado = validarDato(datoValidado,datoleido,mensaje,existeError);	
		 *if (existeError[0])
		 *	{
		 *    //procesa error el mensaje de error se encuentra en mensaje[0] 
		 *	}
		 */
 	 {    
 		numero = 0;
 		try 
    	     { 	// Se convierte el string leido a numero decimal
        	    //Si hay error se ejecuta el catch, si no hay error termina
        		numero= Float.valueOf(datoleido).floatValue();
        		existeError[0]=false;
        		mensaje[0]="";
           	}
        catch(java.lang.NumberFormatException formatex)
         {  //Aqui entra el control solo si hay un error en la conversion a numero flotante
         	mensaje[0]=" Se produjo un error con el formato del Numero Decimal, teclee de nuevo";
         	existeError[0]=true;
         }
      	return numero;    
    }//Termina Validacion de un numero con punto decimal
public static int validarDato(int numero,String datoleido,
                             String[] mensaje, boolean[] existeError)
 	 /*Validar un numero entero
 	 *Forma de uso
	 *boolean[] existeError = new boolean[]{false};
	 *String[] mensaje      = new String[]{""}; 
	 *int datoValidado=0;
	 *String datoleido = .... //contiene el dato que se va a validar
	 *invocacion
	 *datoValidado = validarDato(datoValidado,datoleido,mensaje,existeError);	
	 *if (existeError[0])
	 *	{
	 *    //procesa error el mensaje de error se encuentra en mensaje[0] 
	 *	}
	 */
 	  {    
 		numero = 0;
 		try 
    	     { 	// Se convierte el string leido a numero entero
        	    //Si hay error se ejecuta el catch, si no hay error termina
        		numero= Integer.valueOf(datoleido).intValue();
        		existeError[0]=false;
        		mensaje[0]="";
           	}
        catch(java.lang.NumberFormatException formatex)
         {  //Aqui entra el control solo si hay un error en la conversion a numero flotante
         	mensaje[0]=" Se produjo un error con el formato del Numero Entero, teclee de nuevo";
         	existeError[0]=true;
         }
      	return numero;    
    }//Termina Validacion de un numero entero
public static String validarDato(String dato,String datoleido,
                             String[] mensaje, boolean[] existeError)
 	  	/*Validar un String para que no este vacio
 		 *Forma de uso
		 *boolean[] existeError = new boolean[]{false};
		 *String[] mensaje  = new String[]{""}; 
		 *String datoValidado="";
		 *String datoleido = .... //contiene el dato que se va a validar
		 *invocacion
		 *datoValidado = validarDato(datoValidado,datoleido,mensaje,existeError);	
		 *if (existeError[0])
		 *	{
		 *    //procesa error el mensaje de error se encuentra en mensaje[0] 
		 *	}
		 */
 	 {    
 		
 			
 		mensaje[0]=" ";	
 		if (datoleido==null)
		 	{
		 	mensaje[0]=" El campo es obligatorio, debe llenarse el dato";
         	existeError[0]=true;
         	}
 		dato = datoleido;
 		if ((dato.trim().equals("")) || (dato.trim()== null) )
		 	{
		 	mensaje[0]=" El campo es obligatorio, debe llenarse el dato";
         	existeError[0]=true;
         	}
		else
			{existeError[0]=false;
        	 mensaje[0]=" ";
        	 } 
 		return dato;    
    }//Termina Validacion de un String obligatorio
	public static Date validarDato(Date fecha, String datoleido,
                             String[] mensaje, boolean[] existeError)
 	  	 /*Validar una fecha
 		 *Forma de uso
		 *boolean[] existeError = new boolean[]{false};
		 *String[] mensaje      = new String[]{""}; 
		 *Date datoValidado     = new Date();
		 *String datoleido      = .... //contiene el dato que se va a validar
		 *invocacion
		 *datoValidado = validarDato(datoValidado,datoleido,mensaje,existeError);	
		 *if (existeError[0])
		 *	{
		 *    //procesa error el mensaje de error se encuentra en mensaje[0] 
		 *	}
		 */
 	 {  datoleido=datoleido.trim();  
 		if (datoleido==null)
 		 {
		 	mensaje[0]=" El campo es obligatorio, debe llenarse el dato";
         	existeError[0]=true;
         	return fecha;  
         }
      //if(datoleido.indexOf("0") == 0)
      // 	  datoleido = datoleido.substring(1);
     
 	  //DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT); // DD/MM/AA
 	  //Este es el formato en que se espera que se envie el dato a validar
 	  DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM,Locale.GERMAN); // DD/MM/AAAA
 	  String fe="";
 	  String separador = "";
 	  fe = df.format(new Date());
 	  //Ip.wescribeMensaje("long ("+fe.length()+")");
 	  separador=fe.substring(fe.length() - 5,fe.length() - 4);
 	  //Ip.wescribeMensaje("separador usado por la instalacion ("+separador+")");
 	  //Cambiar  diagonales por .
      String tf = "";
      for (int i=0; i<datoleido.length(); i++)
      {if (datoleido.substring(i,i+1).equals("/"))
      	  		tf +=".";
      	  else
      	  	   	tf +=datoleido.substring(i,i+1);
      //Ip.wescribeMensaje("i="+i+ " datoleido= ("+tf+")");
      }
      datoleido = tf;
      //Ip.wescribeMensaje("datoleido con nuevos separadores ("+datoleido+")");	 
       try
       	{
        fecha = df.parse(datoleido.trim());
         mensaje[0]=" ";
         existeError[0]=false;
         }
      
      catch(ParseException e) {
         mensaje[0]=" Error en el formato de la fecha (dd/mm/aaaa)" +
          "\n Error enviado ("+ e.getMessage()+")" +
          "\nFecha de hoy formateada en el formato default ("+ fe+")" ;
           existeError[0]=true;
         }
     // Date fechaActual = new Date();
     // DateFormat dfDefault =  DateFormat.getDateInstance();
     // DateFormat df1Short  = DateFormat.getDateInstance(DateFormat.SHORT);
     // DateFormat df2Medium = DateFormat.getDateInstance(DateFormat.MEDIUM);
     // DateFormat df3Long   = DateFormat.getDateInstance(DateFormat.LONG);
     // DateFormat df4Full   = DateFormat.getDateInstance(DateFormat.FULL); 
     // String ss  = dfDefault.format(fechaActual);
     // String ss1 = df1Short.format(fechaActual);
     // String ss2 = df2Medium.format(fechaActual);
     // String ss3 = df3Long.format(fechaActual);
     // String ss4 = df4Full.format(fechaActual);

     // System.out.println("(Default) Fecha x " + ss);
     // System.out.println("(SHORT)   Fecha x " + ss1);
     // System.out.println("(MEDIUM)  Fecha x " + ss2);
     // System.out.println("(LONG)    Fecha x " + ss3);
     // System.out.println("(FULL)    Fecha " + ss4);
     
     
     
      if (!df.format(fecha).equals(datoleido.trim())) 
   		{
     		mensaje[0]=" Error en el formato se usa (DD/MM/AAAA)" +
            " ("+ fe+")" ;
           	//mensaje[0]+=" Error en el formato de la fecha (valores de los datos dd/mm/aaaa)  ";
         	existeError[0]=true;
   		}
      if (fecha == null) 
      	{
         mensaje[0]=" Error formato invalido se usa (DD/MM/AAAA) " +
           " ("+ fe+")" ;
         existeError[0]=true;
        }	
      return fecha;
     
    }//Termina Validacion de la fecha
    /*
     *Metodos para manipular fechas
     */
 public static String wleeFecha(String letrero, String stFecha) 
     { String datoleido = "";
       do{
       		error=false;
      		datoleido =JOptionPane.showInputDialog(letrero);
     		try {
        		// Se revisa que no este vacio
        		String temp = datoleido.substring(0);
        		}
        	catch(java.lang.NullPointerException indexex)
          		{
	    	    	JOptionPane.showMessageDialog(
	        			null,
	        		 	"Se produjo un error en la lectura de la fecha, el formato es DD/MM/AAAA, teclee de nuevo: ",
	        		 	"",
	        		 	JOptionPane.ERROR_MESSAGE );
	         		error=true;
          		}
				boolean[] existeError = new boolean[]{false};
		 		String[] mensaje      = new String[]{""}; 
		 		Date datoValidado     = new Date();
		 		datoValidado = validarDato(datoValidado,datoleido,mensaje,existeError);	
		 		if (existeError[0])
		 			{
		     		  JOptionPane.showMessageDialog(
	        			null,
	        		 	mensaje[0],
	        		 	"",
	        		 	JOptionPane.ERROR_MESSAGE );
    	     		  error=true; 
		 			}
            }while(error);
      return datoleido.trim();
       //Termina wleeFecha 
      }
 public static void wleeDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos,
	                 String[] tablaExistencia,
	                 int      numCampos)
     { 	new IpwleeDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos,
	                  tablaExistencia,
	                  numCampos);
       //Termina wleeDatos 
      }
   public static void wleeDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos,
	                 String[] tablaExistencia)
     { 	new IpwleeDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos,
	                  tablaExistencia);
       //Termina wleeDatos 
      }   
   public static void wleeDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos,
	                 int      numCampos)
     { 	new IpwleeDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos,
	                  numCampos);
       //Termina wleeDatos 
      }
  public static void wleeDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos)
     { 	new IpwleeDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos);
	   //Termina wleeCampos 
      }
public static void wleeDatos(
	                 String[] etiquetas,
	                 String[] valoresCampos)
     { 	new IpwleeDatos(etiquetas,
	                  valoresCampos);              
	   //Termina wleeDatos 
      }
public static void wleeDatos(String[] valoresCampos)
     { 	new IpwleeDatos(valoresCampos);              
	   //Termina wleeDatos 
      }
 public static void wmuestraDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos,
	                 int      numCampos)
     { 	new IpwmuestraDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos,
	                  numCampos);
       //Termina wmuestraDatos 
      }
  public static void wmuestraDatos(String   titulo,
	                 String[] etiquetas,
	                 String[] valoresCampos,
	                 String[] tiposCampos)
     { 	new IpwmuestraDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos);
	   //Termina wmuestraCampos 
      }
public static void wmuestraDatos(
	                 String[] etiquetas,
	                 String[] valoresCampos)
     { 	new IpwmuestraDatos(etiquetas,
	                  valoresCampos);              
	   //Termina wmuestraDatos 
      }
public static void wmuestraDatos(String[] valoresCampos)
     { 	new IpwmuestraDatos(valoresCampos);              
	   //Termina wmuestraDatos 
      }
 public static String convFechaACadena(Date f) {
   	  //DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT); // DD/MM/AA
 	  //Este es el formato en que se espera que se envie el dato a validar
 	  DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM,Locale.GERMAN);; // DD/MM/AAAA
      String s =  df.format(f);
      return puntosADiagonales(s);
   }
  public static String puntosADiagonales(String s) {
   	  //Quita los puntos y pone diagonales
 	  String tf = "";
      for (int i=0; i<s.length(); i++)
      {if (s.substring(i,i+1).equals("."))
      	  		tf +="/";
      	  else
      	  	   	tf +=s.substring(i,i+1);
      //Ip.wescribeMensaje("i="+i+ " datoleido= ("+tf+")");
      }
      s = tf;
      return s;
   }
  public static String diagonalesAPuntos(String s) {
   	  //Quita las diagonales  y pone puntos
 	  String tf = "";
      for (int i=0; i<s.length(); i++)
      {if (s.substring(i,i+1).equals("/"))
      	  		tf +=".";
      	  else
      	  	   	tf +=s.substring(i,i+1);
      //Ip.wescribeMensaje("i="+i+ " datoleido= ("+tf+")");
      }
      s = tf;
      return s;
   }      
 public static Date convCadenaAFecha(String s) {
      Date d = new Date();
      if(s.indexOf("0") == 0)
       	  s = s.substring(1);
      s=diagonalesAPuntos(s); 	  
      //DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT); // DD/MM/AA
 	  //Este es el formato en que se espera que se envie el dato a validar
 	  DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM,Locale.GERMAN); // DD/MM/AAAA
      try {
         d = df.parse(s);
      }
      catch(Exception e) {
      //	catch(ParseException e) {
         System.out.println("Error al convertir (" + s + ") a Fecha ");
      }
       return d;
   }
   public static Date aumentaDias(int dias,Date inicio){
	//Aumenta los dias a la fecha dada como inicio, dando una nueva fecha en tipo Date
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long diasLong = dias;
	long diasAIncrementar = dia * diasLong;
	long fechaInicio = inicio.getTime();
	long fechaFinal = fechaInicio + diasAIncrementar;
	Date fin = new Date(fechaFinal);
return fin;
}
public static Date disminuyeDias(int dias,Date inicio){
	//Disminuye los dias a la fecha dada como inicio, dando una nueva fecha en tipo Date
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long diasLong = dias;
	long diasADisminuir = dia * diasLong;
	long fechaInicio = inicio.getTime();
	long fechaFinal = fechaInicio - diasADisminuir;
	if (fechaFinal < 0)
		{ System.out.println("Error al disminuir la fecha");
		  fechaFinal=0;	}
	Date fin = new Date(fechaFinal);
return fin;
}
public static int diferenciaFechas(Date fechaInicial, Date fechaFinal){
	//Encuentra la diferencia en dias de la fecha final a a la fecha inicial
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long lfechaInicial = fechaInicial.getTime();
	long lfechaFinal = fechaFinal.getTime();
	long  diferenciaDias = lfechaFinal - lfechaInicial;
	diferenciaDias= diferenciaDias / dia;	 
return (int)diferenciaDias;
}

public static int diferenciaFechas(String sfechaInicial, String sfechaFinal){
	Date fechaInicial = Ip.convCadenaAFecha(sfechaInicial);
	Date fechaFinal = Ip.convCadenaAFecha(sfechaFinal);
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long lfechaInicial = fechaInicial.getTime();
	long lfechaFinal = fechaFinal.getTime();
	long  diferenciaDias = lfechaFinal - lfechaInicial;
	if (diferenciaDias < 0)
		diferenciaDias = - diferenciaDias;
	diferenciaDias= diferenciaDias / dia;	 
return (int)diferenciaDias;
}
public static String aumentaDias(int dias,String stInicio){
	//Aumenta los dias a la fecha dada como inicio, dando una nueva fecha en tipo String
	Date inicio;
    inicio = Ip.convCadenaAFecha(stInicio);
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long diasLong = dias;
	long diasAIncrementar = dia * diasLong;
	long fechaInicio = inicio.getTime();
	long fechaFinal = fechaInicio + diasAIncrementar;
	Date fin = new Date(fechaFinal);
return Ip.convFechaACadena(fin);
}
public static String disminuyeDias(int dias,String stInicio){
	//Disminuye los dias a la fecha dada como inicio, dando una nueva fecha en tipo String
	Date inicio;
    inicio = Ip.convCadenaAFecha(stInicio);
	long minuto = 60 * 1000;
	long hora = minuto * 60;
	long dia = hora * 24;
	long diasLong = dias;
	long diasADisminuir = dia * diasLong;
	long fechaInicio = inicio.getTime();
	long fechaFinal = fechaInicio - diasADisminuir;
	if (fechaFinal < 0)
		{ System.out.println("Error al disminuir la fecha");
		  fechaFinal=0;	}
	Date fin = new Date(fechaFinal);
return Ip.convFechaACadena(fin);
}	  		           
  	//Termina Clase Ip 
 }
 
 
 
 
 
/***************************************************************
*                     IpwleeDatos    	                        
*Permite capturar y mostrar un grupo de campos validandolos    
*por configuracion                                  
****************************************************************/
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import java.util.Date;
class IpwleeDatos extends JDialog{
	private JTextPane jTextPane1;
	private JScrollPane jScrollPane1;
	private JButton Aceptar;
	private JButton Limpiar;
	private JButton Restaurar;
	private JButton Cancelar;
	private JPanel contentPane;
	private int limiteNumCampos=100;
	private String[] valoresCampos;
	private String[] etiquetas;
	//"S" - string, "F" - float, "I" - int, "D" - fecha
	private String[] tipos;
	private String[] tablaExistencia;
	private String[] valoresExi= new String[1000] ;
	int nExi;
	private String titulo=" ";
	private int numeroCampos=0;
	private JTextField ArrJTextField[]= new JTextField[limiteNumCampos];
	private JLabel ArrJLabel[]= new JLabel[limiteNumCampos];
	//Manejo del error
	private JLabel mensajeError = new JLabel();
	private boolean  existeError[]= new boolean[100];
	private int numBotones      =4;
	private JButton[]    botones        =  new JButton[numBotones];
	private int[]        xBotones        =  new int[numBotones];
	private int[]        yBotones        =  new int[numBotones];
	private int[]        anchoBotones    =  new int[numBotones];
	private int[]        xEtiquetas      =  new int[limiteNumCampos];
	private int[]        yEtiquetas      =  new int[limiteNumCampos];
	private int[]        xCajasTexto     =  new int[limiteNumCampos];
	private int[]        yCajasTexto     =  new int[limiteNumCampos];
	//Variables para formatear la ventana
	int	anchoEtiqueta = 70;
	int	altoEtiqueta  = 18;
	int	altoCajaTexto  = 22;
	int	anchoCajaTexto = 100;
	int	anchoDelBoton  =83;
	int	altoDelBoton   =28;
	int	anchoPanel     =0;
	int	largoPanel     =0;
	int	xMensajeError  =0;
	int	yMensajeError  =0;
	int incrementoY=25;         
	
	public IpwleeDatos(String encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada,
	                 String[] tablaExist,
	                 int      numCampos)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  =  numCampos;
		tipos = tiposEntrada;
		tablaExistencia= tablaExist;
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
		public IpwleeDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada,
	                 String[] tablaExist)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		tipos = tiposEntrada;
		tablaExistencia= tablaExist;
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	public IpwleeDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada,
	                 int      numCampos)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = numCampos;
		tablaExistencia = new String[numeroCampos];
			for (int i= 0; i< numCampos; i ++)
		        {
		         tablaExistencia[i]="";
		        }
		          
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	      
	public IpwleeDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 int      numCampos)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  =  numCampos;
		tipos = new String[numeroCampos];
		tablaExistencia = new String[numeroCampos];
	    for (int i= 0; i< numCampos; i ++)
		      {
		         tablaExistencia[i]="";
		         tipos[i]="S"; 
		        }
		      
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
    public IpwleeDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = valoresEntrada.length;
		tablaExistencia = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      {
		         tablaExistencia[i]="";
		      }
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}	
	
	
	
	public IpwleeDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		tipos = new String[numeroCampos];
		tablaExistencia = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      {
		         tablaExistencia[i]="";
		         tipos[i]="S"; 
		        }  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
	public IpwleeDatos(String[] etiquetasEntrada,
	                 String[] valoresEntrada)
	{
		super();
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		tipos = new String[numeroCampos];
		tablaExistencia = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      {
		         tablaExistencia[i]="";
		         tipos[i]="S"; 
		        }  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
	public IpwleeDatos(String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada)
	{
		super();
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = valoresEntrada.length;
		tablaExistencia = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      {
		         tablaExistencia[i]="";
		      }  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
  	public IpwleeDatos(String[] valoresEntrada)
	{
		super();
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		etiquetas = new String[numeroCampos];
		tipos     = new String[numeroCampos];
		tipos = new String[numeroCampos];
		tablaExistencia = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      {
		         tablaExistencia[i]="";
		         etiquetas[i]=(i+1)+ ".-";
		         tipos[i]="S"; 
		        }  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
		
	private void initializeComponent()
	{
    	Aceptar = new JButton();
    	Limpiar = new JButton();
    	Restaurar = new JButton();
    	Cancelar = new JButton();
		contentPane = (JPanel)this.getContentPane();
		for (int i =0;i<numeroCampos;i++)
			{
			 ArrJLabel[i]=new JLabel();
			 ArrJLabel[i].setText(etiquetas[i]);
			 ArrJTextField[i]=new JTextField();
			 ArrJTextField[i].setText(valoresCampos[i]);
			}
		//Inicializa Escuchadores
		for (int i=0;i<numeroCampos;i++)
			{
				ArrJTextField[i].addFocusListener(new FocusAdapter() {
			       public void focusLost(FocusEvent e)
			        {
				      cajasTexto_focusLost(e);
			         }
		        }
		        );
			}    	
		Aceptar.setText("Aceptar");
		Aceptar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Aceptar_actionPerformed(e);
			}

		});
		Limpiar.setText("Limpiar");
		Limpiar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Limpiar_actionPerformed(e);
			}

		});
		Restaurar.setText("Restaurar");
		Restaurar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Restaurar_actionPerformed(e);
			}

		});
		Cancelar.setText("Cancelar");
		Cancelar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Cancelar_actionPerformed(e);
			}

		});
	    contentPane.setLayout(null);
		anchoEtiqueta = 70;
		altoEtiqueta  = 18;
		altoCajaTexto  = 22;
		anchoCajaTexto = 100;
		anchoDelBoton  =83;
		altoDelBoton   =28;
		anchoPanel     =0;
		largoPanel     =0;
		xMensajeError  =0;
		yMensajeError  =0;
	    incrementoY=25;
	    inicializaArreglosPosiciones(limiteNumCampos,
		              xBotones,
	                  yBotones,
				      anchoBotones,
				      xEtiquetas,
				      yEtiquetas,
				      xCajasTexto,
				      yCajasTexto
				);
		yMensajeError=yBotones[3]+25;
	    xMensajeError=20;         
		int i;
		for (i=0;i<numeroCampos;i++)
		 {
		  addComponent(contentPane, ArrJLabel[i]     , xEtiquetas[i],yEtiquetas[i],anchoEtiqueta,altoEtiqueta);
		  addComponent(contentPane, ArrJTextField[i] , xCajasTexto[i],yCajasTexto[i],asignaAncho(i),altoCajaTexto);
		 }
		addComponent(contentPane, Aceptar, xBotones[0],yBotones[0],anchoBotones[0],altoDelBoton);
		addComponent(contentPane, Limpiar, xBotones[1],yBotones[1],anchoBotones[1],altoDelBoton);
		addComponent(contentPane, Restaurar, xBotones[2],yBotones[2],anchoBotones[2],altoDelBoton);
		addComponent(contentPane, Cancelar, xBotones[3],yBotones[3],anchoBotones[3],altoDelBoton);
		 
			//---Mensaje de Error ---
		addComponent(contentPane, mensajeError, xMensajeError,yMensajeError,400,22);
		this.setTitle(titulo);
		this.setLocation(new Point(100, 100));
		this.setSize(new Dimension(anchoPanel, largoPanel));
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setResizable(false);
	}

	private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}
	private void inicializaArreglosPosiciones(int limiteNumCampos,
		         int[]     xBotones,
	             int[]     yBotones,
				 int[]     anchoBotones,
				 int[]     xEtiquetas,
				 int[]     yEtiquetas,
				 int[]     xCajasTexto,
				 int[]     yCajasTexto
				)
	
	{   int x,y,xc,numBotones, anchoDelBoton;
	    anchoDelBoton=83;
		x=84;
		xc=180;
		//y=40;
		y=15;
		int incrementoY=25;
		int yInicioBotones = y + numeroCampos * incrementoY + incrementoY/2;
	  for (int i=0;i<numeroCampos;i++)
			{
			 xEtiquetas[i]=x;
			 yEtiquetas[i]=y;
			 xCajasTexto[i]=xc;
			 yCajasTexto[i]=y;
			 y = y + incrementoY;  	
			}
		x=20;
		numBotones=xBotones.length;
		for (int i=0;i<numBotones;i++)
			{
			 xBotones[i]=x;
			 yBotones[i]=yInicioBotones;
			 anchoBotones[i] = anchoDelBoton;
			 x=x+100;
		 	}
		yMensajeError=yBotones[3]+40;
	    xMensajeError=20;
	    anchoPanel=430;
	    largoPanel=yBotones[numBotones-1] + incrementoY*3;	
	}
	private int asignaAncho(int i) {
	int anchoCajaTexto = 100;
		  if (tipos[i].equals("I"))
			 anchoCajaTexto = 40;
		  if (tipos[i].equals("F"))
		 	 anchoCajaTexto = 60;
		  if (tipos[i].equals("D"))
		 	 anchoCajaTexto = 80;
	      return anchoCajaTexto; 	 	 	 	
	}
private void cajasTexto_focusLost(FocusEvent e)
	{ int i;
	  for (i=0;i<limiteNumCampos;i++)
		 if (e.getSource().equals((Object)ArrJTextField[i]))
		 		break;
 	  //Validar el campo que origino el evento, su numero est almacenado en i
 	  
 	  //Revisar que no exista error en otro campo
 	    for (int j=0;j<100;j++) 
			if (existeError[j] && (j != i))
				return;
	  int numEntero = 0;
	  float numFloat = 0;
	  String string= "";
	  Date fecha= new Date();
	  String datoleido = ArrJTextField[i].getText();
	  boolean[] error = new boolean[]{false};
	  String[] mensajeV= new String[]{""};
	  
	     if (tipos[i].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tipos[i].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tipos[i].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tipos[i].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);	
		    }
	     mensajeError.setText(mensajeV[0]);
	     existeError[i]=error[0];
	     if (error[0])
	       	{
	         ArrJTextField[i].requestFocus();
	       	 return;
	    	} 
	    //Si es el campo raza se valida por existencia
	    //Validar por existencia
	    if(!tablaExistencia[i].equals(""))
	       {
			
			//nExi=directorios.cargaArregloLLaves
			int nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[i],
				 valoresExi,
				 tablaExistencia[i]+"\\");
    		String[] llaveSel= new String[2];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							return;}
				}
			if (!existeExi)
				{//new selectorDeRegistro(tablaExistencia[i],llaveSel);
				 new IpSelectorDeRegistro(tablaExistencia[i],llaveSel,tablaExistencia[i]+"\\");
			     ArrJTextField[i].setText(llaveSel[0]);
			    }
			 }
	}




	private void Aceptar_actionPerformed(ActionEvent e)
	{   //validar todos
	    //Enviar mensaje y regresar con error o seguir adelante
		for (int i =0;i<numeroCampos;i++)
			{
			  valoresCampos[i]=ArrJTextField[i].getText();
			}
		if (!validaTodo())
		   return;		
		dispose();
	}
	
		private void Limpiar_actionPerformed(ActionEvent e)
	{   //Limpia el panel
		for (int i =0;i<numeroCampos;i++)
			{
			  ArrJTextField[i].setText("");
			}
	}
	
	private void Restaurar_actionPerformed(ActionEvent e)
	{   //Reinicializa el panel
		for (int i =0;i<numeroCampos;i++)
			{
			  ArrJTextField[i].setText(valoresCampos[i]);
			}
    }
    private void Cancelar_actionPerformed(ActionEvent e)
	{   //Regresa sin cambios
	    dispose();
	}
	private boolean validaTodo()
	{   boolean hayErrores = false;
	    String datoleido;
	    int numEntero=0;
	    float numFlotante=0;
	    Date fecha= new Date();
	    boolean[] error = new boolean[]{false};
	    String[] mensajeV= new String[]{""};
	    int numError=0; 
	   	for (int i =0;i<numeroCampos;i++)
			{
			 if (tipos[i].equals("I"))
			 	 {
		         datoleido=valoresCampos[i];
		         numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		            
		         }
			 if (tipos[i].equals("F"))
			 	 {
		         datoleido=valoresCampos[i];
		         numFlotante = Ip.validarDato(numFlotante,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		         }
			 if (tipos[i].equals("D"))
			 	 {
		         datoleido=valoresCampos[i];
		         fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		         }
		     if (error[0])
		     	 hayErrores = true;
		
			
			//Validar por existencia
		if(!tablaExistencia[i].equals(""))
	       {
			nExi=IpDirectorios.cargaArregloLLaves(tablaExistencia[i],
				 								  valoresExi,
				 								  tablaExistencia[i]+"\\");
    		String[] llaveSel= new String[2];
			boolean existeExi =false;
			datoleido=valoresCampos[i];
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							continue;}
				}
			if (!existeExi)
				{
				 hayErrores = true;
				 numError=i;
				}
			 }
			}//Termina el for de validar todos los campos	
			if (hayErrores)
				{
				ArrJTextField[numError].requestFocus();
		     	return false;
		     	}
		    return true;
	   
	}
	public static void main(String[] args)
	{   JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
		//Declaraciones
		int numeroCampos  =  6;
		String   etiquetas[]    =  new String [numeroCampos] ;   
		String[] tiposCampos    =  new String [numeroCampos] ;
        String[] valoresCampos  =  new String [numeroCampos] ;
        String[] tablaExistencia  =  new String [numeroCampos] ;
        String titulo = "Ejemplo de captura";
        //Inicializacion de campos
        etiquetas[0]="Usuario";
        etiquetas[1]="Especialidad";
        etiquetas[2]="Perfil";
        etiquetas[3]="Fecha";
        etiquetas[4]="Credito";
        etiquetas[5]="Tel.";
        tiposCampos[0]="S";
        tiposCampos[1]="S";
        tiposCampos[2]="I";
        tiposCampos[3]="D";
        tiposCampos[4]="F";
        tiposCampos[5]="S";
        for (int i=0; i<numeroCampos; i++)
               {valoresCampos[i]="";}
        valoresCampos[0]="Manuel";
        valoresCampos[1]="Traumatologo";
        valoresCampos[2]="5";
        valoresCampos[3]="12/11/2010";
        valoresCampos[4]="43000.00";
        valoresCampos[5]="19191919";
        
        tablaExistencia[0]="";
        tablaExistencia[1]="Especialidades";
        tablaExistencia[2]="";
        tablaExistencia[3]="";
        tablaExistencia[4]="";
        tablaExistencia[5]="";
               
		new IpwleeDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos,
	                  tablaExistencia);
	    //new IpCamposGui(titulo,
	    //              etiquetas,
	    //              valoresCampos,
	    //              tiposCampos,
	    //              numeroCampos);
	    //new IpCamposGui(etiquetas,
	    //              valoresCampos);              
	    //new IpCamposGui(valoresCampos);              
	    Ip.wescribeMensaje("datos leidos");
        Ip.wmuestraArreglo(valoresCampos,numeroCampos);
		
	}
}


/***************************************************************
*                     wmuestraDatos    	                        
*Permite mostrar un grupo de campos validandolos    
*por configuracion                                  
****************************************************************/
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import java.util.Date;
class IpwmuestraDatos extends JDialog{
	private JTextPane jTextPane1;
	private JScrollPane jScrollPane1;
	private JButton Continuar;
	private JPanel contentPane;
	private int limiteNumCampos=100;
	private String[] valoresCampos;
	private String[] etiquetas;
	//"S" - string, "F" - float, "I" - int, "D" - fecha
	private String[] tipos;
	private String titulo=" ";
	private int numeroCampos=0;
	private JTextField ArrJTextField[]= new JTextField[limiteNumCampos];
	private JLabel ArrJLabel[]= new JLabel[limiteNumCampos];
	
	
	public IpwmuestraDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada,
	                 int      numCampos)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = numCampos;
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	      
	public IpwmuestraDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 int      numCampos)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  =  numCampos;
		tipos = new String[numeroCampos];
		for (int i= 0; i< numCampos; i ++)
		      tipos[i]="S"; 
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
    public IpwmuestraDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = valoresEntrada.length;
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}	
	
	
	
	public IpwmuestraDatos(String   encabezado,
	                 String[] etiquetasEntrada,
	                 String[] valoresEntrada)
	{
		super();
		titulo        = encabezado;
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		tipos = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      tipos[i]="S";  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
	public IpwmuestraDatos(String[] etiquetasEntrada,
	                 String[] valoresEntrada)
	{
		super();
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		tipos = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		      tipos[i]="S";  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
	public IpwmuestraDatos(String[] etiquetasEntrada,
	                 String[] valoresEntrada,
	                 String[] tiposEntrada)
	{
		super();
		etiquetas     = etiquetasEntrada;
		valoresCampos = valoresEntrada;
		tipos         = tiposEntrada;
		numeroCampos  = valoresEntrada.length;
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	
  	public IpwmuestraDatos(String[] valoresEntrada)
	{
		super();
		valoresCampos = valoresEntrada;
		numeroCampos  = valoresEntrada.length;
		etiquetas = new String[numeroCampos];
		tipos     = new String[numeroCampos];
		for (int i= 0; i< numeroCampos; i ++)
		{tipos[i]="S";
		 etiquetas[i]=(i+1)+ ".-";
		}  
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
		
	private void initializeComponent()
	{
       	Continuar = new JButton();
		contentPane = (JPanel)this.getContentPane();
		for (int i =0;i<numeroCampos;i++)
			{
			 ArrJLabel[i]=new JLabel();
			 ArrJLabel[i].setText(etiquetas[i]);
			 ArrJTextField[i]=new JTextField();
			 ArrJTextField[i].setText(valoresCampos[i]);
			 ArrJTextField[i].setEditable(false);
			}
		Continuar.setText("Continuar");
		Continuar.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e)
			{
				Continuar_actionPerformed(e);
			}

		});
	    contentPane.setLayout(null);
		int margenSuperior = 40;
		addComponent(contentPane, Continuar, 130,numeroCampos*25+100-60 +margenSuperior,83,28);
		int ancho=0;
		for (int i=0;i<numeroCampos;i++)
			{ancho = 120;
			 if (tipos[i].equals("I"))
			 	 ancho = 40;
			 if (tipos[i].equals("F"))
			 	 ancho = 60;
			 if (tipos[i].equals("D"))
			 	 ancho = 80;	 	 
			 addComponent(contentPane,ArrJLabel[i],50,(i+1)*10+(i*15)+margenSuperior,90,20);
			 addComponent(contentPane,ArrJTextField[i],160,(i+1)*10 +(i*15)+margenSuperior,ancho,20);
			}
	    this.setTitle(titulo);
		this.setLocation(new Point(20, 10));
		this.setSize(new Dimension(382, numeroCampos*25+150));
	}

	private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}


    private void Continuar_actionPerformed(ActionEvent e)
	{   //Regresa sin cambios
	    dispose();
	}
	private boolean validaTodo()
	{   boolean hayErrores = false;
	    String datoleido;
	    int numEntero=0;
	    float numFlotante=0;
	    Date fecha= new Date();
	    boolean[] error = new boolean[]{false};
	    String[] mensajeV= new String[]{""};
	    int numError=0; 
	   	for (int i =0;i<numeroCampos;i++)
			{
			 if (tipos[i].equals("I"))
			 	 {
		         datoleido=valoresCampos[i];
		         numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		            
		         }
			 if (tipos[i].equals("F"))
			 	 {
		         datoleido=valoresCampos[i];
		         numFlotante = Ip.validarDato(numFlotante,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		         }
			 if (tipos[i].equals("D"))
			 	 {
		         datoleido=valoresCampos[i];
		         fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);
		         if (error[0])
		         	{
		            Ip.wescribeMensaje("Existe un error en el campo "+ etiquetas[i] + " " + mensajeV[0]+ "\n dato leido ("+datoleido+")");
		            numError=i;
		            }
		         }
		     if (error[0])
		     	 hayErrores = true;
			}
			if (hayErrores)
				{
				ArrJTextField[numError].requestFocus();
		     	return false;
		     	}
		    return true;
	}
	public static void main(String[] args)
	{   JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
		//Declaraciones
		int numeroCampos  =  6;
		String   etiquetas[]    =  new String [numeroCampos] ;   
		String[] tiposCampos    =  new String [numeroCampos] ;
        String[] valoresCampos  =  new String [numeroCampos] ;
        String titulo = "Ejemplo que muestra un grupo de datos";
        //Inicializacion de campos
        etiquetas[0]="Usuario";
        etiquetas[1]="Contrasea";
        etiquetas[2]="Perfil";
        etiquetas[3]="Fecha";
        etiquetas[4]="Credito";
        etiquetas[5]="Tel.";
        tiposCampos[0]="S";
        tiposCampos[1]="S";
        tiposCampos[2]="I";
        tiposCampos[3]="D";
        tiposCampos[4]="F";
        tiposCampos[5]="S";
        for (int i=0; i<numeroCampos; i++)
               {valoresCampos[i]="";}
        valoresCampos[0]="Manuel";
        valoresCampos[1]="453beta";
        valoresCampos[2]="5";
        valoresCampos[3]="12/11/2010";
        valoresCampos[4]="43000.00";
        valoresCampos[5]="19191919";
               
		new IpwmuestraDatos(titulo,
	                  etiquetas,
	                  valoresCampos,
	                  tiposCampos);
	    //new IpCamposGui(titulo,
	    //              etiquetas,
	    //              valoresCampos,
	    //              tiposCampos,
	    //              numeroCampos);
	    //new IpCamposGui(etiquetas,
	    //              valoresCampos);              
	    //new IpCamposGui(valoresCampos);              
	    Ip.wescribeMensaje("datos leidos");
        Ip.wmuestraArreglo(valoresCampos,numeroCampos);
		
	}
}

/** 
 * La clase IpArch implementa facilidades para leer y escribir
 * en archivos de texto con varios archivos abiertos simultaneamente.
 * Esta clase requiere una instancia para cada archivo que va a manejarse.
 * Por ejemplo:
 * IpArch archivo1 = new IpArch("PrimerArchivo.txt");
 * IpArch archivo2 = new IpArch("SegundoArchivo.txt"); 
 * Autor: Dr. Manuel Prieto
 * Copyright 2010
 * All Rigths Reserved
 * Todos Los Derechos Reservados
 * Se permite el uso libre de este software utilizando lalicencia GNU GPL
 * Para una licencia comercial, favor de comunicarse con el autor a:
 * mprieto@inwebinternational.com
 */
//import java.io.*;
class IpArch {
	//Declaracin de variables
    public int 				numero ;
    public String 			nombre_archivo;
    public boolean 			error;
    public BufferedWriter 	bw;
    public FileWriter 		fw;
    public FileReader 		fr;
	public BufferedReader 	archivo_entrada;
    public PrintWriter      archivo_salida;
     
    public boolean abreArchSalidaNuevo(String nombre_archivo) 
	    {  
	    	try	{
	    		fw = new FileWriter(nombre_archivo);
				bw = new BufferedWriter(fw);
				archivo_salida = new PrintWriter(bw);
				}
			catch(java.io.IOException iovariable) 
				{
				System.out.println("Error al Abrir archivo de salida: " + iovariable);
				return false;
				};
			return true;
			}
	//Termina el metodo abreArchSalidaNuevo
	public boolean abreArchSalidaYaExistente(String nombre_archivo) 
		    { 
		    	try	{
		    		fw = new FileWriter(nombre_archivo, true);
					bw = new BufferedWriter(fw);
					archivo_salida = new PrintWriter(bw);
					}
				catch(java.io.IOException iovariable) 
					{
					System.out.println("Error al Abrir archivo de salida: " + iovariable);
					return false;
					};
				return true;
			}	
    //Termina Metodo abreArchSalidaYaExistente 
    public   boolean escribeEnArch(String linea)
	    {   
	    	archivo_salida.println(linea);
	    	return true;
		}
	public   boolean escribeEnArch(double linea)
      {  
    	archivo_salida.println(linea);
    	return true;
	  }
	public   boolean escribeEnArch(float linea)
	  {  
	   	archivo_salida.println(linea);
	   	return true;
	  }
	public   boolean escribeEnArch(int linea)
	     {   
	    	archivo_salida.println(linea);
	    	return true;
		 }
	public   boolean escribeEnArch(long linea)
		{  
		archivo_salida.println(linea);
		return true;
		}
	public   boolean escribeEnArch(char linea)
	    { 
	    	archivo_salida.println(linea);
	    	return true;
		}
	public   boolean escribeEnArch(boolean linea)
	    { 
	    	archivo_salida.println(linea);
	    	return true;
		}				
	
       //Termina Metodo escribeEnArch{}
    public   boolean cierraArchSalida()
     	{ 
     	archivo_salida.close();
    	return true;
		}	
       //Termina Metodo cierraArchSalida
    public   boolean abreArchEntrada(String nombre_archivo) 
	    {  
	    	try		{
	    		fr = new FileReader(nombre_archivo);
				archivo_entrada = new BufferedReader(fr);
				}
			catch(java.io.FileNotFoundException fnfex) {
				System.out.println("Archivo de Entrada no encontrado: " + fnfex);
				return false;}
			catch(java.io.IOException ioex) {
				System.out.println("Error en el archivo de Entrada: " + ioex);
				return false;}
			return true;
		}
		//Termina Metodo abreArchEntrada 
	public   String leeDeArch()
    	{ //Declara Variables y Objetos a utilizar localmente  
	    	String linea;
	    	linea="";
	    	try {
	    			if ((linea = archivo_entrada.readLine()) != null)
	    				return linea;
	    			else
	    	    		return "";	
				}
			catch(java.io.FileNotFoundException fnfex) {
				System.out.println("Archivo no encontrado: " + fnfex);}
			catch(java.io.IOException ioex) {
				System.out.println("Error en el archivo de Entrada: " + ioex);}		 
	        return linea;
       }
       //Termina Metodo leeDeArch
	public   boolean cierraArchEntrada()
    { //Declara Variables y Objetos a utilizar localmente  
    		try {archivo_entrada.close();}
    	 catch(java.io.FileNotFoundException fnfex) {
			System.out.println("Archivo no encontrado: " + fnfex);
			return false; }
		catch(java.io.IOException ioex) {
			System.out.println("Error en el archivo de Entrada: " + ioex);
			return false;}
		return true;
	}
	//Termina Metodo cierraArchEntrada	
}//Termina Clase IpArch	

//Actualizador Unitario
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import java.util.Date;
//import java.io.*; 
class IpActUnit extends JFrame{
    private int limiteNumCampos =100;
    private int numBotones      =4;
	//nombre de la tabla 
	private String tabla ="";
	private String ruta="";
	private String wIcon="";
 	//***
	// Variables declaration
	private String[]     nombresCampos;
	private String[]     tiposCampos;
	private String[]     valoresCampos  =  new String[limiteNumCampos];
	private boolean[]    esCampoLlave;
	private String[]     tablaExistencia;
	private JLabel[]     etiquetas      =  new JLabel[limiteNumCampos];
	private JTextField[] cajasTexto     =  new JTextField[limiteNumCampos];
	private JButton[]    botones        =  new JButton[numBotones];
	private int[]        xBotones        =  new int[numBotones];
	private int[]        yBotones        =  new int[numBotones];
	private int[]        anchoBotones    =  new int[numBotones];
	private int[]        xEtiquetas      =  new int[limiteNumCampos];
	private int[]        yEtiquetas      =  new int[limiteNumCampos];
	private int[]        xCajasTexto     =  new int[limiteNumCampos];
	private int[]        yCajasTexto     =  new int[limiteNumCampos];
	int	anchoEtiqueta = 70;
	int	altoEtiqueta  = 18;
	int	altoCajaTexto  = 22;
	int	anchoCajaTexto = 100;
	int	anchoDelBoton  =83;
	int	altoDelBoton   =28;
	int	anchoPanel     =0;
	int	largoPanel     =0;
	int	xMensajeError  =0;
	int	yMensajeError  =0;
	int incrementoY=25;         
	//Botones
	private JButton Guardar;
	private JButton Leer;
	private JButton Borrar;
	private JButton Seleccionar;
	//Panel Contenedor
	private JPanel  panelContenedor;
	//Manejo del error
	private JLabel mensajeError;
	private boolean  existeError[]= new boolean[100];
	//Validaciones de existencia
	private String[] valoresExi= new String[1000] ;
	int nExi;
//***+++
public IpActUnit(String tab,
 				 String[] nombresC,
 				 String[] tiposC,
 				 boolean[] esLlave,
 				 String[] tablaExi)
	{
		super();

     tabla = tab;
     ruta=tabla+"\\";
     wIcon = "logo.gif";
     //Nombres de los campos
     nombresCampos=nombresC;
     //Numero de campos
     limiteNumCampos = nombresC.length;
     //Tipos de los campos
     tiposCampos=tiposC;
     //Indicador de Llave Primaria
     esCampoLlave=esLlave;
     //Tablas para validacion por existencia
     tablaExistencia=tablaExi;
     //Campos que se pueden calcular
     //Posicion x de los botones
     xBotones[0]=20;
     xBotones[1]=120;
     xBotones[2]=220;
     xBotones[3]=320;
     //Posicion y de los botones
     yBotones[0]=202;
     yBotones[1]=202;
     yBotones[2]=202;
     yBotones[3]=202;
     //Ancho de cada boton
     anchoBotones[0]=83;
     anchoBotones[1]=83;
     anchoBotones[2]=83;
     anchoBotones[3]=120;
     //Posicion x de las Etiquetas
     xEtiquetas[0]=84;
     xEtiquetas[1]=84;
     xEtiquetas[2]=84;
     xEtiquetas[3]=84;
     xEtiquetas[4]=84;
     xEtiquetas[5]=84;
     xEtiquetas[6]=84;
     //Posicion y de las Etiquetas
     yEtiquetas[0]=15;
     yEtiquetas[1]=40;
     yEtiquetas[2]=65;
     yEtiquetas[3]=90;
     yEtiquetas[4]=115;
     yEtiquetas[5]=140;
     yEtiquetas[6]=165;
     //Posicion x de las Cajas de Texto
     xCajasTexto[0]=180;
     xCajasTexto[1]=180;
     xCajasTexto[2]=180;
     xCajasTexto[3]=180;
     xCajasTexto[4]=180;
     xCajasTexto[5]=180;
     xCajasTexto[6]=180;
     //Posicion y de las Cajas De Texto
     yCajasTexto[0]=15;
     yCajasTexto[1]=40;
     yCajasTexto[2]=65;
     yCajasTexto[3]=90;
     yCajasTexto[4]=115;
     yCajasTexto[5]=140;
     yCajasTexto[6]=165;
     largoPanel=302;
     anchoPanel=450;
     xMensajeError=20;
     yMensajeError=227;
	 initializeComponent();
	 this.setVisible(true);
	 }
	 
 private void initializeComponent()
	{
		//Inicializa etiquetas y Cajas de Texto
		inicializaComponentes();
		generaDirectorioDeDatos(tabla);
		//Inicializa Escuchadores
		for (int i=0;i<limiteNumCampos;i++)
			{
				cajasTexto[i].addFocusListener(new FocusAdapter() {
			       public void focusLost(FocusEvent e)
			        {
				      cajasTexto_focusLost(e);
			         }
		        }
		        );
			}    
		Guardar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Guardar_actionPerformed(e);
			}

		});
		Leer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Leer_actionPerformed(e);
			}

		});
		Borrar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Borrar_actionPerformed(e);
			}

		});
		Seleccionar.setText("Seleccionar");
		Seleccionar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Seleccionar_actionPerformed(e);
			}

		});
		panelContenedor.setLayout(null);
		int i;
		for (i=0;i<limiteNumCampos;i++)
		 {
		  addComponent(panelContenedor, etiquetas[i] , xEtiquetas[i],yEtiquetas[i],anchoEtiqueta,altoEtiqueta);
		  addComponent(panelContenedor, cajasTexto[i] ,xCajasTexto[i],yCajasTexto[i],asignaAncho(i),altoCajaTexto);
		 }
		 for (i=0;i<numBotones;i++)
		 {
		  addComponent(panelContenedor, botones[i] ,xBotones[i],yBotones[i],anchoBotones[i],altoDelBoton);
		 }
			//---Mensaje de Error ---
		addComponent(panelContenedor, mensajeError, xMensajeError,yMensajeError,400,22);
		this.setTitle(tabla);
		this.setLocation(new Point(0, 0));
		this.setSize(new Dimension(anchoPanel, largoPanel));
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setResizable(false);
		//Icon
		if (Ip.existeArchivo(wIcon))
			this.setIconImage
			(Toolkit.getDefaultToolkit().getImage(this.getClass().getClassLoader().getSystemResource(wIcon)));
			else
			 Ip.wescribeMensaje("No existe el archivo ("+wIcon+") que contiene del Icono");
		this.setVisible(true);
		
		
	}
	
	/** Add Component Without a Layout Manager (Absolute Positioning) */
	private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}
	private int asignaAncho(int i) {
	int anchoCajaTexto = 100;
		  if (tiposCampos[i].equals("I"))
			 anchoCajaTexto = 40;
		  if (tiposCampos[i].equals("F"))
		 	 anchoCajaTexto = 60;
		  if (tiposCampos[i].equals("D"))
		 	 anchoCajaTexto = 80;
	      return anchoCajaTexto; 	 	 	 	
	}
	private void inicializaComponentes()
	{   for (int i=0;i<limiteNumCampos;i++)
			{
			 etiquetas[i]= new JLabel();
			 etiquetas[i].setText(nombresCampos[i]);
			 cajasTexto[i]= new JTextField();
			 }
		//Inicializa Botones
		Guardar     = new JButton();
		Guardar.setText("Guardar");
		botones[0]=Guardar;
		Leer        = new JButton();
		Leer.setText("Leer");
		botones[1]=Leer;
		Borrar      = new JButton();
		Borrar.setText("Borrar");
		botones[2]=Borrar;
		Seleccionar = new JButton();
		Seleccionar.setText("Seleccionar");
		botones[3] = Seleccionar;
		//Inicializa otros componentes
		mensajeError = new JLabel();
		panelContenedor = (JPanel)this.getContentPane();
	}
	
	public void generaDirectorioDeDatos(String t) {
   	    //Si ya existe el directorio de datos no lo genera
   	    if (!Ip.existeArchivo(tabla+"\\."))
   	         Ip.ejecutaConsola("MD "+t);
  	}
	
    private void cajasTexto_focusLost(FocusEvent e)
	{ int i;
	  for (i=0;i<limiteNumCampos;i++)
		 if (e.getSource().equals((Object)cajasTexto[i]))
		 		break;
 	  //Validar el campo que origino el evento, su numero est almacenado en i
 	  
 	  //Revisar que no exista error en otro campo
 	    for (int j=0;j<100;j++) 
			if (existeError[j] && (j != i))
				return;
	  int numEntero = 0;
	  float numFloat = 0;
	  String string= "";
	  Date fecha= new Date();
	  String datoleido = cajasTexto[i].getText();
	  boolean[] error = new boolean[]{false};
	  String[] mensajeV= new String[]{""};
	  
	     if (tiposCampos[i].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tiposCampos[i].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);	
		    }
	     mensajeError.setText(mensajeV[0]);
	     existeError[i]=error[0];
	     if (error[0])
	       	{
	         cajasTexto[i].requestFocus();
	       	 return;
	    	} 
	    //Si es el campo raza se valida por existencia
	    //Validar por existencia
	    if(!tablaExistencia[i].equals(""))
	       {
			
			//nExi=directorios.cargaArregloLLaves
			int nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[i],
				 valoresExi,
				 tablaExistencia[i]+"\\");
    		String[] llaveSel= new String[2];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							return;}
				}
			if (!existeExi)
				{//new selectorDeRegistro(tablaExistencia[i],llaveSel);
				 new IpSelectorDeRegistro(tablaExistencia[i],llaveSel,tablaExistencia[i]+"\\");
			     cajasTexto[i].setText(llaveSel[0]);
			    }
			 }
	}
  private void Guardar_actionPerformed(ActionEvent e)
	{   int numCampo=validaTodo();
		if (numCampo > -1)
		   	cajasTexto[numCampo].requestFocus();
		PanelAVariables();
		GuardaRegistro();
		Ip.wescribeMensaje("Registro Grabado");
	}
	private void Leer_actionPerformed(ActionEvent e)
	{ 
		if(!(Ip.existeArchivo(ruta+tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			Ip.wescribeMensaje("No existe registro para esta identificacion "+formaLlaveDelPanel());
			return;
			}
	 LeeRegistroConLlaveDelPanel();		
	 VariablesAPanel();
	}
   private String formaLlaveDelPanel()
	{ 
		String Llave = "";
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		Llave = Llave + cambiaDiagonalPorGuion(
		 			            cajasTexto[i].getText().trim());
		 }
		return Llave; 
	}
		private String formaLlave()
	{ 
		String Llave = "";
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		Llave = Llave + cambiaDiagonalPorGuion(valoresCampos[i].trim());
		 }
		return Llave; 
	}
	private String cambiaDiagonalPorGuion(String entrada)
	{   String salida="";
		for (int i=0;i<entrada.length();i++)
		 {
		 	if (entrada.substring(i,i+1).equals("/"))
		 		salida = salida + "-";
		 	else
		 		salida = salida + entrada.substring(i,i+1);	
		 			
		 }
		return salida; 
	}

	private void Borrar_actionPerformed(ActionEvent e)
	{   if(!(Ip.existeArchivo(ruta+tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			Ip.wescribeMensaje("No existe registro para esta identificacion "+formaLlaveDelPanel());
			return;
			}
	 LeeRegistroConLlaveDelPanel();
	 VariablesAPanel();
	 boolean respuesta = Ip.wescribePregunta("Desea borrar este registro?");
	 if(respuesta)
	 	Ip.borraArchivo(ruta+tabla +"_" + formaLlaveDelPanel() + ".txt",false);
	}
	private void Seleccionar_actionPerformed(ActionEvent e)
		
	{   String[] llaveSel= new String[limiteNumCampos];
		//new selectorDeRegistro(tabla,llaveSel);
		new IpSelectorDeRegistro(tabla,llaveSel,ruta);
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		valoresCampos[i] = llaveSel[i];
		 }
		LeeRegistro();
	    VariablesAPanel();
	}    
    private void GuardaRegistro()
	{	String nombre_archivo = ruta+tabla +"_" + formaLlave() + ".txt";
	    Ip.abreArchSalidaNuevo(nombre_archivo);
	    for (int i=0;i<limiteNumCampos;i++)
	        Ip.escribeEnArch(valoresCampos[i]);
	    Ip.cierraArchSalida();            	   
	}
	private void LeeRegistro()
	{
		String nombre_archivo = ruta+tabla+"_" + formaLlave() + ".txt";
	    Ip.abreArchEntrada(nombre_archivo);
	    for (int i=0;i<limiteNumCampos;i++)
	    	valoresCampos[i]= Ip.leeDeArch();
	    Ip.cierraArchEntrada();            	   
	}
	private void LeeRegistroConLlaveDelPanel()
	{   
		String nombre_archivo = ruta+tabla+"_" + formaLlaveDelPanel() + ".txt";
	    Ip.abreArchEntrada(nombre_archivo);
	    for (int i=0;i<limiteNumCampos;i++)
	    	valoresCampos[i]= Ip.leeDeArch();
	    Ip.cierraArchEntrada();            	   
	}
	private void PanelAVariables()
	{   
		for (int i=0;i<limiteNumCampos;i++)
		{  
			valoresCampos[i]= cajasTexto[i].getText();
		}
	}	
	 private void VariablesAPanel()
	{   
		for (int i=0;i<limiteNumCampos;i++)
			cajasTexto[i].setText(valoresCampos[i]);
	}		
	private int validaTodo()
	{   
	  
	  int numEntero = 0;
	  float numFloat = 0;
	  String string= "";
	  Date fecha= new Date();
	  String datoleido ;
	  boolean[] error = new boolean[]{false};
	  String[] mensajeV= new String[]{""};
	  for (int i=0;i<limiteNumCampos;i++)
	     {
	      datoleido = cajasTexto[i].getText();
	      error[0] = false;
	      mensajeV[0]= "";
	  
	     if (tiposCampos[i].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tiposCampos[i].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);	
		    }
	     mensajeError.setText(mensajeV[0]);
	     existeError[i]=error[0];
	     if (error[0])
	       	{
	         //cajasTexto[i].requestFocus();
	       	 return i;
	    	}
	    //Si es el campo raza se valida por existencia
		//Validar por existencia
		if(!tablaExistencia[i].equals(""))
	       {
			
			//nExi=directorios.cargaArregloLLaves
			int nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[i],
				 valoresExi,tablaExistencia[i]+"\\");
    		String[] llaveSel= new String[2];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							continue;}
				}
			if (!existeExi)
				{
						return i;
				}
			 }
	     }	 
	return -1;
	}
	
	private static void aparienciaWindows()
	{   
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
	}		
	public static void main(String[] args)
	{
     int numCampos=7;
     String[]     nombresCampos   = new String[numCampos] ;
	 String[]     tiposCampos     = new String[numCampos] ;
	 String[]     valoresCampos   = new String[numCampos] ;
	 boolean[]    esCampoLlave    = new boolean[numCampos] ;
	 String[]     tablaExistencia = new String[numCampos] ;;
     aparienciaWindows();
     String tab = "Medico";
     //Nombres de los campos
     nombresCampos[0]="id";
     nombresCampos[1]="Nombre";
     nombresCampos[2]="Apellido Paterno";
     nombresCampos[3]="Apellido Materno";
     nombresCampos[4]="Especialidad";
     nombresCampos[5]="Telefono";
     nombresCampos[6]="Celular";
     //Tipos de los campos
     tiposCampos[0]="S";
     tiposCampos[1]="S";
     tiposCampos[2]="S";
     tiposCampos[3]="S";
     tiposCampos[4]="S";
     tiposCampos[5]="S";
     tiposCampos[6]="S";
     //Indicador de Llave Primaria
     esCampoLlave[0]=true;
     esCampoLlave[1]=false;
     esCampoLlave[2]=false;
     esCampoLlave[3]=false;
     esCampoLlave[4]=false;
     esCampoLlave[5]=false;
     esCampoLlave[6]=false;
     //Tablas para validacion por existencia
     tablaExistencia[0]="";
     tablaExistencia[1]="";
     tablaExistencia[2]="";
     tablaExistencia[3]="";
     tablaExistencia[4]="Especialidades";
     tablaExistencia[5]="";
     tablaExistencia[6]="";
     new IpActUnit(tab, nombresCampos, tiposCampos, esCampoLlave, tablaExistencia);
      
	}
}

/**
 * @(#)IpSelectorDeRegistro.java
 *
 *
 * @author 
 * @version 1.00 2009/2/27
 */
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import javax.swing.table.*;
//import javax.swing.event.*;
//import java.util.Date;
//import java.util.GregorianCalendar;
//import java.text.*;
class IpSelectorDeRegistro extends JDialog{
//Declaraciones de variables de clase a continuacion
//
	    private JTable jTable1;
	    private JScrollPane jScrollPanel;
        private JButton Buscar;
	    private JPanel  contentPane;        
        private JLabel  mensajeError;
	    private int limiteNumRegs=10000;
	    private int limiteNumCampos =50;
 	    private int limiteCamposTablaVisual=50;
        private int selectedColumn=0;
        private int selectedRow=0;
        private String[] llaveSelec;
        private String llaveBusqueda="";
        private String [][] valoresCamposTabla = new String[limiteNumRegs][limiteNumCampos];
        private String[] llavesTabla = new String[limiteNumRegs];
        private int nllaves,numRegistro ;
	    private boolean existeError[]= new boolean[30];
	    private boolean existe = false;
        private String  tabla="";
        private String  ruta="";
        private int tamanoHorizontal = 200;
        private int tamanoVertical = 700;
        private int posicionX = 500;
	    private int posicionY = 10;
	    Object[][] data; 
	    
       
//Codigo del constructor
public IpSelectorDeRegistro(String tab, String[] RegSel, String path) 	
{
	  
super();
if (RegSel.length > 1)
	{
		limiteNumCampos = RegSel.length;
	    limiteCamposTablaVisual = RegSel.length;
	    tamanoHorizontal = tamanoHorizontal + 77*(limiteNumCampos-2);
	}
else
    {
		limiteNumCampos = 2;
	    limiteCamposTablaVisual = 2;
	}
   data = new Object[limiteNumRegs][limiteNumCampos];
   llaveSelec= new String[limiteNumCampos];
   llaveSelec=RegSel;
   tabla = tab;
   ruta=path;
   initializeComponent();
   nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla,ruta);
   //Ip.wmuestra(llavesTabla,nllaves);
   Leer_Registros();
   this.setModal(true);
   this.setVisible(true);
   
}

public IpSelectorDeRegistro(String tab, String[] RegSel) 	
{
	  
super();
if (RegSel.length > 1)
	{
		limiteNumCampos = RegSel.length;
	    limiteCamposTablaVisual = RegSel.length;
	    tamanoHorizontal = tamanoHorizontal + 77*(limiteNumCampos-2);
	}
else
    {
		limiteNumCampos = 2;
	    limiteCamposTablaVisual = 2;
	}
   data = new Object[limiteNumRegs][limiteNumCampos];
   llaveSelec= new String[limiteNumCampos];
   llaveSelec=RegSel;
   tabla = tab;
   ruta="";
   initializeComponent();
   nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla);
   //Ip.wmuestra(llavesTabla,nllaves);
   Leer_Registros();
   this.setModal(true);
   this.setVisible(true);
   
}


private void initializeComponent()
{  Buscar       = new JButton();
   mensajeError = new JLabel();
   contentPane = (JPanel)this.getContentPane();
   for (int i=0;i<30;i++)
      existeError[i]=false;
      mensajeError.setText("");
   //mensajeError.setText("Aqui parece el mensaje de error");
//Inicializacion de botones
//
//Buscar
//
   Buscar.setText("Buscar");
   Buscar.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{Buscar_actionPerformed(e);}});
//
// contentPane
//
   contentPane.setLayout(null);
//---Mensaje de Error ---
   //this.setLocation(new Point(10, 10));    
   this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
   this.setResizable(false);
   int i,j,k;
   limpiaValoresCamposTabla();
   //Carga informacion inicial en la tabla
for (i=0;i<limiteNumRegs;i++)
           for (j=0;j<limiteNumCampos;j++)
             data[i][j]=new String(""); 
//Arreglo con el nombre de los campos
String[] columnNames = new String[limiteCamposTablaVisual];
columnNames[0]="Id.";
columnNames[1]="Contenido";
for (i=2;i<limiteNumCampos;i++)
           columnNames[i]="";
IpModeloTabla tm= new IpModeloTabla(columnNames,data);

//Se agrega el escuchador al modelo
tm.addTableModelListener(new IpEscuchadorTabla());



//se crea la Tabla con el modelo propio
jTable1 = new JTable(tm);


jScrollPanel = new JScrollPane();
contentPane = (JPanel)this.getContentPane();

//Escuchador para click en la tabla
jTable1.addMouseListener(new MouseAdapter() {
public void mouseClicked(MouseEvent e)
	{
		jTable1_mouseClicked(e);
	}
});


jScrollPanel.setViewportView(jTable1);


//Inicializa los combos y prepara las columnas

jTable1.getColumnModel().getColumn(0).setPreferredWidth(10);
jTable1.getColumnModel().getColumn(1).setPreferredWidth(40);

//***
//*Inicializacion de etiquetas y ubicacion de los campos en el panel
//***
//***
//*Se establece el tamanio del panel
//***
	this.setSize(new Dimension(tamanoHorizontal,tamanoVertical));
	//***
//*Se establece el punto donde aparece
//***
	
	this.setLocation(new Point(posicionX, posicionY)); 
    
    addComponent(contentPane, jScrollPanel, 8,40,tamanoHorizontal - 10,tamanoVertical - 100);
    addComponent(contentPane, Buscar,       10,5,83,28);
    addComponent(contentPane, mensajeError,10,tamanoVertical - 65,500,22);
    this.setTitle("Selector de Un registro de la tabla de "+ tabla);
} //Termina la inicializacion del panel


//Agregar el componente de una manera absoluta
private void addComponent(Container container,Component c,int x,int y,int width,int height)
 {
   c.setBounds(x,y,width,height);
   container.add(c);
 }
//Aqui se insertan los escuchadores de focusLost para cada campo
//Y los escuchadores de los botones

//escuchador del boton Buscar
private void Buscar_actionPerformed(ActionEvent e)
 {//System.out.println("Inicia Buscar");
//Captura la llave a buscar
String llaveBusqueda = "";
llaveBusqueda = Ip.wlee("Argumento para buscar",llaveBusqueda);
numRegistro=0;
existe = false;
for (int i=0; i<limiteNumCampos;i++)
    { //int k = llavesTabla[i].compareTo(llaveBusqueda);
     //Ip.wescribeMensaje("i="+i+" k= "+k+" llavesTabla[i]("+llavesTabla[i]+") llaveBusqueda ("+llaveBusqueda+")");
    if (llavesTabla[i].toUpperCase().compareTo(llaveBusqueda.toUpperCase()) >= 0)
   	{existe=true;
   	 numRegistro = i;
   	 break;	
   	}
   	}
  //Leer_Registros();
  }

private void Leer_Registros()
 {
 String nombre_archivo;
 limpiaValoresCamposTabla();
 String datoleido;
 //Ip.wescribeMensaje("Numero llaves ("+nllaves+")");
//Ip.wescribeMensaje("numRegistro="+numRegistro);
	  
 for (int i=numRegistro; i<nllaves;i++)
   {   nombre_archivo = ruta+ tabla +"_"+ llavesTabla[i] + ".txt";
	   Ip.abreArchEntrada(nombre_archivo);
	   for (int j=0;j<limiteNumCampos;j++)
	         {datoleido  =Ip.leeDeArch();
	         valoresCamposTabla[i][j]    = datoleido;
	         }
	   Ip.cierraArchEntrada();        
   	}
    PasarValoresAlPanel();
  }
//***
//* Rutina para pasar valores al panel
//***
private void PasarValoresAlPanel(){
	for (int i=0;i<nllaves;i++)
    {
    	for (int j=0;j<limiteNumCampos;j++)
	         {jTable1.setValueAt(new String(""),i,j);
	         }
     }
	llaveSelec[0]=valoresCamposTabla[0][0];
for (int i=numRegistro;i<nllaves;i++)
    {//Ip.wescribeMensaje("i="+i+" valoresCamposTabla[i][0]("+valoresCamposTabla[i][0]+")");
     	for (int j=0;j<limiteNumCampos;j++)
	         {jTable1.setValueAt(new String(valoresCamposTabla[i][j]),i-numRegistro,j);
	         }
     //jTable1.setValueAt(new String(valoresCamposTabla[i][0]),i-numRegistro,0);
     //jTable1.setValueAt(new String(valoresCamposTabla[i][1]),i-numRegistro,1);
     //Ip.wescribeMensaje("Paso Valor de la mascota ("+valoresCamposTabla[i][0]+")");
	
     }
    }//Termina metodo
//***
//* Rutinas para hacer el set up de la tabla
//***

private void jTable1_mouseClicked(MouseEvent e)
	{
		//Ip.wescribeMensaje("\njTable1_mouseClicked(MouseEvent e) invocado");
		//Ip.wescribeMensaje("Renglon "+ jTable1.getSelectedRow() +"\n"+
		//    "Columna "+ jTable1.getSelectedColumn()+"\n"
	    //    +jTable1.getValueAt(jTable1.getSelectedRow(),jTable1.getSelectedColumn())); 
		selectedColumn=jTable1.getSelectedColumn();
		selectedRow=jTable1.getSelectedRow();
		for (int j=0;j<1;j++)
	         {      //Ip.wescribeMensaje("Row("+ jTable1.getSelectedRow() + ") col ("+ j+")" );
	         		llaveSelec[j]=(String)jTable1.getValueAt(jTable1.getSelectedRow(),j);
	         }
		dispose(); 
       
	}
private void limpiaValoresCamposTabla()
	{
	 for (int i=0; i<limiteNumRegs; i++)
           for (int j=0; j<limiteNumCampos; j++)
           {
           	valoresCamposTabla[i][j]=""; 
           }
     for (int i=0;i<limiteNumRegs;i++)
         for (int j=0; j<limiteNumCampos; j++)
        	{
             data[i][j]=new String("");
            }
	     
   }

public static void main(String[] args)
	{
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
		String[] llaveSel= new String[1];
		String tabla="Especialidades";
		String ruta="especialidades\\";
		new IpSelectorDeRegistro(tabla,llaveSel,ruta);
  		Ip.wescribeMensaje("Al regresar se selecciono el registro numero="+llaveSel[0]);
	    }
// Fin de la prueba 
}//Fin de la clase

/**
 * @(#)escuchadorTabla.java
 *
 *
 * @author 
 * @version 1.00 2009/2/26
 */
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import javax.swing.table.*;
//import javax.swing.event.*;
//import java.util.Date;
//import java.util.GregorianCalendar;
//import java.text.*;
class IpEscuchadorTabla implements TableModelListener {
    public IpEscuchadorTabla() {
        //table.getModel().addTableModelListener(this);
    }
    public void tableChanged(TableModelEvent e) {
        int row = e.getFirstRow();
        int column = e.getColumn();
        TableModel model = (TableModel)e.getSource();
        String columnName = model.getColumnName(column);
        Object dt = model.getValueAt(row, column);
        Class x=model.getValueAt(row, column).getClass();
        if (dt==null) return;
        String ts= dt.toString();
        //if (ts.equals("")) return;
        //int icampo = column -2;
        //ES.wescribeMensaje("\nClick Escuchador del modelo...."+
		//                   "\n**** Control de cambios de datos en la tabla \nrengln nmero ("+row +") "+
		//		   "en la columna ("+columnName+")\n"
		//		   +" Dato de la celda ("+dt+")\n"		);
		  }
    }





/**
 * @(#)modeloTabla.java
 *
 *
 * @author 
 * @version 1.00 2009/2/26
 */
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import javax.swing.table.*;
//import javax.swing.event.*;
//import java.util.Date;
//import java.util.GregorianCalendar;
//import java.text.*;
class IpModeloTabla extends AbstractTableModel {
       String [] columnNames;
       Object [][] data;      
       public IpModeloTabla(String[] names, Object[][] d) {
            columnNames = names;
            data = d;
            return;
        }
        //nicamente retornamos el numero de elementos del
        //array de los nombres de las columnas
        public int getColumnCount() {
            return columnNames.length;
        }
        public void setData(Object[][] d) {
            data = d;
        }
        //retormanos el numero de elementos
        //del array de datos
        public int getRowCount() {
            return data.length;
        }
        //retornamos el elemento indicado
        public String getColumnName(int col) {
            return columnNames[col];
        }
        //y lo mismo para las celdas
        public Object getValueAt(int row, int col) {
            return data[row][col];
        }
         /*
          * Este metodo sirve para determinar el editor predeterminado
          * para cada columna de celdas
          */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
         /*
          * No tienes que implementar este mtodo a menos que
          * las celdas de tu tabla sean Editables
          */
        public boolean isCellEditable(int row, int col) {
                return true;
        }
         /*
          * No tienes que implementar este mtodo a menos que
          * los datos de tu tabla cambien
          */
        public void setValueAt(Object value, int row, int col) {
            data[row][col] = value;
            fireTableCellUpdated(row, col);
        }
}
 
/**
 * @(#)directorios.java
 *
 *
 * @author 
 * @version 1.00 2009/2/23
 */

//import java.sql.*;
//import java.io.*;
//import java.util.Date;
//import java.text.*;
//import org.apache.commons.io.FileUtils;
//import org.apache.commons.io.filefilter.*;

class IpDirectorios {
   static int nLlaves = 0;    
   public static int cargaArregloLLaves
    	(String nomTabla,
    	 String[] Llaves)
    {
    //Carga las llaves de la tabla que recibe y las regresa en
    //el arreglo Llaves y en el nombre del metodo regresa
    //cuantas llaves cargo		
	nomTabla =nomTabla.trim();
	String NArch="DatosDirectorio"+nomTabla+".txt";
	Ip.borraArchivo(NArch,false);
	File dir = new File(".");
	//ES.escribeMensaje("Nombre Tabla ("+nomTabla +")");
 	String [] filtroPre = new String[] {nomTabla + "_"}; 
 	String[] filtroSuf  = new String[] {"txt"};
 	int i=0;
 	for (i=0;i<Llaves.length - 1 ;i++)
	 		{
	 			Llaves[i]="";
	 	     }
	//directorioAArchivo(NArch,dir,filtroPre,filtroSuf,nomTabla);
	directorioAArchivo(dir,filtroPre,filtroSuf,nomTabla);
 	Ip.abreArchEntrada(NArch);
 	//ES.escribeMensaje("Llaves Leidas del archivo ("+NArch+")");
 	String datoleido= Ip.leeDeArch().trim();
 	i=0;
 	while(datoleido!="")
 	 {
  		//ES.escribeMensaje("datoleido ("+datoleido+")");
  		Llaves[i]=datoleido;
  		datoleido= Ip.leeDeArch();
 	 i++;
 	 }
 	nLlaves=i;
 	Ip.cierraArchEntrada();
 	Ip.borraArchivo(NArch,false);
 	return nLlaves;
}
 public static int cargaArregloLLavesJava
    	(String nomTabla,
    	 String[] Llaves)
    {
    //Carga las llaves de la tabla que recibe y las regresa en
    //el arreglo Llaves y en el nombre del metodo regresa
    //cuantas llaves cargo		
	nomTabla =nomTabla.trim();
	String NArch="DatosDirectorio"+nomTabla+".txt";
	Ip.borraArchivo(NArch,false);
	File dir = new File(".");
	//ES.escribeMensaje("Nombre Tabla ("+nomTabla +")");
 	String [] filtroPre = new String[] {nomTabla + "_"}; 
 	String[] filtroSuf  = new String[] {"java"};
 	int i=0;
 	for (i=0;i<Llaves.length - 1 ;i++)
	 		{
	 			Llaves[i]="";
	 	     }
	//directorioAArchivo(NArch,dir,filtroPre,filtroSuf,nomTabla);
	directorioAArchivoJava(dir,filtroPre,filtroSuf,nomTabla);
 	Ip.abreArchEntrada(NArch);
 	//ES.escribeMensaje("Llaves Leidas del archivo ("+NArch+")");
 	String datoleido= Ip.leeDeArch().trim();
 	i=0;
 	while(datoleido!="")
 	 {
  		//ES.escribeMensaje("datoleido ("+datoleido+")");
  		Llaves[i]=datoleido;
  		datoleido= Ip.leeDeArch();
 	 i++;
 	 }
 	nLlaves=i;
 	Ip.cierraArchEntrada();
 	Ip.borraArchivo(NArch,false);
 	return nLlaves;
}

public static int cargaArregloLLavesJava
    	(String nomTabla,
    	 String[] Llaves,
    	 String path)
    {
    //Carga las llaves de la tabla que recibe y las regresa en
    //el arreglo Llaves y en el nombre del metodo regresa
    //cuantas llaves cargo		
	nomTabla =nomTabla.trim();
	String NArch="DatosDirectorio"+nomTabla+".java";
	Ip.borraArchivo(NArch,false);
	File dir = new File(path);
	//ES.escribeMensaje("Nombre Tabla ("+nomTabla +")");
 	String [] filtroPre = new String[] {nomTabla + "_"}; 
 	String[] filtroSuf  = new String[] {"java"};
 	int i=0;
 	for (i=0;i<Llaves.length - 1 ;i++)
	 		{
	 			Llaves[i]="";
	 	     }
	//directorioAArchivo(NArch,dir,filtroPre,filtroSuf,nomTabla);
	directorioAArchivoJava(dir,filtroPre,filtroSuf,nomTabla);
 	Ip.abreArchEntrada(NArch);
 	//ES.escribeMensaje("Llaves Leidas del archivo ("+NArch+")");
 	String datoleido= Ip.leeDeArch().trim();
 	i=0;
 	while(datoleido!="")
 	 {
  		//ES.escribeMensaje("datoleido ("+datoleido+")");
  		Llaves[i]=datoleido;
  		datoleido= Ip.leeDeArch();
 	 i++;
 	 }
 	nLlaves=i;
 	Ip.cierraArchEntrada();
 	Ip.borraArchivo(NArch,false);
 	return nLlaves;
}
public static int cargaArregloLLaves
    	(String nomTabla,
    	 String[] Llaves,
    	 String path)
    {
    //Carga las llaves de la tabla que recibe y las regresa en
    //el arreglo Llaves y en el nombre del metodo regresa
    //cuantas llaves cargo		
	nomTabla =nomTabla.trim();
	String NArch="DatosDirectorio"+nomTabla+".txt";
	Ip.borraArchivo(NArch,false);
	File dir = new File(path);
	//ES.escribeMensaje("Nombre Tabla ("+nomTabla +")");
 	String [] filtroPre = new String[] {nomTabla + "_"}; 
 	String[] filtroSuf  = new String[] {"txt"};
 	int i=0;
 	for (i=0;i<Llaves.length - 1 ;i++)
	 		{
	 			Llaves[i]="";
	 	     }
	//directorioAArchivo(NArch,dir,filtroPre,filtroSuf,nomTabla);
	directorioAArchivo(dir,filtroPre,filtroSuf,nomTabla);
 	Ip.abreArchEntrada(NArch);
 	//ES.escribeMensaje("Llaves Leidas del archivo ("+NArch+")");
 	String datoleido= Ip.leeDeArch().trim();
 	i=0;
 	while(datoleido!="")
 	 {
  		//ES.escribeMensaje("datoleido ("+datoleido+")");
  		Llaves[i]=datoleido;
  		datoleido= Ip.leeDeArch();
 	 i++;
 	 }
 	nLlaves=i;
 	Ip.cierraArchEntrada();
 	Ip.borraArchivo(NArch,false);
 	return nLlaves;
}

public static boolean directorioAArchivo(
 	                   File directorio,
 	                   String[] filtroPrefijo,
 	                   String[] filtroSufijo,
 	                   String tabla
 	                   	 )
 
 { //Convierte un directorio a archivo de salida, permitiendo un filtros de prefijos y sufijos 
 //Archivo de Salida
 //ES.escribeMensaje("Nombre Tabla ("+tabla+")");
 //ES.escribeMensaje("Filtro Prefijo ("+filtroPrefijo[0]+")");
 //ES.escribeMensaje("Filtro Sufijo ("+filtroSufijo[0]+")");
 String NombArchivo = "DatosDirectorio"+tabla+".txt";
 IOFileFilter FiltroTotal = null;
 String[] archivos = null;
 int lenPre=0;
 int lenSuf=0;
 if (filtroPrefijo != null)
 	 lenPre=filtroPrefijo.length;
 if (filtroSufijo != null)
 	 lenSuf=filtroSufijo.length;	 
 //  Armamos el filtro total
 if ((lenPre > 0) && (lenSuf > 0))
 	  {
 	  FiltroTotal = new AndFileFilter(
 	  	new PrefixFileFilter(filtroPrefijo),
 	  	new SuffixFileFilter(filtroSufijo)
 	    );
 	  }
 	 else
 	 {
 	    if ((lenPre> 0) && (lenSuf <= 0))
 	    	{
 	     		FiltroTotal = new PrefixFileFilter(
 	     			          filtroPrefijo);
 	    	}	
 	 	else
 	 	   {if ((lenPre <= 0) && (lenSuf > 0) )
 	 			FiltroTotal = new SuffixFileFilter(
 	 			filtroSufijo);
 	 	   }
 	 }
 	 	   					
 //Lista de los archivos del directorio filtrado
 if (FiltroTotal == null)
 		archivos  = directorio.list();
 else
 	 	archivos  = directorio.list(FiltroTotal);
 //Abrir el archivo de salida
    //ES.escribeMensaje("Nombre Archivo ("+NombArchivo+")");
 if (Ip.existeArchivo(NombArchivo))
 	{boolean r=Ip.wleeRespuesta("El archivo de salida: \n"
 		 + NombArchivo +"\nYa existe, desea reemplazarlo?");
 	 if (!r)	 						
 	 	 return false;
 	}
 Ip.abreArchSalidaNuevo(NombArchivo);
 //Llena de informacin el achivo de salida, un archivo por renglon.
 int lon=0;
 for (int i = 0; i < archivos.length; i++ ) {
 			 archivos[i] = 
 			 	archivos[i].substring(tabla.length()+1);
 			 lon = archivos[i].length() - 4;
 			 archivos[i] = archivos[i].substring(0, lon);
 			 //ES.escribeMensaje("Nombre escrito ("+archivos[i]+")");
 		 Ip.escribeEnArch(archivos[i]);
      }
 //Cierra Archivo de salida
 Ip.cierraArchSalida();
 return true;
 }
    
public static boolean directorioAArchivo(
 	                   String NombArchivo,
 	                   File directorio,
 	                   String[] filtroPrefijo,
 	                   String[] filtroSufijo,
 	                   String tabla
 	                   	 )
 
 { //Convierte un directorio a archivo de salida, permitiendo un filtros de prefijos y sufijos 
 //Archivo de Salida
 //ES.escribeMensaje("Nombre Tabla ("+tabla+")");
 //ES.escribeMensaje("Filtro Prefijo ("+filtroPrefijo[0]+")");
 //ES.escribeMensaje("Filtro Sufijo ("+filtroSufijo[0]+")");
 IOFileFilter FiltroTotal = null;
 String[] archivos = null;
 int lenPre=0;
 int lenSuf=0;
 if (filtroPrefijo != null)
 	 lenPre=filtroPrefijo.length;
 if (filtroSufijo != null)
 	 lenSuf=filtroSufijo.length;	 
 //  Armamos el filtro total
 if ((lenPre > 0) && (lenSuf > 0))
 	  {
 	  FiltroTotal = new AndFileFilter(
 	  	new PrefixFileFilter(filtroPrefijo),
 	  	new SuffixFileFilter(filtroSufijo)
 	    );
 	  }
 	 else
 	 {
 	    if ((lenPre> 0) && (lenSuf <= 0))
 	    	{
 	     		FiltroTotal = new PrefixFileFilter(
 	     			          filtroPrefijo);
 	    	}	
 	 	else
 	 	   {if ((lenPre <= 0) && (lenSuf > 0) )
 	 			FiltroTotal = new SuffixFileFilter(
 	 			filtroSufijo);
 	 	   }
 	 }
 	 	   					
 //Lista de los archivos del directorio filtrado
 if (FiltroTotal == null)
 		archivos  = directorio.list();
 else
 	 	archivos  = directorio.list(FiltroTotal);
 //Abrir el archivo de salida
    //ES.escribeMensaje("Nombre Archivo ("+NombArchivo+")");
 if (Ip.existeArchivo(NombArchivo))
 	{boolean r=Ip.wleeRespuesta("El archivo de salida: \n"
 		 + NombArchivo +"\nYa existe, desea reemplazarlo?");
 	 if (!r)	 						
 	 	 return false;
 	}
 Ip.abreArchSalidaNuevo(NombArchivo);
 //Llena de informacin el achivo de salida, un archivo por renglon.
 int lon=0;
 for (int i = 0; i < archivos.length; i++ ) {
 			 archivos[i] = 
 			 	archivos[i].substring(tabla.length()+1);
 			 lon = archivos[i].length() - 4;
 			 archivos[i] = archivos[i].substring(0, lon);
 			 //ES.escribeMensaje("Nombre escrito ("+archivos[i]+")");
 		 Ip.escribeEnArch(archivos[i]);
      }
 //Cierra Archivo de salida
 Ip.cierraArchSalida();
 return true;
 }
 //Directorios
 static boolean directorioAArchivoJava(
 	                   File directorio,
 	                   String[] filtroPrefijo,
 	                   String[] filtroSufijo,
 	                   String tabla
 	                   	 )
 
 { 
 String NombArchivo = "DatosDirectorio"+tabla+".txt";
 IOFileFilter FiltroTotal = null;
 String[] archivos = null;
 int lenPre=0;
 int lenSuf=0;
 if (filtroPrefijo != null)
 	 lenPre=filtroPrefijo.length;
 if (filtroSufijo != null)
 	 lenSuf=filtroSufijo.length;	 
 //  Armamos el filtro total
 if ((lenPre > 0) && (lenSuf > 0))
 	  {
 	  FiltroTotal = new AndFileFilter(
 	  	new PrefixFileFilter(filtroPrefijo),
 	  	new SuffixFileFilter(filtroSufijo)
 	    );
 	  }
 	 else
 	 {
 	    if ((lenPre> 0) && (lenSuf <= 0))
 	    	{
 	     		FiltroTotal = new PrefixFileFilter(
 	     			          filtroPrefijo);
 	    	}	
 	 	else
 	 	   {if ((lenPre <= 0) && (lenSuf > 0) )
 	 			FiltroTotal = new SuffixFileFilter(
 	 			filtroSufijo);
 	 	   }
 	 }
 	 	   					
 //Lista de los archivos del directorio filtrado
 if (FiltroTotal == null)
 		archivos  = directorio.list();
 else
 	 	archivos  = directorio.list(FiltroTotal);
 //Abrir el archivo de salida
    //ES.escribeMensaje("Nombre Archivo ("+NombArchivo+")");
 if (Ip.existeArchivo(NombArchivo))
 	{boolean r=Ip.wleeRespuesta("El archivo de salida: \n"
 		 + NombArchivo +"\nYa existe, desea reemplazarlo?");
 	 if (!r)	 						
 	 	 return false;
 	}
 Ip.abreArchSalidaNuevo(NombArchivo);
 //Llena de informacin el achivo de salida, un archivo por renglon.
 int lon=0;
 for (int i = 0; i < archivos.length; i++ ) {
 			 archivos[i] = 
 			 	archivos[i].substring(tabla.length()+1);
 			 lon = archivos[i].length() - 5;
 			 archivos[i] = archivos[i].substring(0, lon);
 			 //ES.escribeMensaje("Nombre escrito ("+archivos[i]+")");
 		 Ip.escribeEnArch(archivos[i]);
      }
 //Cierra Archivo de salida
 Ip.cierraArchSalida();
 return true;
 }



    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        String[] especialidades = new String[10] ;
        String tabla = "Especialidades";
        String path = "especialidades\\";
        int n=cargaArregloLLaves(tabla,especialidades,path);
        for(int i=0;i<nLlaves;i++)
	 		{
	 			Ip.escribeMensaje("Nombre "+ tabla +" ("+especialidades[i]+")");
	 		}
        	 
        	
    }
}

/**
 * @(#)Actualizador Tabular
 *
 *
 * @Manuel Prieto 
 * @version 1.00 2009/2/27
 */
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import javax.swing.table.*;
//import javax.swing.event.*;
//import java.util.Date;
//import java.util.GregorianCalendar;
//import java.text.*;
class IpActTab extends JFrame{
        private int numeroCampos =0;
        private JTable jTable1;
	    private JScrollPane jScrollPanel;
        private JButton Guardar;
        private JButton Leer;
        private JButton Buscar;
        private JButton AgregarEliminar;
        private JButton Salir;
	    private JPanel  contentPane;        
        private JLabel  mensajeError;
        private int limiteNumRegs=10000;
	    private String  tabla;
	    private String wIcon="";
	    private int limiteCamposTablaVisual=0; 
        private int selectedColumn=0;
        private int selectedRow=0;
        private String[] llaveSelec= new String[1];
        private String llaveBusqueda="";
        private String [][] valoresCamposTabla;
        private String[] llavesTabla = new String[limiteNumRegs];
        private int nllaves,numRegistro ;
	    private boolean existeError[]= new boolean[30];
	    private boolean existe = false;
	    private boolean registrosGrabados = false;
        private int tamanoHorizontal = 800;
        private int tamanoVertical = 300;//700
        private int posicionX = 10;
	    private int posicionY = 10;
	    private boolean escuchadorActivado_jTable1_tableChanged;
	    Object[][] data;
	    String[] nombresCampos;
	    String[] tiposCampos;
	    //"S".-String
		//"F".-Numero con decimales
		//"I".-Numero entero
		//"D".-Fecha
	    boolean[] esCampoLlave;
	    String[] tablaExistencia;
		private String[] valoresExi= new String[100] ;
	    int nExi;
       
//Codigo del constructor
//***+++
public IpActTab(String tab,
 				 String[] nombresC,
 				 String[] tiposC,
 				 boolean[] esLlave,
 				 String[] tablaExi)
   {  
   super();
   tabla = tab;
   wIcon = "logo.gif";
   numeroCampos = nombresC.length;
   limiteCamposTablaVisual=numeroCampos;
   valoresCamposTabla = new String[limiteNumRegs][numeroCampos];
   data = new Object[limiteNumRegs][numeroCampos];
   //Nombres de los campos
   nombresCampos=nombresC;
   //Tipos de los campos
   tiposCampos=tiposC;
   //Indicador de Llave Primaria
   esCampoLlave=esLlave;
   //Tablas para validacion por existencia
   tablaExistencia=tablaExi;
   initializeComponent();
   nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla,tabla+"\\");
   //Ip.wmuestra(llavesTabla,nllaves);
   numRegistro=0;
   Leer_Registros();
   this.setVisible(true);
   agregarEscuchadorCambiosTabla();
   escuchadorActivado_jTable1_tableChanged=true;
}
private void initializeComponent()
{ 	Guardar         = new JButton();
	Leer            = new JButton();
	Buscar          = new JButton();
	AgregarEliminar = new JButton();
	Salir           = new JButton();
   	mensajeError    = new JLabel();
   	contentPane     = (JPanel)this.getContentPane();
   	for (int i=0;i<numeroCampos;i++)
      existeError[i]=false;
     mensajeError.setText("");
   //mensajeError.setText("Aqui parece el mensaje de error");
   //Inicializacion de botones
   Guardar.setText("Guardar");
   Leer.setText("Leer");
   Buscar.setText("Buscar");
   AgregarEliminar.setText("Agregar/Eliminar");
   Salir.setText("Salir");
   //Declarar y activar Escuchador Boton Guardar
   Guardar.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{Guardar_actionPerformed(e);}});
	//Declarar y activar Escuchador Boton Leer
	Leer.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{Leer_actionPerformed(e);}});
	//Declarar y activar Escuchador Buscar
	Buscar.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{Buscar_actionPerformed(e);}});
	//Declarar y activar Escuchador Boton Agregar Eliminar
	AgregarEliminar.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{AgregarEliminar_actionPerformed(e);}});
	//Declarar y activar Escuchador Boton Agregar Salir
	Salir.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e)
	{Salir_actionPerformed(e);}});
   	contentPane.setLayout(null);
   	//---Mensaje de Error ---
   	//this.setLocation(new Point(10, 10));    
   	this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
   	this.setResizable(false);
   	int i,j,k;
   	limpiaValoresCamposTabla();
   	//Carga informacion inicial en la tabla
   	for (i=0;i<limiteNumRegs;i++)
           for (j=0;j<numeroCampos;j++)
             data[i][j]=new String(""); 
   	IpModeloTabla tm= new IpModeloTabla(nombresCampos,data);
	//Se agrega el escuchador al modelo
	tm.addTableModelListener(new IpEscuchadorTabla());
	//se crea la Tabla con el modelo propio
	jTable1 = new JTable(tm);
	jScrollPanel = new JScrollPane();
	contentPane = (JPanel)this.getContentPane();
	//Escuchador para click en la tabla
	jTable1.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e)
			{
				jTable1_mouseClicked(e);
			}
		});
	jScrollPanel.setViewportView(jTable1);
	//Inicializa prepara las columnas
 	for (i = 0; i<numeroCampos; i ++)
 	{ if(tiposCampos[i].equals("S"))
 		jTable1.getColumnModel().getColumn(i).setPreferredWidth(20);
   	  if(tiposCampos[i].equals("F"))
 		jTable1.getColumnModel().getColumn(i).setPreferredWidth(10);
   	  if(tiposCampos[i].equals("I"))
 		jTable1.getColumnModel().getColumn(i).setPreferredWidth(5);
   	if(tiposCampos[i].equals("D"))
 		jTable1.getColumnModel().getColumn(i).setPreferredWidth(10);			
 	} 
	//***
	//*Se establece el tamanio del panel
	//***
	this.setSize(new Dimension(tamanoHorizontal,tamanoVertical));
	//***
	//*Se establece el punto donde aparece cada elemento
	//***
	this.setLocation(new Point(posicionX, posicionY)); 
    addComponent(contentPane, jScrollPanel, 8,40,tamanoHorizontal - 10,tamanoVertical - 100);
    addComponent(contentPane, Guardar,                10, 5,80,28);
    addComponent(contentPane, Leer,                  100,5,80,28);
    addComponent(contentPane, Buscar,                190,5,80,28);
    addComponent(contentPane, AgregarEliminar,       280,5,120,28);
    addComponent(contentPane, Salir,                 410,5,80,28);
    addComponent(contentPane, mensajeError,10,tamanoVertical - 65,500,22);
    this.setTitle(tabla);
    if (Ip.existeArchivo(wIcon))
		this.setIconImage
		(Toolkit.getDefaultToolkit().getImage(this.getClass().getClassLoader().getSystemResource(wIcon)));
		else
		 Ip.wescribeMensaje("No existe el archivo ("+wIcon+") que contiene del Icono");
  } //Termina la inicializacion del panel
  //Agregar el componente de una manera absoluta
private void addComponent(Container container,Component c,int x,int y,int width,int height)
 {
   c.setBounds(x,y,width,height);
   container.add(c);
 }
private void agregarEscuchadorCambiosTabla()
 {
   jTable1.getModel().addTableModelListener(new TableModelListener() {

      public void tableChanged(TableModelEvent e) {
         jTable1_tableChanged(e);
      }
    });
 }
//Aqui se insertan los escuchadores
//Y los escuchadores de los botones
//escuchador del boton Guardar
private void Guardar_actionPerformed(ActionEvent e)
 {  if (validarTodo())
 	    Guardar_Registros();
 	else
 		Ip.wescribeMensaje("existen errores en los registros, imposible grabarlos");    
 }
private boolean validarTodo()
 {  //pasar los valores capturados en la tabla a un arreglo de trabajo
    String [][] valoresCapturados= new String[limiteNumRegs][numeroCampos];
    for (int i=0;i<nllaves;i++)
    {  for (int j=0;j<numeroCampos;j++ )
		   	{
	           valoresCapturados[i][j]=(String)jTable1.getValueAt(i,j);
	           //Ip.escribeMensaje("valoresCapturados["+i+"]["+j+"]="+valoresCapturados[i][j]);
	        }
	}            
    //valida el arreglo de trabajo
    boolean existeError=false;
    int numEntero = 0;
	float numFloat = 0;
	String string= "";
	Date fecha= new Date();
	String datoleido;
	boolean[] error = new boolean[]{false};
	String[] mensajeV= new String[]{""};
	for (int i=0;i<nllaves;i++)
    {   error[0]=false;
    	for (int j=0;j<numeroCampos;j++ )
		   	{//Se valida el campo del renglon i columna j
	         datoleido = valoresCapturados[i][j];
	         //Ip.escribeMensaje(" Valida valoresCapturados["+i+"]["+j+"]="+valoresCapturados[i][j]);
	     if (tiposCampos[j].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[j].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tiposCampos[j].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[j].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);	
		    }
	     if (error[0])
	          	 {
		          Ip.wescribeMensaje("Error en campo "+ nombresCampos[j] + " del rengln " + i +
	          	       " " + mensajeV[0]+ "\n dato leido (" + datoleido +")");
	          	  jTable1.setRowSelectionInterval(i,i);
	    	      existeError=true;
		         } 
	    //Si es el campo se valida por existencia
	    //Validar por existencia
	    if(!tablaExistencia[j].equals(""))
	       {
			nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[j],valoresExi,tablaExistencia[j]+"\\");
    		String[] llaveSel= new String[1];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{
					if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							 break;}
				}
			if (!existeExi)
				{
			     Ip.wescribeMensaje("Error en campo "+ nombresCampos[j] + " del rengln " + i +
	          	       " No existe este valor ("+ datoleido +") en la tabla " + tablaExistencia[j]);
	    	      existeError=true;
	    	      jTable1.setRowSelectionInterval(i,i); 
	    	    }
			 }    
	        }
	      }//Termina el lazo 	
    //Regresa true si no hay errores
    if (!existeError)
        {
         for (int i=0; i<nllaves;i++)
             {
	           for (int j=0;j<numeroCampos;j++ )
	   	          {
	      	        valoresCamposTabla[i][j]=valoresCapturados[i][j];
	      	       } 
	         }
       	}	  
 	return (!existeError);
   
   	}
   	 //escuchador del boton Leer
private void Leer_actionPerformed(ActionEvent e)
 {  escuchadorActivado_jTable1_tableChanged = false;
 	nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla,tabla+"\\"); 
 	numRegistro = 0;
 	Leer_Registros();
 	escuchadorActivado_jTable1_tableChanged = true;
 }
//escuchador del boton Buscar
private void Buscar_actionPerformed(ActionEvent e)
 {//System.out.println("Inicia Buscar");
//Captura la llave a buscar
escuchadorActivado_jTable1_tableChanged = false;
String llaveBusqueda = "";
llaveBusqueda = Ip.wlee("Argumento para buscar",llaveBusqueda);
int numRegEncontrado=0;
existe = false;
for (int i=0; i<nllaves;i++)
    { //int k = llavesTabla[i].compareTo(llaveBusqueda);
     //Ip.wescribeMensaje("i="+i+" k= "+k+" llavesTabla[i]("+llavesTabla[i]+") llaveBusqueda ("+llaveBusqueda+")");
    if (llavesTabla[i].toUpperCase().compareTo(llaveBusqueda.toUpperCase()) >= 0)
   	{existe=true;
   	 numRegEncontrado = i;
   	 break;	
   	}
   	}
  jTable1.setRowSelectionInterval(numRegEncontrado,numRegEncontrado);
  escuchadorActivado_jTable1_tableChanged = true;
  }
  //escuchador del boton AgregarEliminar
private void AgregarEliminar_actionPerformed(ActionEvent e)
 {  escuchadorActivado_jTable1_tableChanged=false;
 	boolean r=false;
 	if (!registrosGrabados)
 	   {r=Ip.wescribePregunta("No ha grabado los cambios,\n si no los guarda se perderan,\n desea continuar?");
 	    if (r)
 	        new IpActUnit(tabla, nombresCampos, tiposCampos, esCampoLlave, tablaExistencia);
 	    else
 	        {
 	        escuchadorActivado_jTable1_tableChanged=true;
 	        return;
 	        }
 	   }     
 	 else
 	 	new IpActUnit(tabla, nombresCampos, tiposCampos, esCampoLlave, tablaExistencia);     
  //cargar los registros actualizados
  nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla,tabla+"\\");
  numRegistro=nllaves;
  Leer_Registros();
  escuchadorActivado_jTable1_tableChanged=true;
 }
 //escuchador del boton Salir
private void Salir_actionPerformed(ActionEvent e)
 {  boolean r=false;
 	if (!registrosGrabados)
 	   {r=Ip.wescribePregunta("No ha grabado los cambios, desea salir?");
 	    if (r)
 	        dispose();
 	    else
 	        return;
 	   }
  dispose();   	
 }
private void Leer_Registros()
 { //Carga la tabla con los datos de los archivos .txt
 String nombre_archivo;
 limpiaValoresCamposTabla();
 String datoleido;
 nllaves=IpDirectorios.cargaArregloLLaves(tabla,llavesTabla,tabla+"\\");
 for (int i=numRegistro; i<nllaves;i++)
   {   nombre_archivo = tabla+"\\"+tabla +"_"+ llavesTabla[i] + ".txt";
	   Ip.abreArchEntrada(nombre_archivo);
	   for (int j=0;j<numeroCampos;j++ )
	   	{
	      datoleido                   = Ip.leeDeArch();
	      valoresCamposTabla[i][j]    = datoleido;
	     } 
	   //Ip.wescribeMensaje("Leyo ("+valoresCamposTabla[i][0]+") registros");
	   Ip.cierraArchEntrada();        
   	}
    PasarValoresAlPanel();
  }
  private void Guardar_Registros()
 { //Carga la tabla con los datos de los archivos .txt
 String nombre_archivo;
 String datoleido;
 for (int i=0; i<nllaves;i++)
   {   nombre_archivo = tabla+"\\"+ tabla +"_"+ llavesTabla[i] + ".txt";
	   Ip.abreArchEntrada(nombre_archivo);
	   for (int j=0;j<numeroCampos;j++ )
	   	{
	      Ip.escribeEnArch(valoresCamposTabla[i][j]);
	    } 
	   Ip.cierraArchSalida();        
   	}
    Ip.wescribeMensaje("Registros Grabados" );
 	registrosGrabados = true;
  }
  private void limpiaValoresCamposTabla()
	{
	 for (int i=0; i<limiteNumRegs; i++)
           for (int j=0; j<numeroCampos; j++)
           {
           	valoresCamposTabla[i][j]=""; 
           }
     for (int i=0;i<limiteNumRegs;i++)
         for (int j=0; j<numeroCampos; j++)
        	{
             data[i][j]=new String("");
            }
   }
//***
//* Rutina para pasar valores al panel
//***
private void PasarValoresAlPanel(){
	for (int i=0;i<nllaves;i++)
	    {for (int j=0;j<numeroCampos;j++ )
		   	{
	           jTable1.setValueAt(new String(""),i,j);
	        }
     //Ip.wescribeMensaje("Paso Valor de la mascota ("+valoresCamposTabla[i][0]+")");
	}
	 llaveSelec[0]=valoresCamposTabla[0][0];
   for (int i=numRegistro;i<nllaves;i++)
    {//Ip.wescribeMensaje("i="+i+" valoresCamposTabla[i][0]("+valoresCamposTabla[i][0]+")");
	     for (int j=0;j<numeroCampos;j++ )
		   	{
	           jTable1.setValueAt(new String(valoresCamposTabla[i][j]),i-numRegistro,j);
	        }
     //Ip.wescribeMensaje("Paso Valor de la mascota ("+valoresCamposTabla[i][0]+")");
	}
  }//Termina metodo
//***
//* Rutinas para hacer el set up de la tabla
//***
private void jTable1_mouseClicked(MouseEvent e)
	{
		//Ip.wescribeMensaje("MouseEvent Click " + "\n"+
		//"Renglon "+ jTable1.getSelectedRow() +"\n"+
		//"Columna "+ jTable1.getSelectedColumn()+"\n"+
		//"Campo   "+ jTable1.getColumnName(jTable1.getSelectedColumn())+"\n"+
		//"Valor   "+ (String)jTable1.getValueAt(jTable1.getSelectedRow(), jTable1.getSelectedColumn())); 	
	}
public void jTable1_tableChanged(TableModelEvent e){
	    if (!escuchadorActivado_jTable1_tableChanged)
		    return;
		//Ip.wescribeMensaje("TableChanged  " + "\n" +
		//"Renglon "+ jTable1.getSelectedRow() +"\n"+
		//"Columna "+ jTable1.getSelectedColumn()+"\n"+
		//"Campo   "+ jTable1.getColumnName(jTable1.getSelectedColumn())+"\n"+
		//"Tipo    "+ jTable1.getColumnClass(jTable1.getSelectedColumn())+"\n"+
		//"Valor   "+ (String)jTable1.getValueAt(jTable1.getSelectedRow(), jTable1.getSelectedColumn())); 	
	    if (esCampoLlave[jTable1.getSelectedColumn()])
	        { escuchadorActivado_jTable1_tableChanged=false;
	          jTable1.setValueAt(new String(llavesTabla[jTable1.getSelectedRow()]),jTable1.getSelectedRow(),jTable1.getSelectedColumn());
		      escuchadorActivado_jTable1_tableChanged=true;
		      Ip.wescribeMensaje("Para cambiar las llaves es necesario dar de baja el registro");
		    }	
	    registrosGrabados = false;
	    int numEntero = 0;
	    float numFloat = 0;
	    String string= "";
	    Date fecha= new Date();
	    String datoleido = (String)jTable1.getValueAt(jTable1.getSelectedRow(),jTable1.getSelectedColumn());
	    boolean[] error = new boolean[]{false};
	    String[] mensajeV= new String[]{""};
	    if (tiposCampos[jTable1.getSelectedColumn()].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[jTable1.getSelectedColumn()].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tiposCampos[jTable1.getSelectedColumn()].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[jTable1.getSelectedColumn()].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);		
		    }            
	    if (error[0])
	    	{int i,j;
	    	i=jTable1.getSelectedRow();
	    	j=jTable1.getSelectedColumn();
	    	Ip.wescribeMensaje(mensajeV + " \nEl Valor orignal del campo se conserva");
	    	escuchadorActivado_jTable1_tableChanged=false;
	    	jTable1.setValueAt(new String(valoresCamposTabla[i][j]),i,j);
	    	escuchadorActivado_jTable1_tableChanged=true;
	    	return;
	    	} 
	    //Si es el campo raza se valida por existencia
	    //Validar por existencia
	    if(!tablaExistencia[jTable1.getSelectedColumn()].equals(""))
	       {
			nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[jTable1.getSelectedColumn()],
				 valoresExi,tablaExistencia[jTable1.getSelectedColumn()]+"\\");
    		String[] llaveSel= new String[1];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							return;}
				}
			if (!existeExi)
				{new IpSelectorDeRegistro(
					tablaExistencia[jTable1.getSelectedColumn()],
					llaveSel,
					tablaExistencia[jTable1.getSelectedColumn()]+"\\"
						);
			     jTable1.setValueAt(new String(llaveSel[0]),jTable1.getSelectedRow(),jTable1.getSelectedColumn());
			    }
			 }    
	 }
	 private static void aparienciaWindows()
	{   
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
	}		
public static void main(String[] args)
	{
	 aparienciaWindows();
	 int numCampos=7;
     String[]     nombresCampos   = new String[numCampos] ;
	 String[]     tiposCampos     = new String[numCampos] ;
	 String[]     valoresCampos   = new String[numCampos] ;
	 boolean[]    esCampoLlave    = new boolean[numCampos] ;
	 String[]     tablaExistencia = new String[numCampos] ;;
     aparienciaWindows();
     String tab = "Medico";
     //Nombres de los campos
     nombresCampos[0]="id";
     nombresCampos[1]="Nombre";
     nombresCampos[2]="Apellido Paterno";
     nombresCampos[3]="Apellido Materno";
     nombresCampos[4]="Especialidad";
     nombresCampos[5]="Telefono";
     nombresCampos[6]="Celular";
     //Tipos de los campos
     tiposCampos[0]="S";
     tiposCampos[1]="S";
     tiposCampos[2]="S";
     tiposCampos[3]="S";
     tiposCampos[4]="S";
     tiposCampos[5]="S";
     tiposCampos[6]="S";
     //Indicador de Llave Primaria
     esCampoLlave[0]=true;
     esCampoLlave[1]=false;
     esCampoLlave[2]=false;
     esCampoLlave[3]=false;
     esCampoLlave[4]=false;
     esCampoLlave[5]=false;
     esCampoLlave[6]=false;
     //Tablas para validacion por existencia
     tablaExistencia[0]="";
     tablaExistencia[1]="";
     tablaExistencia[2]="";
     tablaExistencia[3]="";
     tablaExistencia[4]="Especialidades";
     tablaExistencia[5]="";
     tablaExistencia[6]="";
     new IpActTab(tab, nombresCampos, tiposCampos, esCampoLlave, tablaExistencia);
      
}
// Fin de la prueba 
}//Fin de la clase IpActTab

/****************************************************************/
/*                      IpMenuBarras	                        */
/*                                                              */
/****************************************************************/
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import inovaProg.*;
class IpMenuBarras extends JFrame
{
	// Variables declaration
	private String titulo;
	private String wIcon;
	private JPanel contentPane;
	private JDesktopPane desktop;
	int cantOpciones=0;
	String[] opciones;
	int[] cantSubOpciones;
	int maxSubOpciones=0;
	String[][] subOpciones;
	String[][] acciones;
	JMenuBar menuBar;
	JMenu[] arrMenu;
	JMenuItem[][] arrMenuItem; 
	// End of variables declaration
	public IpMenuBarras(String t, //Titulo del menu
	                  String[] opc, //Opciones en la barra principal
	                  String [][] subOpc,   //Sub Opciones 
	                  String[][] acc )      // Acciones a efectuar
	{
		super();
		int i=0,j=0;
		titulo = t;
		opciones=opc;
		subOpciones=subOpc;
		acciones=acc;
		cantOpciones=opciones.length;
		cantSubOpciones= new int[cantOpciones];
		maxSubOpciones = 0;
		wIcon = "logo.gif";
		for (i=0;i<cantOpciones;i++)
		{
			cantSubOpciones[i]=0;
			j=0;
			while ((j < subOpciones[i].length) && (subOpciones[i][j]!=null) && (subOpciones[i][j]!="")  )
			{
				cantSubOpciones[i]++;
				j++;
			}
			if (maxSubOpciones < cantSubOpciones[i])
				maxSubOpciones = cantSubOpciones[i];
			}
		arrMenu= new JMenu[cantOpciones];
		arrMenuItem =new JMenuItem[cantOpciones][maxSubOpciones]; 	
		initializeComponent();	
		this.setVisible(true);
	}
	private void initializeComponent()
	{
		int i,j;
		contentPane = (JPanel)this.getContentPane();
		contentPane.setLayout(null);
		desktop     = new JDesktopPane();
		menuBar 	= new JMenuBar();
		//Inicializar el menu superior
		for (i=0;i<cantOpciones;i++)
			{
				arrMenu[i] = new JMenu(opciones[i]); 
			}
		//Inicializar los submenus
		for (i=0;i<cantOpciones;i++)
			for (j=0;j<cantSubOpciones[i];j++)
			{
				arrMenuItem[i][j] = new JMenuItem(subOpciones[i][j]);
				 
			}
		//Aadir las opciones al menu de barras
		for (i=0;i<cantOpciones;i++)
			{
				menuBar.add(arrMenu[i]);
				//Agregar sub opciones a la opcion
			for (j=0;j<cantSubOpciones[i];j++)
				{
				arrMenu[i].add(arrMenuItem[i][j]);
				 
				}
				 
			}
		//Aadir el escuchador para todas las sub opciones
		for (i=0;i<cantOpciones;i++)
			{
				menuBar.add(arrMenu[i]);
				//Agregar sub opciones a la opcion
			for (j=0;j<cantSubOpciones[i];j++)
				{
				arrMenuItem[i][j].addActionListener(new java.awt.event.ActionListener() {
			    public void actionPerformed(java.awt.event.ActionEvent e)
			    	        {
				      			escuchador_subOpciones(e);
			                }
							});
				 
				}
				 
			}
		this.setContentPane(desktop);
		this.setJMenuBar(menuBar);
		this.setTitle(titulo);
		this.setResizable(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setSize(700,500);
		this.setLocation(100,100);
		//Icon
		if (Ip.existeArchivo(wIcon))
			this.setIconImage
			(Toolkit.getDefaultToolkit().getImage(this.getClass().getClassLoader().getSystemResource(wIcon)));
			else
			 Ip.wescribeMensaje("No existe el archivo ("+wIcon+") que contiene del Icono");
		this.setVisible(true);
    }
	//Escuchador de las subopciones del menu
	public void escuchador_subOpciones(java.awt.event.ActionEvent e)
	{  boolean encontrado=false;
	   int i,j=0;
	   for (i=0;i<cantOpciones;i++)
	    {for (j=0;j<cantSubOpciones[i];j++)
		   if (e.getSource().equals((Object)arrMenuItem[i][j]))
		   {
		   	encontrado=true;
		   	break;
		   }
		 if (encontrado)
		 	break;  	
		}
	   if (!IpEjecuta.accion(acciones[i][j]))
	      Ip.wescribeMensaje("Accion: \"" + acciones[i][j] + "\" desconocida codifique la clase faltante" +
        	"\ny agreguela a la lgica del metodo \"accion\" de la clase \"IpEjecuta\" ");	
	}
   	//Da la apriencia a la s ventanas del sistema operativo windows
   	private static void aparienciaWindows()
	{   
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
	}		
   public static void main(String[] args)
	{
		int numOpciones=5;
		int maxNumSubOpciones=4; //numero maximo de subopciones
		String titulo="Encabezado";
		String[] opciones        = new String[numOpciones] ;
		String[][] subOpciones   = new String[numOpciones][maxNumSubOpciones] ;
		String[][] acciones      = new String[numOpciones][maxNumSubOpciones] ;
		opciones[0] = "Operacin";
		opciones[1] = "Catalogos";
		opciones[2] = "Reportes";
		opciones[3] = "Procesos";
		opciones[4] = "Mantenimiento";
		subOpciones[0][0]="Facturas";
		subOpciones[0][1]="Remisiones";
		subOpciones[0][2]="Pedidos";
		subOpciones[0][3]="Inventarios";
		subOpciones[1][0]="Vendedores";
		subOpciones[1][1]="Articulos";
		subOpciones[1][2]="Clientes";
		subOpciones[2][0]="Reporte Ventas";
		subOpciones[2][1]="Reporte Compras";
		subOpciones[3][0]="Depuracion";
		subOpciones[4][0]="Ayuda";
		subOpciones[4][1]="Salida";
		//
		acciones[0][0]="Facturas";
		acciones[0][1]="Remisiones";
		acciones[0][2]="Pedidos";
		acciones[0][3]="Inventarios";
		acciones[1][0]="Vendedores";
		acciones[1][1]="Articulos";
		acciones[1][2]="Clientes";
		acciones[2][0]="Reporte Ventas";
		acciones[2][1]="Reporte Compras";
		acciones[3][0]="Depuracion";
		acciones[4][0]="Ayuda";
		acciones[4][1]="Salida";
		aparienciaWindows();
	    new IpMenuBarras("Encabezado",opciones,subOpciones,acciones);
	}//Termina la prueba
}//Termina la clase IpMenuBarras


/****************************************************************/
/*            Generador de Codigo para                          */
/*        Programas Actualizadores Unitarios y tabulares        */
/*        El fuente lo deja en ActUnit_tabla.java y             */
/*        ActTab_tabla.java                                     */
/*        Utiliza las plantillas:plantilla_ActUnit.txt y        */
/*        plantilla_ActTab.txt                                  */
/****************************************************************/
///import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import java.util.Date;
//import inovaProg.*;
//import java.io.*;
class IpGenCodAct extends JFrame
{
	//La siguiente dos variable se inicializan de acuerdo a la tabla
	//numero de campos en la tabla 
	private int    NumRenglones    = 1 + 24 ;//El 1 es constante 24 es el numero de renglones
	private int    limiteNumCampos =NumRenglones * 4 + 1 ;
	//nombre de la tabla 
	private String tabla ="programaActualizador";
	private String wIcon="";
	//***
	// Variables declaration
	private String[]     nombresCampos =   new String[NumRenglones];
	private String[]     tiposCampos   =   new String[NumRenglones];
	private String[]     valoresCampos =   new String[limiteNumCampos];
	String[] tiposReconocidos = {"S","I","F", "D"};
	//"S".-String "I".-Numero entero "F".-Numero con decimales "D".-Fecha
	private boolean[]    esCampoLlave   =  new boolean[limiteNumCampos];
	private String[]     tablaExistencia=  new String[limiteNumCampos];
	private JLabel[]     etiquetas      =  new JLabel[limiteNumCampos];
	private JTextField[] cajasTexto     =  new JTextField[NumRenglones+1];
	private JCheckBox[]  cajasCheck     =  new JCheckBox[NumRenglones+1];
	private JComboBox[]  comboTipo      =  new JComboBox[NumRenglones+1];
	private JComboBox[]  comboExi       =  new JComboBox[NumRenglones+1];
	//Botones
	private JButton Guardar;
	private JButton Leer;
	private JButton Borrar;
	private JButton Seleccionar;
	private JButton Ventana;
	private JButton GenerarCodigo;
	//Panel Contenedor
	private JPanel  panelContenedor;
	//Manejo del error
	private JLabel mensajeError;
	private boolean  existeError[]= new boolean[100];
	//Validaciones de existencia
	private String[] valoresExi= new String[1000] ;
	int nExi;
	//Variables de la aplicacion que se genera
	    int numBotones      =4;
	    String[]     nombres;
	    String[]     tipos;    
	    String[]     esLlave;
	    String[]     tablaExi;
	    int[]        xBotones        =  new int[numBotones];
	    int[]        yBotones        =  new int[numBotones];
	    int[]        anchoBotones    =  new int[numBotones];
	    int[]        xEtiquetas;
	    int[]        yEtiquetas;
	    int[]        xCajasTexto;
	    int[]        yCajasTexto;
	    int numCampos;
	    int yMensajeError=0;
	    int xMensajeError=0;
	    int anchoPanel=0;
	    int largoPanel=0;

	
	
	
	public IpGenCodAct()
	{
		super();
				//***
	    //Inician los campos que se modifican
	    //*** 
	    //Tabla que actualiza
	    tabla="ActUnit";
	    //wIcon="ManuelPrieto.gif";
	    wIcon="logo.gif";
	   	//Nombres de las columnas (Campos)
		nombresCampos[0]="Nombre Clase";
		nombresCampos[1]="Campo    ";
		nombresCampos[2]="Es Llave ";
		nombresCampos[3]="Tipo     ";
		nombresCampos[4]="Tabla Exi..";
		//Indica si el campo es llave primaria
		esCampoLlave[0]=true;
		for (int i= 1; i< NumRenglones ; i++)
			esCampoLlave[i]=false;
		//Tipos de las columnas (Campos)
		for (int i= 0; i< NumRenglones ; i++)
		    tiposCampos[i]="S"; //S.-String
		//Nombres de las tablas contra las que se valida la existencia
		for (int i= 0; i< NumRenglones ; i++)
		    tablaExistencia[i]="";
		//***
	    //Terminan los campos que se modifican
	    //***
		initializeComponent();
		this.setVisible(true);
	 }
 private void initializeComponent()
	{
		//Inicializa etiquetas y Cajas de Texto
		for (int i=0;i<NumRenglones;i++)
			{
			 etiquetas[i]= new JLabel();
			 etiquetas[i].setText(nombresCampos[i]);
			}
		//Inicializa Cajas de Texto, CheckBoxes y Combos
		for (int i=0;i<NumRenglones;i++)
			{
			 cajasTexto[i]=  new JTextField();
			 cajasCheck[i]=  new JCheckBox();
	         comboTipo [i]=  new JComboBox();
	         cargaComboTipo(comboTipo[i]);
	         comboExi  [i]=  new JComboBox();
	         cargaComboExi(comboExi[i]); 	
			}	
		//Inicializa Botones
		Guardar     = new JButton();
		Guardar.setText("Guardar");
		Leer        = new JButton();
		Leer.setText("Leer");
		Borrar      = new JButton();
		Borrar.setText("Borrar");
		Seleccionar = new JButton();
		Seleccionar.setText("Seleccionar");
		Ventana = new JButton();
		Ventana.setText("Diseo");
		GenerarCodigo = new JButton();
		GenerarCodigo.setText("Generar Codigo");
		//Inicializa otros componentes
		mensajeError = new JLabel();
		panelContenedor = (JPanel)this.getContentPane();
		//Inicializa Escuchadores
		for (int i=0;i<NumRenglones;i++)
			{
				cajasTexto[i].addFocusListener(new FocusAdapter() {
			       public void focusLost(FocusEvent e)
			        {
				      cajasTexto_focusLost(e);
			         }
		        }
		        );
			}    
		Guardar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Guardar_actionPerformed(e);
			}

		});
		Leer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Leer_actionPerformed(e);
			}

		});
		Borrar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Borrar_actionPerformed(e);
			}

		});
		Seleccionar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Seleccionar_actionPerformed(e);
			}

		});
		Ventana.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				Ventana_actionPerformed(e);
			}

		});
		GenerarCodigo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				GenerarCodigo_actionPerformed(e);
			}

		});
		panelContenedor.setLayout(null);
		//--- Etiquetas ------
		int x,y;
		int anchoEtiqueta,altoEtiqueta,incrementoY,altoCajaTexto,anchoCajaTexto,yInicioBotones;
		int anchoCajaCheck,anchoComboTipo;
		anchoEtiqueta = 70;
		altoEtiqueta  = 18;
		x=84;
		y=5;
		incrementoY=25;
		yInicioBotones = y + limiteNumCampos * incrementoY + incrementoY;
		anchoCajaTexto = 100;
		altoCajaTexto  = 22;
		anchoCajaCheck = 30;
		anchoComboTipo = 35;    
		//Encabezados
		addComponent(panelContenedor, etiquetas[0] ,x,y,anchoEtiqueta,altoEtiqueta);
		x=180;
		addComponent(panelContenedor, cajasTexto[0] ,x,y,anchoCajaTexto,altoCajaTexto);
		y = y + incrementoY - 3;
		x=84;
		addComponent(panelContenedor, etiquetas[1] , x+27,y,anchoCajaTexto,altoEtiqueta);
		x=x+anchoCajaTexto+20;
		addComponent(panelContenedor, etiquetas[2] , x+10,y,anchoCajaTexto,altoEtiqueta);
		x=x+anchoCajaTexto+20;
		addComponent(panelContenedor, etiquetas[3] , x,y,anchoCajaTexto,altoEtiqueta);  
		x=x+anchoCajaTexto+20;
		addComponent(panelContenedor, etiquetas[4] , x,y,anchoCajaTexto,altoEtiqueta);  
		y = y + incrementoY;
		x=84;
		//for (int i=1;i<limiteNumCampos- 3 ;i=i+4)
		for (int i=1;i<NumRenglones ;i++)
		 {x=84;
		  addComponent(panelContenedor, cajasTexto[i],x,y,anchoCajaTexto,altoCajaTexto);
		  x=x+anchoCajaTexto+20;
		  addComponent(panelContenedor, cajasCheck[i],x+20,y,anchoCajaCheck,altoCajaTexto);
		  x=x+anchoCajaTexto+20;
		  addComponent(panelContenedor, comboTipo[i],x,y,anchoComboTipo,altoCajaTexto);
		  x=x+anchoCajaTexto+20;
		  addComponent(panelContenedor, comboExi[i],x,y,anchoCajaTexto,altoCajaTexto);
		  y = y + incrementoY;
		 }
		//--- Controles ---
		int t = x;
		x=34;
		int anchoBotones=70;
		addComponent(panelContenedor, Guardar, x,y,anchoBotones+5,28);
		x=x+anchoBotones+15;
		addComponent(panelContenedor, Leer, x,y,anchoBotones,28);
		x=x+anchoBotones+10;
		addComponent(panelContenedor, Borrar,x,y,anchoBotones,28);
		x=x+anchoBotones+10;
		addComponent(panelContenedor, Seleccionar, x,y,anchoBotones+20,28);
		x=x+anchoBotones+30;
		addComponent(panelContenedor, Ventana, x,y,anchoBotones+20,28);
		x=x+anchoBotones+30;
		addComponent(panelContenedor, GenerarCodigo, x,y,anchoBotones+40,28);
		//---Mensaje de Error ---
		y = y +  incrementoY;
		addComponent(panelContenedor, mensajeError, 20,y,400,22);
		y = y +  incrementoY + 40;
		t=t+anchoCajaTexto+100;
		this.setTitle("Generador De Cdigo");
		this.setLocation(new Point(0, 0));
		this.setSize(new Dimension(t, y));
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setResizable(false);
		//Icon
		if (Ip.existeArchivo(wIcon))
			this.setIconImage
			(Toolkit.getDefaultToolkit().getImage(this.getClass().getClassLoader().getSystemResource(wIcon)));
			else
			 Ip.wescribeMensaje("No existe el archivo ("+wIcon+") que contiene del Icono");
		this.setVisible(true);
		
		
	}

    private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}
	private void cargaComboTipo(JComboBox combo)
	{
		for (int i=0;i<tiposReconocidos.length;i++)
		     combo.addItem(tiposReconocidos[i]);
		     		
	}
	private void cargaComboExi(JComboBox combo)
	{
		combo.addItem("");;
		Ip.cargaCombo(combo,"ActUnit");		     		
	}
    private void cajasTexto_focusLost(FocusEvent e)
		{ int i;
	  for (i=0;i<limiteNumCampos;i++)
		 if (e.getSource().equals((Object)cajasTexto[i]))
		 		break;
 	  //Validar el campo que origino el evento, su numero esta almacenado en i
 	  
 	  //Revisar que no exista error en otro campo
 	    for (int j=0;j<100;j++) 
			if (existeError[j] && (j != i))
				return;
	  int numEntero = 0;
	  float numFloat = 0;
	  String string= "";
	  Date fecha= new Date();
	  String datoleido = cajasTexto[i].getText();
	  boolean[] error = new boolean[]{false};
	  String[] mensajeV= new String[]{""};
	  
	     if (tiposCampos[i].equals("S"))
		    {
		     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("F"))
		    {
		     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
		    }
		 if (tiposCampos[i].equals("I"))
		    {
		     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);	
		    }
		 if (tiposCampos[i].equals("D"))
		    {
		     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);	
		    }
	     mensajeError.setText(mensajeV[0]);
	     existeError[i]=error[0];
	     if (error[0])
	       	{
	         cajasTexto[i].requestFocus();
	       	 return;
	    	} 
	    //Si es el campo raza se valida por existencia
	    //Validar por existencia
	    if(!tablaExistencia[i].equals(""))
	       {
			
			//nExi=directorios.cargaArregloLLaves
			int nExi=IpDirectorios.cargaArregloLLaves
				(tablaExistencia[i],
				 valoresExi,
				 tablaExistencia[i]+"\\");
    		String[] llaveSel= new String[2];
			boolean existeExi =false;
			for (int k=0;k<nExi;k++)
				{ if (datoleido.equals(valoresExi[k]))
							{existeExi =true;
							return;}
				}
			if (!existeExi)
				{//new selectorDeRegistro(tablaExistencia[i],llaveSel);
				 new IpSelectorDeRegistro(tablaExistencia[i],llaveSel,tablaExistencia[i]+"\\");
			     cajasTexto[i].setText(llaveSel[0]);
			    }
			 }
	}
	private void Guardar_actionPerformed(ActionEvent e)
	{   int numCampo=validaTodo();
		if (numCampo > -1)
		   {cajasTexto[numCampo].requestFocus();
		    return;
		   }
		if((Ip.existeArchivo(tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			boolean respuesta = Ip.wescribePregunta("Ya existe un registro para esta clase "+formaLlaveDelPanel()+", desea actualizarlo");
	        if(!respuesta)
	 	     {
	 	       return;
	 	     }	
			}
		PanelAVariables();
		GuardaRegistro();
		Ip.wescribeMensaje("Registro Grabado " );
		cuentaCamposDefineArreglos();
		inicializaArreglosPosiciones(numCampos,
	             xBotones,
	             yBotones,
	             anchoBotones,
	             xEtiquetas,
	             yEtiquetas,
	             xCajasTexto,
	             yCajasTexto);
	    if((Ip.existeArchivo("diseno_"+tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			boolean respuesta = Ip.wescribePregunta("Ya existe un diseo para esta clase "+formaLlaveDelPanel()+", desea actualizarlo");
	        if(!respuesta)
	 	     {
	 	       return;
	 	     }	
			}
	    guardaDisenoPanel();         
	}
	private void guardaDisenoPanel()
	{  String archivo_salida="diseno_"+ tabla +"_" + formaLlaveDelPanel() + ".txt";
	   Ip.abreArchSalidaNuevo(archivo_salida);
	   Ip.escribeEnArch(numCampos);
	   Ip.escribeEnArch(numBotones);
	   for (int i=0;i<numCampos;i++)
	   	{
	   		Ip.escribeEnArch(xEtiquetas[i]);
	   	    Ip.escribeEnArch(yEtiquetas[i]);
	   	    Ip.escribeEnArch(xCajasTexto[i]);
	   	    Ip.escribeEnArch(yCajasTexto[i]);
	   	}
	   	for (int i=0;i<numBotones;i++)
	   	{
	   		Ip.escribeEnArch(xBotones[i]);
	   	    Ip.escribeEnArch(yBotones[i]);
	   	    Ip.escribeEnArch(anchoBotones[i]);
	   	}
	   	Ip.escribeEnArch(xMensajeError);
	   	Ip.escribeEnArch(yMensajeError);
	   	Ip.escribeEnArch(largoPanel);
	   	Ip.escribeEnArch(anchoPanel);
	   	Ip.cierraArchSalida();		   
	}
	private void cuentaCamposDefineArreglos()
	{   cuentaCampos();
	    nombres = new String[numCampos] ;
	    tipos   = new String[numCampos] ;
	    esLlave = new String[numCampos] ;
	    tablaExi= new String[numCampos] ;
		String archivo_entrada=tabla +"_" + formaLlaveDelPanel() + ".txt";
	    Ip.abreArchEntrada(archivo_entrada);
	    String datoleido=Ip.leeDeArch();
	    datoleido=Ip.leeDeArch();
	    int i = 0;
	    while (!datoleido.equals(""))
	    { 
	      nombres[i]=datoleido;
	      datoleido = Ip.leeDeArch();
	      esLlave[i]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tipos[i]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tablaExi[i]=datoleido;
	      i++;
	      datoleido = Ip.leeDeArch();	
	    }
	    Ip.cierraArchEntrada();
	    xEtiquetas  = new int[numCampos]  ;
	    yEtiquetas  = new int[numCampos]  ;
	    xCajasTexto = new int[numCampos]  ;;
	    yCajasTexto = new int[numCampos]  ;; 
	}
	private void cuentaCampos()
	{   String archivo_entrada=tabla +"_" + formaLlaveDelPanel() + ".txt";
	    Ip.abreArchEntrada(archivo_entrada);
	    numCampos=0;
	    String datoleido=Ip.leeDeArch();
	    datoleido=Ip.leeDeArch();
	    while (!datoleido.equals(""))
	    { 
	      datoleido = Ip.leeDeArch();
	      datoleido = Ip.leeDeArch();
	      datoleido = Ip.leeDeArch();
	      numCampos++;
	      datoleido = Ip.leeDeArch();	
	    }
	    Ip.cierraArchEntrada();
	}
	private void Leer_actionPerformed(ActionEvent e)
	{ 
		if(!(Ip.existeArchivo(tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			Ip.wescribeMensaje("No existe registro para esta clase "+formaLlaveDelPanel());
			return;
			}
	 LeeRegistro(formaLlaveDelPanel());
	 VariablesAPanel();
	}
	private String formaLlaveDelPanel()
	{ 
		String Llave = "";
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		Llave = Llave + cajasTexto[i].getText().trim();
		 }
		return Llave; 
	}
	private void Borrar_actionPerformed(ActionEvent e)
	{   if(!(Ip.existeArchivo(tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			Ip.wescribeMensaje("No existe registro para esta clase "+formaLlaveDelPanel());
			return;
			}
	 LeeRegistro(formaLlaveDelPanel());
	 VariablesAPanel();
	 boolean respuesta = Ip.wescribePregunta("Desea borrar este registro?");
	 if(respuesta)
	 	{
	 	Ip.borraArchivo(tabla +"_" + formaLlaveDelPanel() + ".txt",true);
	 	Ip.wescribeMensaje("Registro Borrado ");
	 	}
		
	}
private void Ventana_actionPerformed(ActionEvent e)
	{   //Cuenta los campos, despues inicializa arreglos y disea
	    if(!Ip.existeArchivo("diseno_"+tabla +"_" + formaLlaveDelPanel() + ".txt"))
			{
			Ip.wescribePregunta("No existe un diseo para esta clase "+formaLlaveDelPanel()+", se procede a generarlo");
	        cuentaCamposDefineArreglos();
	        inicializaArreglosPosiciones(numCampos,
	             xBotones,
	             yBotones,
	             anchoBotones,
	             xEtiquetas,
	             yEtiquetas,
	             xCajasTexto,
	             yCajasTexto);	
			}
		else	
		   {
			cuentaCamposDefineArreglos();
			LeeDisenoPanel();
		   }
	    int incrementoY = 25;
	    int[] valoresParam    =  new int[4];
	    valoresParam[0]=xMensajeError;
	    valoresParam[1]=yMensajeError;
	    valoresParam[2]=largoPanel;
	    valoresParam[3]=anchoPanel;
	    new IpDisenoPanel(tabla,
	                    nombres,
	                    tipos,
						xBotones,
						yBotones,
						anchoBotones,
						xEtiquetas,
						yEtiquetas,
						xCajasTexto,
						yCajasTexto,
						valoresParam);
	  xMensajeError=valoresParam[0];
	  yMensajeError=valoresParam[1];
	  largoPanel=valoresParam[2];
	  anchoPanel= valoresParam[3];
	  if((Ip.existeArchivo("diseno_"+tabla +"_" + formaLlaveDelPanel() + ".txt")))
			{
			boolean respuesta = Ip.wescribePregunta("Ya existe un diseo para esta clase "+formaLlaveDelPanel()+", desea actualizarlo");
	        if(!respuesta)
	 	     {
	 	       return;
	 	     }	
			}
	   guardaDisenoPanel();    				  
	}
	private void LeeDisenoPanel()
	{  String archivo_entrada="diseno_"+ tabla +"_" + formaLlaveDelPanel() + ".txt";
		if(!Ip.existeArchivo(archivo_entrada))
			{
			 Ip.wescribePregunta("No existe archivo de diseo para esta clase "+formaLlaveDelPanel());
	         return;
	 	    }
	   Ip.abreArchEntrada(archivo_entrada);
	   String datoleido=Ip.leeDeArch();
	   numCampos=Ip.aEntero(datoleido);
	   datoleido=Ip.leeDeArch();
	   numBotones=Ip.aEntero(datoleido);
	   for (int i=0;i<numCampos;i++)
	   	{   
	   		xEtiquetas[i]=Ip.aEntero(Ip.leeDeArch());
	   		yEtiquetas[i]=Ip.aEntero(Ip.leeDeArch());
	   		xCajasTexto[i]=Ip.aEntero(Ip.leeDeArch());
	   		yCajasTexto[i]=Ip.aEntero(Ip.leeDeArch());
	   	}
	   	for (int i=0;i<numBotones;i++)
	   	{
	   		xBotones[i]=Ip.aEntero(Ip.leeDeArch());
	   		yBotones[i]=Ip.aEntero(Ip.leeDeArch());
	   		anchoBotones[i]=Ip.aEntero(Ip.leeDeArch());
	   	}
	   	xMensajeError=Ip.aEntero(Ip.leeDeArch());
	   	yMensajeError=Ip.aEntero(Ip.leeDeArch());
	   	largoPanel=Ip.aEntero(Ip.leeDeArch());
	   	anchoPanel=Ip.aEntero(Ip.leeDeArch());
	   	Ip.cierraArchEntrada();		   
	}	
	private String formaLlave()
	{ 
		String Llave = "";
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		Llave = Llave + valoresCampos[i].trim();
		 }
		return Llave; 
	}
	private void Seleccionar_actionPerformed(ActionEvent e)
		
	{   String[] llaveSel= new String[1];
		new IpSelectorDeRegistro(tabla,llaveSel);
		for (int i=0;i<limiteNumCampos;i++)
		 {
		 	if (esCampoLlave[i])
		 		valoresCampos[i] = llaveSel[0];
		 }
		LeeRegistro(llaveSel[0]);
	    VariablesAPanel();
	}
private void GenerarCodigo_actionPerformed(ActionEvent e)
		
	{ 
		GenerarCodigoActUnit();
		GenerarCodigoActTab();   
	}
	
	private void GenerarCodigoActUnit()
	{	String archivo_entrada=tabla +"_" + formaLlaveDelPanel() + ".txt";
	    String archivo_salida_unit=tabla +"_" + formaLlaveDelPanel() + ".java";
	    String archivo_plantilla_ActUnit = "plantilla_ActUnit.txt";
	    String clase;
	    if(Ip.existeArchivo(archivo_salida_unit))
			{
			boolean respuesta = Ip.wescribePregunta("Ya existe un archivo "+archivo_salida_unit+", desea actualizarlo");
	        if(!respuesta)
	 	     {
	 	       return;
	 	     }	
			}
	    //***
	    //*Se cargan los arreglos con los datos almacenados en el registro
	    //***
	    Ip.abreArchEntrada(archivo_entrada);
	    clase= Ip.leeDeArch();
	    numCampos=0;
	    String datoleido=Ip.leeDeArch();
	    while (!datoleido.equals(""))
	    { 
	      nombres[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      esLlave[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tipos[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tablaExi[numCampos]=datoleido;
	      numCampos++;
	      datoleido = Ip.leeDeArch();	
	    }
	    Ip.cierraArchEntrada();
	    //***
	    //*Abre archivos para generar Act Unit
	    //***
	    Ip.abreArchEntrada(archivo_plantilla_ActUnit);
	    Ip.abreArchSalidaNuevo(archivo_salida_unit);
	    CopiaHastaIndicador();
	    //Genera el codigo para el encabezado de la clase
	    Ip.escribeEnArch("public class ActUnit_"+clase+" extends JFrame{");
	    //Genera el codigo para el numero de campos
	    Ip.escribeEnArch("     private int limiteNumCampos ="+numCampos+";");
	    CopiaHastaIndicador();
	    //Genera el codigo para el encabezado del constructor de la clase
	    Ip.escribeEnArch("public ActUnit_"+clase+ "()");
	    CopiaHastaIndicador();
	    //Genera el codigo para inicializar los arreglos
	    GeneraElCodigoParaInicializarArreglosUnit(clase,numCampos,
	             nombres,
	             tipos,
	             esLlave,
	             tablaExi,
	             xBotones,
	             yBotones,
	             anchoBotones,
	             xEtiquetas,
	             yEtiquetas,
	             xCajasTexto,
	             yCajasTexto);
	    CopiaHastaIndicador();
	    //Genera en el main el codigo del new para probar la clase
	    Ip.escribeEnArch("      new ActUnit_"+clase+ "();");
	    CopiaSegundaParteDeLaPlantilla();         
	    //Cierra Archivos
	    Ip.cierraArchSalida();
	    Ip.cierraArchEntrada();
	    Ip.wescribeMensaje("El codigo para el actualizador unitario ha sido generado en el archivo: "+  archivo_salida_unit);
	    
	}
	
	private void GenerarCodigoActTab()
	{	String archivo_entrada=tabla +"_" + formaLlaveDelPanel() + ".txt";
	    String archivo_salida_tab= "ActTab_" + formaLlaveDelPanel() + ".java";
	    String archivo_plantilla_ActTab = "plantilla_ActTab.txt";
	    String clase;
	    if(Ip.existeArchivo(archivo_salida_tab))
			{
			boolean respuesta = Ip.wescribePregunta("Ya existe un archivo "+archivo_salida_tab+", desea actualizarlo");
	        if(!respuesta)
	 	     {
	 	       return;
	 	     }	
			}
	    //***
	    //*Se cargan los arreglos con los datos almacenados en el registro
	    //***
	    Ip.abreArchEntrada(archivo_entrada);
	    clase= Ip.leeDeArch();
	    numCampos=0;
	    String datoleido=Ip.leeDeArch();
	    while (!datoleido.equals(""))
	    { 
	      nombres[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      esLlave[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tipos[numCampos]=datoleido;
	      datoleido = Ip.leeDeArch();
	      tablaExi[numCampos]=datoleido;
	      numCampos++;
	      datoleido = Ip.leeDeArch();	
	    }
	    Ip.cierraArchEntrada();
	    //***
	    //*Abre archivos para generar Act Tab
	    //***
	    Ip.abreArchEntrada(archivo_plantilla_ActTab);
	    Ip.abreArchSalidaNuevo(archivo_salida_tab);
	    CopiaHastaIndicador();
	    //Genera el codigo para el encabezado de la clase
	    Ip.escribeEnArch("public class ActTab_"+clase+" extends JFrame{");
	    //Genera el codigo para el numero de campos
	    Ip.escribeEnArch("     private int limiteNumCampos ="+numCampos+";");
	    CopiaHastaIndicador();
	    //Genera el codigo para el encabezado del constructor de la clase
	    Ip.escribeEnArch("public ActTab_"+clase+ "()");
	    CopiaHastaIndicador();
	    //Genera el codigo para inicializar los arreglos 
	    GeneraElCodigoParaInicializarArreglosTabular(clase,numCampos,
	             nombres,
	             tipos,
	             esLlave,
	             tablaExi);
	    CopiaHastaIndicador();
	    //Genera en el main el codigo del new para probar la clase
	    Ip.escribeEnArch("      new ActTab_"+clase+ "();");
	    CopiaSegundaParteDeLaPlantilla();         
	    //Cierra Archivos
	    Ip.cierraArchSalida();
	    Ip.cierraArchEntrada();
	    Ip.wescribeMensaje("El codigo del actualizador tabular ha sido generado en el archivo: "+archivo_salida_tab);
	    
	}
		private void inicializaArreglosPosiciones(int limiteNumCampos,
		         int[]     xBotones,
	             int[]     yBotones,
				 int[]     anchoBotones,
				 int[]     xEtiquetas,
				 int[]     yEtiquetas,
				 int[]     xCajasTexto,
				 int[]     yCajasTexto
				)
	
	{   int x,y,xc,numBotones, anchoDelBoton;
	    anchoDelBoton=83;
		x=84;
		xc=180;
		//y=40;
		y=15;
		int incrementoY=25;
		int yInicioBotones = y + limiteNumCampos * incrementoY + incrementoY/2;
	  for (int i=0;i<limiteNumCampos;i++)
			{
			 xEtiquetas[i]=x;
			 yEtiquetas[i]=y;
			 xCajasTexto[i]=xc;
			 yCajasTexto[i]=y;
			 y = y + incrementoY;  	
			}
		x=20;
		numBotones=xBotones.length;
		for (int i=0;i<numBotones;i++)
			{
			 xBotones[i]=x;
			 yBotones[i]=yInicioBotones;
			 anchoBotones[i] = anchoDelBoton;
			 if (i==3)
			 	 anchoBotones[i] = 120;
			 x=x+100;
			}
		yMensajeError=yBotones[3]+25;
	    xMensajeError=20;
	    anchoPanel=450;
	    largoPanel=yBotones[numBotones-1] + incrementoY*4;	
	}
	private void CopiaHastaIndicador()
	{	String datoleido=Ip.leeDeArch();
	    while (!datoleido.trim().equals("//***+++"))
	      {Ip.escribeEnArch(datoleido);
	       datoleido=Ip.leeDeArch();
	      }
	    Ip.escribeEnArch(datoleido);
	}
	private void GeneraElCodigoParaInicializarArreglosUnit(String clase,int numCampos,
	             String [] nombresCampos,
	             String [] tiposCampos,
	             String [] esCampoLlave,
	             String [] tablaExistencia,
	             int[]     xBotones,
	             int[]     yBotones,
				 int[]     anchoBotones,
				 int[]     xEtiquetas,
				 int[]     yEtiquetas,
				 int[]     xCajasTexto,
				 int[]     yCajasTexto
				)
	{	
	  //Generar Codigo
	    Ip.escribeEnArch("//*Codigo Generado Automaticamente");
	    Ip.escribeEnArch("//***");
	    Ip.escribeEnArch("     tabla = \"" + clase + "\";");
	    Ip.escribeEnArch("     wIcon = \"logo.gif\";");
	    Ip.escribeEnArch("     //Nombres de los campos");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     nombresCampos[" + i + "]=\""+nombresCampos[i]+"\";");
	    Ip.escribeEnArch("     //Tipos de los campos");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     tiposCampos[" + i + "]=\""+tiposCampos[i]+"\";");
	    Ip.escribeEnArch("     //Indicador de Llave Primaria");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     esCampoLlave[" + i + "]="+esCampoLlave[i]+";");
	    Ip.escribeEnArch("     //Tablas para validacion por existencia");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     tablaExistencia[" + i + "]=\""+tablaExistencia[i]+"\";");
	    int numBotones=xBotones.length;			
	    Ip.escribeEnArch("     //Posicion x de los botones");  
	    for (int i = 0; i<numBotones;i++)
	      Ip.escribeEnArch("     xBotones[" + i + "]="+xBotones[i]+";");
	    Ip.escribeEnArch("     //Posicion y de los botones");  
	    for (int i = 0; i<numBotones;i++)
	      Ip.escribeEnArch("     yBotones[" + i + "]="+yBotones[i]+";");  
	    Ip.escribeEnArch("     //Ancho de cada boton");  
	    for (int i = 0; i<numBotones;i++)
	      Ip.escribeEnArch("     anchoBotones[" + i + "]="+anchoBotones[i]+";");
	    Ip.escribeEnArch("     //Posicion x de las Etiquetas");  
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     xEtiquetas[" + i + "]="+xEtiquetas[i]+";");
	    Ip.escribeEnArch("     //Posicion y de las Etiquetas");  
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     yEtiquetas[" + i + "]="+yEtiquetas[i]+";");          
	    Ip.escribeEnArch("     //Posicion x de las Cajas de Texto");  
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     xCajasTexto[" + i + "]="+xCajasTexto[i]+";");
	    Ip.escribeEnArch("     //Posicion y de las Cajas De Texto");  
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     yCajasTexto[" + i + "]="+yCajasTexto[i]+";");
	    Ip.escribeEnArch("     largoPanel="+largoPanel+";");
	    Ip.escribeEnArch("     anchoPanel="+anchoPanel+";");
	    Ip.escribeEnArch("     xMensajeError="+xMensajeError+";");
	    Ip.escribeEnArch("     yMensajeError="+yMensajeError+";");
	    Ip.escribeEnArch("//***");  
	    Ip.escribeEnArch("//*Aqui Termina el codigo Generado Automaticamente");
	    Ip.escribeEnArch("//***");  	
	}
	private void GeneraElCodigoParaInicializarArreglosTabular(String clase,int numCampos,
	             String [] nombresCampos,
	             String [] tiposCampos,
	             String [] esCampoLlave,
	             String [] tablaExistencia	             
				)
	{	
	  //Generar Codigo
	    Ip.escribeEnArch("//*Codigo Generado Automaticamente");
	    Ip.escribeEnArch("//***");
	    Ip.escribeEnArch("     tabla = \"" + clase + "\";");
	    Ip.escribeEnArch("     wIcon = \"logo.gif\";");
	    Ip.escribeEnArch("     //Nombres de los campos");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     nombresCampos[" + i + "]=\""+nombresCampos[i]+"\";");
	    Ip.escribeEnArch("     //Tipos de los campos");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     tiposCampos[" + i + "]=\""+tiposCampos[i]+"\";");
	    Ip.escribeEnArch("     //Indicador de Llave Primaria");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     esCampoLlave[" + i + "]="+esCampoLlave[i]+";");
	    Ip.escribeEnArch("     //Tablas para validacion por existencia");
	    for (int i = 0; i<numCampos;i++)
	      Ip.escribeEnArch("     tablaExistencia[" + i + "]=\""+tablaExistencia[i]+"\";");
	    Ip.escribeEnArch("//***");  
	    Ip.escribeEnArch("//*Aqui Termina el codigo Generado Automaticamente");
	    Ip.escribeEnArch("//***");  	
	}
	
	private void CopiaSegundaParteDeLaPlantilla()
	{	String datoleido=Ip.leeDeArch();
	    while (!datoleido.equals(""))
	      {Ip.escribeEnArch(datoleido);
	       datoleido=Ip.leeDeArch();
	      }
	}		
	    	    
   private void GuardaRegistro()
	{	String nombre_archivo = tabla +"_" + formaLlave() + ".txt";
	    Ip.abreArchSalidaNuevo(nombre_archivo);
	    for (int i=0;i<limiteNumCampos;i++)
	        Ip.escribeEnArch(valoresCampos[i]);
	    Ip.cierraArchSalida();
	}
	private void LeeRegistro(String id)
	{
		String nombre_archivo = tabla+"_" + id.trim() + ".txt";
	    Ip.abreArchEntrada(nombre_archivo);
	    for (int i=0;i<limiteNumCampos;i++)
	    	valoresCampos[i]= Ip.leeDeArch();
	    Ip.cierraArchEntrada();            	   
	}
	private void PanelAVariables()
	{   
		valoresCampos[0]= cajasTexto[0].getText();
		int k = 1;
		for (int i=1;k<NumRenglones;i=i+4)
			{
		     if (cajasTexto[k].getText().equals(null))
				valoresCampos[i]= "";//Nombre del campo
			else	
			    valoresCampos[i]= cajasTexto[k].getText();//Nombre del campo
			if (cajasCheck[k].isSelected())
				valoresCampos[i+1]="true";
			else
				valoresCampos[i+1]="false";
			valoresCampos[i+2] = (String)comboTipo[k].getSelectedItem();
			valoresCampos[i+3] = (String)comboExi[k].getSelectedItem();
			k=k+1;	
			}
	}	
	 private void VariablesAPanel()
	{   
		int k;
		cajasTexto[0].setText(valoresCampos[0]);
		k=1;
		//Ip.escribeMensaje("Numero Renglones="+NumRenglones+" numCampos="+limiteNumCampos);
		for (int i=1;k<NumRenglones;i=i+4)
			{
			 //Ip.escribeMensaje("i="+i+" k="+k);
			 cajasTexto[k].setText(valoresCampos[i]);//Nombre del campo
			 if (valoresCampos[i+1].equals("true"))
			      cajasCheck[k].setSelected(true);
			 else     	
			      {cajasCheck[k].setSelected(false);
			      }
			comboTipo[k].setSelectedItem(valoresCampos[i+2]);
			comboExi[k].setSelectedItem(valoresCampos[i+3]);
			k= k + 1;				
			}	
	}		
	private int validaTodo()
	{   
	  int numEntero = 0;
	  float numFloat = 0;
	  String string= "";
	  Date fecha= new Date();
	  String datoleido;
	  boolean[] error = new boolean[]{false};
	  String[] mensajeV= new String[]{""};
	  {
	  datoleido = cajasTexto[0].getText();
	  string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);	
	  if (error[0])
		    	{
		    	 return 0;
		    	} 	
	  }	    
	  int j=1;
	  for (int i=1;i<NumRenglones;i++)
	     {
		  datoleido = cajasTexto[j].getText();
		  if (datoleido.equals(""))
		  	 continue;
		  if (tiposCampos[i].equals("S"))
			    {
			     string = Ip.validarDato(string,datoleido,mensajeV,
	                                  error);
			    }
			 if (tiposCampos[j].equals("F"))
			    {
			     numFloat = Ip.validarDato(numFloat,datoleido,mensajeV,
	                                  error);
			    }
			 if (tiposCampos[j].equals("I"))
			    {
			     numEntero = Ip.validarDato(numEntero,datoleido,mensajeV,
	                                  error);
			    }
			 if (tiposCampos[j].equals("D"))
			    {
			     fecha = Ip.validarDato(fecha,datoleido,mensajeV,
	                                  error);
			    }
			mensajeError.setText(mensajeV[0]);
	        existeError[j]=error[0];                
		    if (existeError[j])
		    	{
		    	 return j;
		    	} 
		    //Validar por existencia
		    if(!tablaExistencia[j].equals(""))
		       {
				//nExi=directorios.cargaArregloLLaves
				//	(tablaExistencia[j],
				//	 valoresExi);
				nExi= IpDirectorios.cargaArregloLLaves
				(tablaExistencia[j],
				 valoresExi);
	    		boolean existeExi =false;
				for (int k=0;k<nExi;k++)
					{ if (datoleido.equals(valoresExi[k]))
								{existeExi =true;
								 continue;}
					}
				if (!existeExi)
					{
						return j;
				    }
				}
			j= j + 4;
			}	 
		return -1;
	}
    private static void aparienciaWindows()
	{   
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
	}		 
	public static void main(String[] args)
	{
		aparienciaWindows();
		new IpGenCodAct();
	}
//= End of Testing =
}//Termina la clase IpGenCodAct

/****************************************************************/
/*                      Diseo del panel                        */
/*      Esta clase se utiliza en el generador de codigo         */
/*      IpGenCodAct.java                                        */
/****************************************************************/
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
class IpDisenoPanel extends JDialog
{
	//***
	// Variables declaration
	private String       tabla;
	private String[]     nombresCampos;
	private String[]     tiposCampos;
	private JLabel[]     etiquetas;
	private JLabel[]     cajasTexto;
	private JLabel[]     botones;
	private int[]        xBotones;
	private int[]        yBotones;
	private int[]        anchoBotones;
	private int[]        xEtiquetas;
	private int[]        yEtiquetas;
	private int[]        xCajasTexto;
	private int[]        yCajasTexto;
	private int[]        valoresParam =  new int[4];
	private JLabel mensajeError;
	private int xMensajeError;
	private int yMensajeError;
	private int	anchoEtiqueta = 70;
	private int	altoEtiqueta  = 18;
	private int	altoCajaTexto  = 22;
	private int	anchoCajaTexto = 100;
	private int	anchoDelBoton  =83;
	private int	altoDelBoton   =28;
	private int incrementoY=25;
	private int numCampos =0;
	private int numBotones =0;         
	private JPanel panelContenedor;
	private ImageIcon jImagen1;
	private ImageIcon jImagen2;
	private int x,y;
	private JComponent componenteEnMov;
	private Color colorEnMov;
	boolean hayComponente = false;
	int tipoComponente = 0;
	int numComponente = 0;
	int largoPanel = 0;
	int anchoPanel = 0;
	public IpDisenoPanel(String tab,
	                    String[]     nombresC,
	                    String[]     tiposC,
						int   []     xBot,
						int   []     yBot,
						int   []     anchoBot,
						int   []     xEtiq,
						int   []     yEtiq,
						int   []     xCajas,
						int   []     yCajas,
						int   []     valParam){
		super();
		tabla=tab;
		nombresCampos = nombresC;
		tiposCampos   =   tiposC;
		numCampos =nombresCampos.length;
		etiquetas      =  new JLabel[numCampos];
	    cajasTexto     =  new JLabel[numCampos];
	    xBotones        =  xBot;
	    yBotones        =  yBot;
	    numBotones = xBotones.length; 
	    botones        =  new JLabel[numBotones];
	    anchoBotones    =  anchoBot;
	    xEtiquetas      =  xEtiq;
	    yEtiquetas      =  yEtiq;
	    xCajasTexto     =  xCajas;
	    yCajasTexto     =  yCajas;
	    valoresParam =valParam;
	    xMensajeError=valoresParam[0];
	    yMensajeError=valoresParam[1];
	    largoPanel=valoresParam[2];
	    anchoPanel= valoresParam[3];
		//inicializaPosicionesDefault();	
		
		initializeComponent();
		this.setModal(true);
		this.setVisible(true);
	}
	private void initializeComponent(){
		inicializaComponentes();
		panelContenedor.setLayout(null);
		panelContenedor.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e)
			{
				panelContenedor_mouseClicked(e);
			}

		});
		panelContenedor.addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e)
			{
				panelContenedor_mouseDragged(e);
			}

		});
		int i;
			
		for (i=0;i<numCampos;i++)
		 {
		  addComponent(panelContenedor, etiquetas[i] , xEtiquetas[i],yEtiquetas[i],anchoEtiqueta,altoEtiqueta);
		  addComponent(panelContenedor, cajasTexto[i] ,xCajasTexto[i],yCajasTexto[i],asignaAncho(i),altoCajaTexto);
		 }
		 for (i=0;i<numBotones;i++)
		 {
		  addComponent(panelContenedor, botones[i] ,xBotones[i],yBotones[i],anchoBotones[i],altoDelBoton);
		 }
			//---Mensaje de Error ---
		addComponent(panelContenedor, mensajeError, xMensajeError,yMensajeError,400,22);
		this.setTitle("Diseo del Panel para actualizar la tabla "+ tabla);
		this.setSize(new Dimension(anchoPanel,largoPanel));
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setResizable(true);
	}

    private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}
	private int asignaAncho(int i) {
	int anchoCajaTexto = 100;
		  if (tiposCampos[i].equals("I"))
			 anchoCajaTexto = 40;
		  if (tiposCampos[i].equals("F"))
		 	 anchoCajaTexto = 60;
		  if (tiposCampos[i].equals("D"))
		 	 anchoCajaTexto = 80;
	      return anchoCajaTexto; 	 	 	 	
	}
	private void inicializaComponentes()
	{  for (int i=0;i<numCampos;i++)
			{
			 etiquetas[i]= new JLabel();
			 etiquetas[i].setText(nombresCampos[i]);
			 etiquetas[i].setBorder(BorderFactory.createLineBorder(Color.BLACK));
			 etiquetas[i].setOpaque(true);
			 cajasTexto[i]= new JLabel();
			 cajasTexto[i].setText(nombresCampos[i]);
			 cajasTexto[i].setBorder(BorderFactory.createLineBorder(Color.BLACK));
			 cajasTexto[i].setBackground(Color.white);
			 cajasTexto[i].setOpaque(true);
			 }
		//Inicializa Botones
		botones[0]     = new JLabel();
		botones[0].setText("Guardar");
		botones[0].setBorder(BorderFactory.createLineBorder(Color.BLACK));
		botones[0].setBackground(Color.GRAY);
		botones[0].setOpaque(true);
		botones[1]      = new JLabel();
		botones[1].setText("Leer");
		botones[1].setBorder(BorderFactory.createLineBorder(Color.BLACK));
		botones[1].setBackground(Color.GRAY);
		botones[1].setOpaque(true);
		botones[2]      = new JLabel();
		botones[2].setText("Borrar");
		botones[2].setBorder(BorderFactory.createLineBorder(Color.BLACK));
		botones[2].setBackground(Color.GRAY);
		botones[2].setOpaque(true);
		botones[3]      = new JLabel();
		botones[3].setText("Seleccionar");
		botones[3].setBorder(BorderFactory.createLineBorder(Color.BLACK));
		botones[3].setBackground(Color.GRAY);
		botones[3].setOpaque(true);
		//Inicializa otros componentes
		mensajeError = new JLabel();
		mensajeError.setText("Mensaje De Error.............................");
		mensajeError.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		mensajeError.setOpaque(true);
		panelContenedor = (JPanel)this.getContentPane();
	}
		private void inicializaPosicionesDefault()
	
	{   int x,y,xc,numBotones, anchoDelBoton;
	    anchoDelBoton=83;
		x=84;
		xc=180;
		//y=40;
		y=15;
		int incrementoY=25;
		int yInicioBotones = y + numCampos * incrementoY + incrementoY/2;
	  for (int i=0;i<numCampos;i++)
			{
			 xEtiquetas[i]=x;
			 yEtiquetas[i]=y;
			 xCajasTexto[i]=xc;
			 yCajasTexto[i]=y;
			 y = y + incrementoY;  	
			}
		x=20;
		numBotones=xBotones.length;
		for (int i=0;i<numBotones;i++)
			{
			 xBotones[i]=x;
			 yBotones[i]=yInicioBotones;
			 anchoBotones[i] = anchoDelBoton;
			 if (i==3)
			 	 anchoBotones[i] = 120;
			 x=x+100;
			}
			xMensajeError=20;
			yMensajeError=yBotones[numBotones-1]+incrementoY;
			valoresParam[0]=xMensajeError;
	        valoresParam[1]=yMensajeError;
			
				
	}
	private void panelContenedor_mouseClicked(MouseEvent e)
	{
	 Rectangle rectVentana = new Rectangle();
     this.getBounds(rectVentana);
     anchoPanel = this.getWidth();
     largoPanel = this.getHeight();
     valoresParam[0]=xMensajeError;
	 valoresParam[1]=yMensajeError;
     valoresParam[2]=largoPanel;
	 valoresParam[3]=anchoPanel;
	  //restaurar la imagen, clic derecho ultimo paso del arrastre
     if (e.getButton()== 3)
         {
         hayComponente = false;
         componenteEnMov.setBackground(colorEnMov);
         //ES.wescribeMensaje("Fija y libera el componente ");
         return;}		
     //procesar el clic izquierdo e.getButton()== 1
     //primera parte del proceso de arrastre
	 if(hayComponente)
	 	return;
	 x=e.getX();
	 y=e.getY();
	 hayComponente = false;
	 //ES.wescribeMensaje("Proceso de Seleccion del componente ");
	 int i;
	 //Revisa si el componente seleccionado es una Etiqueta
	 for (i=0;i<numCampos;i++)
			{
			 if (componenteSeleccionado(etiquetas[i]))
			 	{	//ES.wescribeMensaje("Componente seleccionado Etiqueta: " + etiquetas[i].getText() );
			 		tipoComponente= 1;
			 		numComponente = i;
			  		return;
			 	}
			}
	//Revisa si el componente seleccionado es una CajaDeTexto
	 for (i=0;i<numCampos;i++)
			{
			 if (componenteSeleccionado(cajasTexto[i]))
			 	{	//ES.wescribeMensaje("Componente seleccionado cajaDeTexto: " + cajasTexto[i].getText() );
			 	    tipoComponente= 2;
			 	    numComponente = i;
			  		return;
			 	}
			}
	//Revisa si el componente seleccionado es un boton
	 for (i=0;i<numBotones;i++)
			{
			 if (componenteSeleccionado(botones[i]))
			 	{	//ES.wescribeMensaje("Componente seleccionado Boton: " + botones[i].getText() );
			 	    tipoComponente= 3;
			 	    numComponente = i;
			  		return;
			 	}
			} 
	 //Revisa si el componente seleccionado es el mensaje de error
	 if (componenteSeleccionado(mensajeError))
			 	{	//ES.wescribeMensaje("Componente seleccionado Mensaje de error " );
			 	    tipoComponente= 4;
			 	    return;
			 	} 
	
	 	return;
	 }
   private boolean componenteSeleccionado(JComponent jComponent){
    	Rectangle rv= new Rectangle();
    	jComponent.getBounds(rv);
       	if (((x >= rv.getX()) 
	 	     && (x <= rv.getX()+rv.getWidth() ))
	 	     && ((y >= rv.getY()) 
	 	     && (y <= rv.getY()+rv.getHeight ())))
	 	    {//Selecciono la imagen
	 	     componenteEnMov = jComponent;
	 	     hayComponente = true;
	 	     colorEnMov = (Color)componenteEnMov.getBackground();
	 	     componenteEnMov.setBackground(Color.cyan);
	 	     return true;}
	 	return false; 
    	}

	private void panelContenedor_mouseDragged(MouseEvent e)
	{
     x=e.getX();
	 y=e.getY();
	 if (!hayComponente)
	 	return;
	 Rectangle rv= new Rectangle();
     componenteEnMov.getBounds(rv); 	
     //componenteEnMov.setBounds
     //	(x - (int)rv.getWidth()/2,y-(int)rv.getHeight()/2,
     //   (int)rv.getWidth(),(int)rv.getHeight());
     int i = numComponente;   
     if (tipoComponente==1)
        { 
             //xEtiquetas[i]=componenteEnMov.getX();
			 //yEtiquetas[i]=componenteEnMov.getY();
			 xEtiquetas[i]=x;
			 yEtiquetas[i]=y;
			 componenteEnMov.setBounds(x ,y,(int)rv.getWidth(),(int)rv.getHeight());
			 return;	
        }
     if (tipoComponente==2)
        { 
             //xCajasTexto[i]=componenteEnMov.getX();
			 //yCajasTexto[i]=componenteEnMov.getY();
			 xCajasTexto[i]=x;
			 yCajasTexto[i]=y;
			 componenteEnMov.setBounds(x ,y,(int)rv.getWidth(),(int)rv.getHeight());
			 return;	
        }
     if (tipoComponente==3)
        { 
             //xBotones[i]=componenteEnMov.getX();
			 //yBotones[i]=componenteEnMov.getY();
			 xBotones[i]=x;
			 yBotones[i]=y;
			 componenteEnMov.setBounds(x ,y,(int)rv.getWidth(),(int)rv.getHeight());
			 return;	
        }
     if (tipoComponente==4)
        { 
             //xMensajeError=componenteEnMov.getX();
			 //yMensajeError=componenteEnMov.getY();
			 xMensajeError=x;
			 yMensajeError=y;
			 componenteEnMov.setBounds(x ,y,(int)rv.getWidth(),(int)rv.getHeight());
			 return;	
        } 
    
  	}
  	private static void aparienciaWindows()
	{   
		JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}
	}		 
	public static void main(String[] args)
	{
	aparienciaWindows();
	int limiteNumCampos =13;
    int numBotones      =4;
	//nombre de la tabla 
	String tabla ="Pacientes";
	//***
	// Variables declaration
	String[]     nombresCampos =   new String[limiteNumCampos];
	String[]     tiposCampos   =   new String[limiteNumCampos];
	int[]        xBotones        =  new int[numBotones];
	int[]        yBotones        =  new int[numBotones];
	int[]        anchoBotones    =  new int[numBotones];
	int[]        xEtiquetas      =  new int[limiteNumCampos];
	int[]        yEtiquetas      =  new int[limiteNumCampos];
	int[]        xCajasTexto     =  new int[limiteNumCampos];
	int[]        yCajasTexto     =  new int[limiteNumCampos];
	int[]        valoresParam    =  new int[4];
	int  xMensajeError = 0;
	int  yMensajeError = 0;
	int  largoPanel = 0;
	int  anchoPanel = 0;
	int incrementoY=25;
	//Nombres de los campos
     nombresCampos[0]="id";
     nombresCampos[1]="Nombre";
     nombresCampos[2]="Ap. Paterno";
     nombresCampos[3]="Ap. Materno";
     nombresCampos[4]="Medico";
     nombresCampos[5]="Tel.";
     nombresCampos[6]="Cel.";
     nombresCampos[7]="Fecha Nac.";
     nombresCampos[8]="Calle y Num.";
     nombresCampos[9]="Col.";
     nombresCampos[10]="Mpo.";
     nombresCampos[11]="CP";
     nombresCampos[12]="Estado Civil";
      //Tipos de los campos
     tiposCampos[0]="S";
     tiposCampos[1]="S";
     tiposCampos[2]="S";
     tiposCampos[3]="S";
     tiposCampos[4]="S";
     tiposCampos[5]="S";
     tiposCampos[6]="S";
     tiposCampos[7]="D";
     tiposCampos[8]="S";
     tiposCampos[9]="S";
     tiposCampos[10]="S";
     tiposCampos[11]="S";
     tiposCampos[12]="S";
     //Posicion x de los botones
     xBotones[0]=20;
     xBotones[1]=120;
     xBotones[2]=220;
     xBotones[3]=320;
     //Posicion y de los botones
     yBotones[0]=352;
     yBotones[1]=352;
     yBotones[2]=352;
     yBotones[3]=352;
     //Ancho de cada boton
     anchoBotones[0]=83;
     anchoBotones[1]=83;
     anchoBotones[2]=83;
     anchoBotones[3]=120;
     //Posicion x de las Etiquetas
     xEtiquetas[0]=84;
     xEtiquetas[1]=84;
     xEtiquetas[2]=84;
     xEtiquetas[3]=84;
     xEtiquetas[4]=84;
     xEtiquetas[5]=84;
     xEtiquetas[6]=84;
     xEtiquetas[7]=84;
     xEtiquetas[8]=84;
     xEtiquetas[9]=84;
     xEtiquetas[10]=84;
     xEtiquetas[11]=84;
     xEtiquetas[12]=84;
     //Posicion y de las Etiquetas
     yEtiquetas[0]=15;
     yEtiquetas[1]=40;
     yEtiquetas[2]=65;
     yEtiquetas[3]=90;
     yEtiquetas[4]=115;
     yEtiquetas[5]=140;
     yEtiquetas[6]=165;
     yEtiquetas[7]=190;
     yEtiquetas[8]=215;
     yEtiquetas[9]=240;
     yEtiquetas[10]=265;
     yEtiquetas[11]=290;
     yEtiquetas[12]=315;
     //Posicion x de las Cajas de Texto
     xCajasTexto[0]=180;
     xCajasTexto[1]=180;
     xCajasTexto[2]=180;
     xCajasTexto[3]=180;
     xCajasTexto[4]=180;
     xCajasTexto[5]=180;
     xCajasTexto[6]=180;
     xCajasTexto[7]=180;
     xCajasTexto[8]=180;
     xCajasTexto[9]=180;
     xCajasTexto[10]=180;
     xCajasTexto[11]=180;
     xCajasTexto[12]=180;
     //Posicion y de las Cajas De Texto
     yCajasTexto[0]=15;
     yCajasTexto[1]=40;
     yCajasTexto[2]=65;
     yCajasTexto[3]=90;
     yCajasTexto[4]=115;
     yCajasTexto[5]=140;
     yCajasTexto[6]=165;
     yCajasTexto[7]=190;
     yCajasTexto[8]=215;
     yCajasTexto[9]=240;
     yCajasTexto[10]=265;
     yCajasTexto[11]=290;
     yCajasTexto[12]=315;
     xMensajeError=20;
	 yMensajeError=yBotones[3]+25;
	 anchoPanel=450;
	 largoPanel=yBotones[numBotones-1] + incrementoY*4;
	 valoresParam[0]=xMensajeError;
	 valoresParam[1]=yMensajeError;
	 valoresParam[2]=largoPanel;
	 valoresParam[3]=anchoPanel;
	 Ip.wmuestraArreglo(valoresParam);
	 new IpDisenoPanel(tabla,
	                    nombresCampos,
	                    tiposCampos,
						xBotones,
						yBotones,
						anchoBotones,
						xEtiquetas,
						yEtiquetas,
						xCajasTexto,
						yCajasTexto,
						valoresParam
						);
	 xMensajeError=valoresParam[0];
	 yMensajeError=valoresParam[1];
	 largoPanel=valoresParam[2];
	 anchoPanel= valoresParam[3];
	 Ip.wmuestraArreglo(valoresParam);					
	}
//Termina el main
}//Termina la clase IpDisenoPanel





